-- my custom locale file - more streamlined than AceLocale and no lib dependency

-- To help with missing translations please go here:
local url = "http://wow.curseforge.com/addons/arh/localization/"

local addonName, vars = ...
local Ld, La = {}, {}
local locale = GAME_LOCALE or GetLocale()
if locale == "enGB" then locale = "enUS" end

vars.L = setmetatable({},{
    __index = function(t, s) 
      if locale ~= "enUS" and Ld[s] and
         not La[s] and url and not vars.locale_warning then
        vars.locale_warning = true
        print(string.format("*** %s needs help translating to your language! (%s)", addonName, locale))
	print("*** If you speak English, you can contribute by visiting:")
	print("*** "..url)
      end
      return La[s] or Ld[s] or rawget(t,s) or s 
    end
})

Ld["add new %s zone to the HUD"] = "add new %s zone to the HUD"
Ld["Add %s area to the HUD"] = "Add %s area to the HUD"
Ld["Alpha"] = "Alpha"
Ld["Annulus Sectors Settings"] = "Annulus Sectors Settings"
Ld["Archaeology Helper"] = "Archaeology Helper"
Ld["Arch nodes only"] = "Arch nodes only"
Ld["Arrow Alpha"] = "Arrow Alpha"
Ld["Arrow Scaling"] = "Arrow Scaling"
Ld["Audio Settings"] = "Audio Settings"
Ld["Automatically mount when adding this color to the HUD"] = "Automatically mount when adding this color to the HUD"
Ld["cast Survey"] = "cast Survey"
Ld["Cast Survey"] = "Cast Survey"
Ld["clear HUD"] = "clear HUD"
Ld["Color of Compass Direction Marks (you can also set alpha here)"] = "Color of Compass Direction Marks (you can also set alpha here)"
Ld["Color of the Compass Circle (you can also set alpha here)"] = "Color of the Compass Circle (you can also set alpha here)"
Ld["Color of the Success Circle (you can also set alpha here)"] = "Color of the Success Circle (you can also set alpha here)"
Ld["Compass Circle Color"] = "Compass Circle Color"
Ld["Compass Settings"] = "Compass Settings"
Ld["Dig Sites"] = "Dig Sites"
Ld["Direction Marks Color"] = "Direction Marks Color"
Ld["Display minimap icon"] = "Display minimap icon"
Ld["Draw arrow in the center of the HUD"] = "Draw arrow in the center of the HUD"
Ld["Draw compass-like circle on the HUD"] = "Draw compass-like circle on the HUD"
Ld["General HUD Settings"] = "General HUD Settings"
Ld["green"] = "green"
Ld["Green"] = "Green"
Ld["Hide on combat"] = "Hide on combat"
Ld["Hide when resting"] = "Hide when resting"
Ld["Horizontal position of HUD relative to screen center"] = "Horizontal position of HUD relative to screen center"
Ld["How transparent is HUD"] = "How transparent is HUD"
Ld["How transparent is Player Arrow"] = "How transparent is Player Arrow"
Ld["How transparent is %s Annulus Sector"] = "How transparent is %s Annulus Sector"
Ld["How transparent is %s Direction Line"] = "How transparent is %s Direction Line"
Ld["How transparent is window"] = "How transparent is window"
Ld["HUD"] = "HUD"
Ld["HUD Alpha"] = "HUD Alpha"
Ld["HUD Scaling"] = "HUD Scaling"
Ld["HUD settings"] = "HUD settings"
Ld["HUD X-Offset"] = "HUD X-Offset"
Ld["HUD Y-Offset"] = "HUD Y-Offset"
Ld["Key Bindings Settings"] = "Key Bindings Settings"
Ld["Left Click"] = "Left Click"
Ld["Locked"] = "Locked"
Ld["Locks window to prevent accidental repositioning"] = "Locks window to prevent accidental repositioning"
Ld["Main Window"] = "Main Window"
Ld["Main window settings"] = "Main window settings"
Ld["Middle Click"] = "Middle Click"
Ld["Minimap Icon"] = "Minimap Icon"
Ld["Misc Settings"] = "Misc Settings"
Ld["Mount %s"] = "Mount %s"
Ld["move window"] = "move window"
Ld["Only show Archaeology nodes from GatherMate2 on the HUD"] = "Only show Archaeology nodes from GatherMate2 on the HUD"
Ld["Open archaeology window"] = "Open archaeology window"
Ld["Play confirmation sounds for various actions"] = "Play confirmation sounds for various actions"
Ld["Play Sounds"] = "Play Sounds"
Ld["Radius of the compass circle"] = "Radius of the compass circle"
Ld["Radius (yards)"] = "Radius (yards)"
Ld["red"] = "red"
Ld["Red"] = "Red"
Ld["Redirect GatherMate2 output to the HUD when visible"] = "Redirect GatherMate2 output to the HUD when visible"
Ld["remove one previously added area"] = "remove one previously added area"
Ld["Remove one previously added area"] = "Remove one previously added area"
Ld["Reset All Settings"] = "Reset All Settings"
Ld["Reset Position"] = "Reset Position"
Ld["Resets all settings to defaults"] = "Resets all settings to defaults"
Ld["Resets window position to the center of the screen"] = "Resets window position to the center of the screen"
Ld["Right Click"] = "Right Click"
Ld["Scale main window Tooltips"] = "Scale main window Tooltips"
Ld["Scaling"] = "Scaling"
Ld["Show compass"] = "Show compass"
Ld["Show digsites on the Battlefield Minimap"] = "Show digsites on the Battlefield Minimap"
Ld["Show digsites on the Minimap"] = "Show digsites on the Minimap"
Ld["Show GatherMate2 pins on the HUD (recomended)"] = "Show GatherMate2 pins on the HUD (recomended)"
Ld["Show/Hide all %s areas"] = "Show/Hide all %s areas"
Ld["show/hide all %s areas on the HUD"] = "show/hide all %s areas on the HUD"
Ld["Show/Hide Config"] = "Show/Hide Config"
Ld["show/hide digsites on minimap"] = "show/hide digsites on minimap"
Ld["Show/Hide the HUD"] = "Show/Hide the HUD"
Ld["Show/Hide the Main Window"] = "Show/Hide the Main Window"
Ld["Show/Hide window when entering/leaving a digsite"] = "Show/Hide window when entering/leaving a digsite"
Ld["Show/Hide window when you show/hide Archy addon"] = "Show/Hide window when you show/hide Archy addon"
Ld["Show Player Arrow"] = "Show Player Arrow"
Ld["Show Success Circle"] = "Show Success Circle"
Ld["Show Tooltips"] = "Show Tooltips"
Ld["Show Tooltips in the main window"] = "Show Tooltips in the main window"
Ld[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=]
Ld["Size of the main window"] = "Size of the main window"
Ld["Size of the Player Arrow"] = "Size of the Player Arrow"
Ld["%s Line Alpha"] = "%s Line Alpha"
Ld["%s Sector Alpha"] = "%s Sector Alpha"
Ld["Success Circle Color"] = "Success Circle Color"
Ld["Survey will succeed if fragment lies within this circle"] = "Survey will succeed if fragment lies within this circle"
Ld["This will overwrite current settings!"] = "This will overwrite current settings!"
Ld["This will reset Main Window position"] = "This will reset Main Window position"
Ld["Toggle with Archy"] = "Toggle with Archy"
Ld["Toggle with digsite"] = "Toggle with digsite"
Ld["Tooltips Scaling"] = "Tooltips Scaling"
Ld["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"
Ld["Vertical position of HUD relative to screen center"] = "Vertical position of HUD relative to screen center"
Ld["Visible"] = "Visible"
Ld["Visual Settings"] = "Visual Settings"
Ld["Whether window is visible"] = "Whether window is visible"
Ld["yellow"] = "yellow"
Ld["Yellow"] = "Yellow"
Ld["You can also use %s command for this action"] = "You can also use %s command for this action"


if locale == "frFR" then do end
La["add new %s zone to the HUD"] = "Ajouter une zone %s à l'ATH"
La["Add %s area to the HUD"] = "Ajouter une zone %s à l'ATH"
La["Alpha"] = "Opacité"
La["Annulus Sectors Settings"] = "Réglages des zones"
La["Archaeology Helper"] = "Archaeology Helper"
La["Arch nodes only"] = "Nœuds d'archéologie seulement"
La["Arrow Alpha"] = "Opacité de la flèche"
La["Arrow Scaling"] = "Echelle de la flèche"
La["Audio Settings"] = "Réglages Audio"
La["Automatically mount when adding this color to the HUD"] = "Se mettre automatiquement en selle lorsque cette couleur est ajouté à l'ATH."
La["cast Survey"] = "Levé"
La["Cast Survey"] = "Levé"
La["clear HUD"] = "Nettoyer l'ATH" -- Needs review
La["Color of Compass Direction Marks (you can also set alpha here)"] = "Réglez la couleur des points cardinaux de la boussole (réglez aussi l'opacité ici)."
La["Color of the Compass Circle (you can also set alpha here)"] = "Réglez la couleur du cercle de la boussole (réglez aussi l'opacité ici)."
La["Color of the Success Circle (you can also set alpha here)"] = "Réglez la couleur du cercle de portée (réglez aussi l'opacité ici)."
La["Compass Circle Color"] = "Cercle de la boussole"
La["Compass Settings"] = "Réglages de la boussole"
La["Dig Sites"] = "Sites de fouilles"
La["Direction Marks Color"] = "Points cardinaux"
La["Display minimap icon"] = "Affiche l'icône sur la mini-carte."
La["Draw arrow in the center of the HUD"] = "Affiche une flèche au centre de l'ATH."
La["Draw compass-like circle on the HUD"] = "Affiche un cercle type boussole sur l'ATH."
La["General HUD Settings"] = "Réglages généraux de l'ATH"
La["green"] = "verte" -- Needs review
La["Green"] = "verte" -- Needs review
La["Hide on combat"] = "Cacher en combat"
La["Hide when resting"] = "Cacher au repos"
La["Horizontal position of HUD relative to screen center"] = "Réglez la position horizontale de l'ATH par rapport au centre de l'écran."
La["How transparent is HUD"] = "Réglez la transparence de l'ATH."
La["How transparent is Player Arrow"] = "Réglez la transparence de la flèche du joueur."
La["How transparent is %s Annulus Sector"] = "Réglez la transparence des zones %ss."
La["How transparent is %s Direction Line"] = "Réglez la transparence des lignes de direction %ss."
La["How transparent is window"] = "Réglez la transparence de la fenêtre."
La["HUD"] = "ATH"
La["HUD Alpha"] = "Opacité ATH"
La["HUD Scaling"] = "Echelle ATH"
La["HUD settings"] = "Réglages de l'ATH"
La["HUD X-Offset"] = "Décalage X de l'ATH"
La["HUD Y-Offset"] = "Décalage Y de l'ATH"
La["Key Bindings Settings"] = "Réglages des raccourcis clavier"
La["Left Click"] = "Clic gauche"
La["Locked"] = "Verrouillé"
La["Locks window to prevent accidental repositioning"] = "Verrouille la fenêtre pour empêcher de la déplacer accidentellement."
La["Main Window"] = "Fenêtre principale"
La["Main window settings"] = "Réglages de la fenêtre principale"
La["Middle Click"] = "Clic milieu"
La["Minimap Icon"] = "Icône mini-carte"
La["Misc Settings"] = "Réglages divers"
La["Mount %s"] = "Mount %s" -- Needs review
La["move window"] = "Déplacer la fenêtre"
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "Ne montrer que les nœuds d'archéologie de GatherMate2 sur l'ATH."
La["Open archaeology window"] = "Ouvrir la fenêtre d'archéologie"
La["Play confirmation sounds for various actions"] = "Joue un son de confirmation pour diverses actions."
La["Play Sounds"] = "Jouer des sons"
La["Radius of the compass circle"] = "Rayon du cercle de la boussole"
La["Radius (yards)"] = "Rayon (yards)"
La["red"] = "rouge" -- Needs review
La["Red"] = "rouge" -- Needs review
La["Redirect GatherMate2 output to the HUD when visible"] = "Redirige les points de GatherMate2 vers l'ATH quand il est visible."
La["remove one previously added area"] = "Enlever la dernière zone ajoutée"
La["Remove one previously added area"] = "Retirer la dernière zone ajoutée" -- Needs review
La["Reset All Settings"] = "Réinitialiser tous les réglages" -- Needs review
La["Reset Position"] = "Réinitialiser la position" -- Needs review
La["Resets all settings to defaults"] = "Réinitialise tous les réglages aux paramètres par défaut."
La["Resets window position to the center of the screen"] = "Réinitialise la position de la fenêtre au centre de l'écran."
La["Right Click"] = "Clic droit"
La["Scale main window Tooltips"] = "Réglez l'échelle des infobulles de la fenêtre principale."
La["Scaling"] = "Echelle"
La["Show compass"] = "Boussole"
La["Show digsites on the Battlefield Minimap"] = "Afficher les sites de fouille sur la carte locale"
La["Show digsites on the Minimap"] = "Afficher les sites de fouille sur la mini-carte"
La["Show GatherMate2 pins on the HUD (recomended)"] = "Points GatherMate2 dans l'ATH (recommandé)"
La["Show/Hide all %s areas"] = "Afficher/Cacher les zones %ss" -- Needs review
La["show/hide all %s areas on the HUD"] = "Afficher/Cacher les zones %ss sur l'ATH"
La["Show/Hide Config"] = "Afficher/Cacher la configuration"
La["show/hide digsites on minimap"] = "Afficher/Cacher les sites de fouille sur la mini-carte" -- Needs review
La["Show/Hide the HUD"] = "Afficher/Cacher l'ATH" -- Needs review
La["Show/Hide the Main Window"] = "Afficher/Cacher la fenêtre principale"
La["Show/Hide window when entering/leaving a digsite"] = "Affiche/Cache la fenêtre en entrant/sortant d'un site de fouilles."
La["Show/Hide window when you show/hide Archy addon"] = "Afficher/Cacher la fenêtre quand vous affichez/cachez l'addon Archy"
La["Show Player Arrow"] = "Flèche du joueur"
La["Show Success Circle"] = "Cercle de portée"
La["Show Tooltips"] = "Infobulles"
La["Show Tooltips in the main window"] = "Affiche les infobulles dans la fenêtre principale."
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[Réglez la taille de l'ATH.
Pour faire un zoom, utilisez celui de la mini-carte.]=]
La["Size of the main window"] = "Réglez la taille de la fenêtre principale."
La["Size of the Player Arrow"] = "Réglez la taille de la flèche du joueur."
La["%s Line Alpha"] = "Opacité ligne %s"
La["%s Sector Alpha"] = "Opacité zone %s"
La["Success Circle Color"] = "Réglez la couleur du cercle de portée."
La["Survey will succeed if fragment lies within this circle"] = "Levé trouvera les fragments dans ce cercle." -- Needs review
La["This will overwrite current settings!"] = "Cela écrasera les réglages actuels !"
La["This will reset Main Window position"] = "Cela réinitialisera la position de la fenêtre principale."
La["Toggle with Archy"] = "Activer avec Archy" -- Needs review
La["Toggle with digsite"] = "Afficher sur place"
La["Tooltips Scaling"] = "Echelle de l'infobulle"
La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "Utilisez |cff69ccf0Maj-M|r pour ouvrir ou cacher la carte locale."
La["Vertical position of HUD relative to screen center"] = "Réglez la position verticale de l'ATH par rapport au centre de l'écran."
La["Visible"] = "Visible"
La["Visual Settings"] = "Réglages visuels"
La["Whether window is visible"] = "Réglez la visibilité de la fenêtre."
La["yellow"] = "jaune" -- Needs review
La["Yellow"] = "jaune" -- Needs review
La["You can also use %s command for this action"] = "Vous pouvez aussi utiliser la commande %s pour cette action."

elseif locale == "deDE" then do end
La["add new %s zone to the HUD"] = "neue %s Zone zum HUD hinzufügen"
La["Add %s area to the HUD"] = "%s-Bereich zum HUD hinzufügen"
La["Alpha"] = "Transparenz"
La["Annulus Sectors Settings"] = "Kreisring-Sektor-Einstellungen"
La["Archaeology Helper"] = "Archaeology Helper"
La["Arch nodes only"] = "Nur Arch.-Fundstellen"
La["Arrow Alpha"] = "Transparenz des Pfeils"
La["Arrow Scaling"] = "Größe des Pfeils"
La["Audio Settings"] = "Audio-Einstellungen"
La["Automatically mount when adding this color to the HUD"] = "Automatisch aufsitzen, wenn diese Farbe im HUD gesetzt wird."
La["cast Survey"] = "Untersuchen"
La["Cast Survey"] = "Untersuchen"
La["clear HUD"] = "HUD bereinigen"
La["Color of Compass Direction Marks (you can also set alpha here)"] = "Farbe der Kompassrichtungsmarker (Transparenz kann hier auch eingestellt werden)"
La["Color of the Compass Circle (you can also set alpha here)"] = "Farbe des Kompasskreises (Transparenz kann hier auch eingestellt werden)"
La["Color of the Success Circle (you can also set alpha here)"] = "Farbe des Erfolgskreises (Transparenz kann hier auch eingestellt werden)"
La["Compass Circle Color"] = "Kompasskreisfarbe"
La["Compass Settings"] = "Kompasseinstellungen"
La["Dig Sites"] = "Ausgrabungsstätten"
La["Direction Marks Color"] = "Farbe der Richtungsmarker"
La["Display minimap icon"] = "Minikartensymbol anzeigen"
La["Draw arrow in the center of the HUD"] = "Pfeil in der Mitte vom HUD anzeigen"
La["Draw compass-like circle on the HUD"] = "Kompasskreis auf HUD anzeigen"
La["General HUD Settings"] = "Allgemeine HUD Einstellungen"
La["green"] = "Grün"
La["Green"] = "Grün"
La["Hide on combat"] = "Im Kampf verstecken"
La["Hide when resting"] = "In Ruhezonen verstecken"
La["Horizontal position of HUD relative to screen center"] = "Horizontale Position des HUDs relativ zur Bildschirmmitte"
La["How transparent is HUD"] = "Wie transparent ist das HUD"
La["How transparent is Player Arrow"] = "Wie transparent ist der Spielerpfeil"
La["How transparent is %s Annulus Sector"] = "Wie transparent ist der %s-Kreisring-Sektor"
La["How transparent is %s Direction Line"] = "Wie transparent ist %s Richtungslinie"
La["How transparent is window"] = "Wie transparent ist das Fenster"
La["HUD"] = "HUD"
La["HUD Alpha"] = "HUD Transparenz"
La["HUD Scaling"] = "HUD Skalierung"
La["HUD settings"] = "HUD Einstellungen"
La["HUD X-Offset"] = "HUD X-Versatz"
La["HUD Y-Offset"] = "HUD Y-Versatz"
La["Key Bindings Settings"] = "Tastaturbelegungseinstellungen"
La["Left Click"] = "Links-Klick"
La["Locked"] = "Gesperrt"
La["Locks window to prevent accidental repositioning"] = "Fenster sperren, um versehentliches Verschieben zu vermeiden"
La["Main Window"] = "Hauptfenster"
La["Main window settings"] = "Hauptfenstereinstellungen"
La["Middle Click"] = "Mittel-Klick"
La["Minimap Icon"] = "Minikartensymbol"
La["Misc Settings"] = "Sonstige Einstellungen"
La["Mount %s"] = "Aufsitzen bei %s"
La["move window"] = "Fenster bewegen"
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "Nur Archäologie-Fundstellen von Gathermate2 am HUD anzeigen"
La["Open archaeology window"] = "Archäologiefenster öffnen"
La["Play confirmation sounds for various actions"] = "Bestätigungssounds abspielen für verschiedene Aktionen"
La["Play Sounds"] = "Sounds abspielen"
La["Radius of the compass circle"] = "Radius des Kompasskreises"
La["Radius (yards)"] = "Radius (yards)"
La["red"] = "Rot"
La["Red"] = "Rot"
La["Redirect GatherMate2 output to the HUD when visible"] = "GatherMate2-Ausgabe an HUD weiterleiten, wenn es sichtbar ist"
La["remove one previously added area"] = "einen vorher hinzugefügten Bereich entfernen"
La["Remove one previously added area"] = "Ein vorher hinzugefügten Bereich entfernen"
La["Reset All Settings"] = "Alle Einstellungen zurücksetzen"
La["Reset Position"] = "Position zurücksetzen"
La["Resets all settings to defaults"] = "Alle Einstellungen auf Standard zurücksetzen"
La["Resets window position to the center of the screen"] = "Fensterposition auf Bildschirmmitte zurücksetzen"
La["Right Click"] = "Rechtsklick"
La["Scale main window Tooltips"] = "Skalierung der Tooltips im Hauptfenster"
La["Scaling"] = "Skalierung"
La["Show compass"] = "Kompass anzeigen"
La["Show digsites on the Battlefield Minimap"] = "Ausgrabungsstätten auf der Schlachtfeld-Minikarte anzeigen"
La["Show digsites on the Minimap"] = "Ausgrabungsstätten auf der Minikarte anzeigen"
La["Show GatherMate2 pins on the HUD (recomended)"] = "GatherMate2-Pins im HUD anzeigen (empfohlen)"
La["Show/Hide all %s areas"] = "Alle %s Gebiete anzeigen/verstecken"
La["show/hide all %s areas on the HUD"] = "Alle %s Zonen am HUD anzeigen/verstecken"
La["Show/Hide Config"] = "Konfiguration anzeigen/verstecken"
La["show/hide digsites on minimap"] = "Ausgrabungsstätten auf der Minikarte anzeigen/verstecken"
La["Show/Hide the HUD"] = "HUD anzeigen/verstecken"
La["Show/Hide the Main Window"] = "Hauptfenster anzeigen/verstecken"
La["Show/Hide window when entering/leaving a digsite"] = "Zeige/Verstecke das Fenster, wenn eine Ausgrabungsstätte betreten/verlassen wird"
La["Show/Hide window when you show/hide Archy addon"] = "Fenster anzeigen/verstecken, wenn du das Archy-Addon anzeigst/versteckst"
La["Show Player Arrow"] = "Spielerpfeil anzeigen"
La["Show Success Circle"] = "Erfolgskreis anzeigen"
La["Show Tooltips"] = "Tooltips anzeigen"
La["Show Tooltips in the main window"] = "Tooltips im Hauptfenster anzeigen"
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[Größe des HUDs
Wenn du ZOOM benötigst benutze stattdessen den Minimap ZOOM]=]
La["Size of the main window"] = "Größe des Hauptfensters"
La["Size of the Player Arrow"] = "Größe des Spielerpfeils"
La["%s Line Alpha"] = "%s Linien-Transparenz"
La["%s Sector Alpha"] = "%s Sektor-Transparenz"
La["Success Circle Color"] = "Farbe des Erfolgskreises"
La["Survey will succeed if fragment lies within this circle"] = "Untersuchen wird erfolgreich sein, falls das Fragment in diesem Kreis liegt"
La["This will overwrite current settings!"] = "Dies wird die aktuellen Einstellungen überschreiben!"
La["This will reset Main Window position"] = "Dies wird die Hauptfensterposition zurücksetzen"
La["Toggle with Archy"] = "Mit Archy umschalten"
La["Toggle with digsite"] = "Anzeige nur bei Ausgrabungsstätten"
La["Tooltips Scaling"] = "Tooltipskalierung"
La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "Nutze |cff69ccf0Shift-M|r, um die Schlachtfeld-Minikarte anzuzeigen/zu verstecken"
La["Vertical position of HUD relative to screen center"] = "Vertikale Position des HUDs relativ zur Bildschirmmitte"
La["Visible"] = "Sichtbar"
La["Visual Settings"] = "Anzeige-Einstellungen"
La["Whether window is visible"] = "Ob das Fenster sichbar sein soll"
La["yellow"] = "Gelb"
La["Yellow"] = "Gelb"
La["You can also use %s command for this action"] = "Du kannst auch den %s Befehl für diese Aktion benutzen"

elseif locale == "koKR" then do end
La["add new %s zone to the HUD"] = "새로운 %s 지역을 HUD에 추가"
La["Add %s area to the HUD"] = "%s 영역을 HUD에 추가"
La["Alpha"] = "투명도"
La["Annulus Sectors Settings"] = "고리 영역 설정"
La["Archaeology Helper"] = "Archaeology Helper"
La["Arch nodes only"] = "고고학 노드만"
La["Arrow Alpha"] = "화살표 투명도"
La["Arrow Scaling"] = "화살표 크기"
La["Audio Settings"] = "소리 설정"
La["Automatically mount when adding this color to the HUD"] = "HUD에 이 색상이 추가되면 자동으로 탈것을 탑니다"
La["cast Survey"] = "조사 시전"
La["Cast Survey"] = "조사 시전"
La["clear HUD"] = "HUD 지우기"
La["Color of Compass Direction Marks (you can also set alpha here)"] = "나침반 방향 표시 색상 (투명도도 설정 가능)"
La["Color of the Compass Circle (you can also set alpha here)"] = "나침반 원의 색상 (투명도도 설정 가능)"
La["Color of the Success Circle (you can also set alpha here)"] = "성공 원의 색상 (투명도도 설정 가능)"
La["Compass Circle Color"] = "나침반 원 색상"
La["Compass Settings"] = "나침반 설정"
La["Dig Sites"] = "발굴현장"
La["Direction Marks Color"] = "방향 표시 색상"
La["Display minimap icon"] = "미니맵 아이콘 표시"
La["Draw arrow in the center of the HUD"] = "HUD 중앙에 화살표 표시"
La["Draw compass-like circle on the HUD"] = "HUD에 나침반 형태의 원 표시"
La["General HUD Settings"] = "기본 HUD 설정"
La["green"] = "녹색"
La["Green"] = "녹색"
La["Hide on combat"] = "전투 중 숨기기"
La["Hide when resting"] = "휴식 중 숨기기"
La["Horizontal position of HUD relative to screen center"] = "화면 중앙을 기준으로 HUD의 가로 위치"
La["How transparent is HUD"] = "HUD의 투명도"
La["How transparent is Player Arrow"] = "플레이어 화살표의 투명도"
La["How transparent is %s Annulus Sector"] = "%s 고리 영역의 투명도"
La["How transparent is %s Direction Line"] = "%s 방향 선의 투명도"
La["How transparent is window"] = "창의 투명도"
La["HUD"] = "HUD"
La["HUD Alpha"] = "HUD 투명도"
La["HUD Scaling"] = "HUD 크기"
La["HUD settings"] = "HUD 설정"
La["HUD X-Offset"] = "HUD X-좌표"
La["HUD Y-Offset"] = "HUD Y-좌표"
La["Key Bindings Settings"] = "단축키 설정"
La["Left Click"] = "좌 클릭"
La["Locked"] = "잠금"
La["Locks window to prevent accidental repositioning"] = "위치 이동을 방지하기 위해 창을 잠급니다"
La["Main Window"] = "메인 창"
La["Main window settings"] = "메인 창 설정"
La["Middle Click"] = "가운데 클릭"
La["Minimap Icon"] = "미니맵 아이콘"
La["Misc Settings"] = "기타 설정"
La["Mount %s"] = "%s 탈것 타기"
La["move window"] = "창 이동"
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "HUD에 GatherMate2의 고고학 노드만 표시합니다"
La["Open archaeology window"] = "고고학 창 열기"
La["Play confirmation sounds for various actions"] = "여러 행동에 맞는 소리를 재생합니다"
La["Play Sounds"] = "소리 재생하기"
La["Radius of the compass circle"] = "나침반 원의 반경"
La["Radius (yards)"] = "반경 (미터)"
La["red"] = "빨강"
La["Red"] = "빨강"
La["Redirect GatherMate2 output to the HUD when visible"] = "표시 될 때 HUD에 GatherMate2 출력을 재설정합니다"
La["remove one previously added area"] = "이전에 추가된 지역 제거"
La["Remove one previously added area"] = "이전에 추가된 지역 삭제"
La["Reset All Settings"] = "모든 설정 초기화"
La["Reset Position"] = "위치 초기화"
La["Resets all settings to defaults"] = "모든 설정을 기본값으로 초기화"
La["Resets window position to the center of the screen"] = "창 위치를 화면 중앙으로 초기화"
La["Right Click"] = "우 클릭"
La["Scale main window Tooltips"] = "메인 창 툴팁 크기"
La["Scaling"] = "크기"
La["Show compass"] = "나침반 표시"
La["Show digsites on the Battlefield Minimap"] = "전장 미니맵에 발굴현장 표시"
La["Show digsites on the Minimap"] = "미니맵에 발굴현장 표시"
La["Show GatherMate2 pins on the HUD (recomended)"] = "HUD에 GatherMate2 핀 표시 (권장)"
La["Show/Hide all %s areas"] = "모든 %s 영역 표시/숨기기"
La["show/hide all %s areas on the HUD"] = "HUD에 모든 %s 지역 표시/숨기기"
La["Show/Hide Config"] = "설정 표시/숨기기"
La["show/hide digsites on minimap"] = "미니맵에 발굴현장 표시/숨기기"
La["Show/Hide the HUD"] = "HUD 표시/숨기기"
La["Show/Hide the Main Window"] = "메인 창 표시/숨기기"
La["Show/Hide window when entering/leaving a digsite"] = "발굴현장에 들어가거나 나올 때 창을 표시하거나 숨깁니다"
La["Show/Hide window when you show/hide Archy addon"] = "Archy 애드온을 표시하거나 숨기면 창을 표시하거나 숨깁니다"
La["Show Player Arrow"] = "플레이어 화살표 표시"
La["Show Success Circle"] = "성공 원 표시"
La["Show Tooltips"] = "툴팁 표시"
La["Show Tooltips in the main window"] = "메인 창에 툴팁 표시"
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[HUD의 크기
확대하고 싶다면 - 미니맵 확대를 대신 사용하세요]=]
La["Size of the main window"] = "메인 창의 크기"
La["Size of the Player Arrow"] = "플레이어 화살표의 크기"
La["%s Line Alpha"] = "%s 선 투명도"
La["%s Sector Alpha"] = "%s 영역 투명도"
La["Success Circle Color"] = "성공 원 색상"
La["Survey will succeed if fragment lies within this circle"] = "원 안에 조각이 있으면 조사가 성공합니다"
La["This will overwrite current settings!"] = "현재 설정을 덮어씁니다!"
La["This will reset Main Window position"] = "메인 창 위치를 초기화합니다"
La["Toggle with Archy"] = "Archy로 전환"
La["Toggle with digsite"] = "발굴현장으로 전환"
La["Tooltips Scaling"] = "툴팁 크기"
La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "|cff69ccf0쉬프트-M|r을 눌러 전장 미니맵을 열거나 숨깁니다"
La["Vertical position of HUD relative to screen center"] = "화면 중앙을 기준으로 HUD의 세로 위치"
La["Visible"] = "표시"
La["Visual Settings"] = "표시 설정"
La["Whether window is visible"] = "창 표시 여부"
La["yellow"] = "노랑"
La["Yellow"] = "노랑"
La["You can also use %s command for this action"] = "이 행동에 %s 명령어를 사용할 수 있습니다"

elseif locale == "esMX" then do end
La["add new %s zone to the HUD"] = "Añadir nueva zona %s al HUD"
La["Add %s area to the HUD"] = "Añadir área %s al HUD"
La["Alpha"] = "Transparencia"
La["Annulus Sectors Settings"] = "Configuración de las áreas del anillo"
La["Archaeology Helper"] = "Archaeology Helper"
La["Arch nodes only"] = "Sólo los nodos de arqueología"
La["Arrow Alpha"] = "Transparencia de la flecha"
La["Arrow Scaling"] = "Escala de la flecha"
La["Audio Settings"] = "Configuración de audio"
La["Automatically mount when adding this color to the HUD"] = "Montar automáticamente al añadir este color al HUD" -- Needs review
La["cast Survey"] = "Lanzar Estudiar"
La["Cast Survey"] = "Lanzar Estudiar"
La["clear HUD"] = "Limpiar HUD"
La["Color of Compass Direction Marks (you can also set alpha here)"] = "Color de las marcas de dirección de la brújula (también puedes establecer aquí la transparencia)."
La["Color of the Compass Circle (you can also set alpha here)"] = "Color del círculo de la brújula (también puedes establecer aquí la transparencia)."
La["Color of the Success Circle (you can also set alpha here)"] = "Color del círculo de acierto (también puedes establecer aquí la transparencia)."
La["Compass Circle Color"] = "Color del círculo de la brújula"
La["Compass Settings"] = "Configuración de la brújula"
La["Dig Sites"] = "Excavaciones"
La["Direction Marks Color"] = "Color de las marcas de dirección"
La["Display minimap icon"] = "Muestra el icono en el Minimapa."
La["Draw arrow in the center of the HUD"] = "Muestra una flecha en el centro del HUD."
La["Draw compass-like circle on the HUD"] = "Muestra un círculo similar a una brújula en el HUD."
La["General HUD Settings"] = "Configuración general del HUD"
La["green"] = "verde"
La["Green"] = "verde"
La["Hide on combat"] = "Ocultar en combate"
La["Hide when resting"] = "Ocultar en reposo"
La["Horizontal position of HUD relative to screen center"] = "Posición horizontal del HUD con respecto al centro de la pantalla."
La["How transparent is HUD"] = "Transparencia del HUD."
La["How transparent is Player Arrow"] = "Transparencia de la flecha del jugador."
La["How transparent is %s Annulus Sector"] = "Transparencia del área %s del anillo."
La["How transparent is %s Direction Line"] = "Transparencia de la línea de dirección %s."
La["How transparent is window"] = "Transparencia de la ventana."
La["HUD"] = "HUD"
La["HUD Alpha"] = "Transparencia del HUD"
La["HUD Scaling"] = "Escala del HUD"
La["HUD settings"] = "Configuración del HUD."
La["HUD X-Offset"] = "Posición horizontal"
La["HUD Y-Offset"] = "Posición vertical"
La["Key Bindings Settings"] = "Configuración de acceso rápido"
La["Left Click"] = "Clic izquierdo"
La["Locked"] = "Bloquear"
La["Locks window to prevent accidental repositioning"] = "Bloquea la ventana para evitar que puedas moverla accidentalmente."
La["Main Window"] = "General"
La["Main window settings"] = "Ventana principal de configuración."
La["Middle Click"] = "Clic medio"
La["Minimap Icon"] = "Icono en el Minimapa"
La["Misc Settings"] = "Configuración Misc" -- Needs review
La["Mount %s"] = "Montar %s" -- Needs review
La["move window"] = "Mover ventana"
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "Muestra solo los nodos de arqueología de GatherMate2 en el HUD."
La["Open archaeology window"] = "Abrir el panel de arqueología"
La["Play confirmation sounds for various actions"] = "Reproduce sonidos de confirmación para algunas acciones."
La["Play Sounds"] = "Reproducir sonidos"
La["Radius of the compass circle"] = "Radio del círculo de la brújula."
La["Radius (yards)"] = "Radio (yardas)"
La["red"] = "roja"
La["Red"] = "roja"
La["Redirect GatherMate2 output to the HUD when visible"] = "Redirecciona la salida de GatherMate2 al HUD cuando está visible."
La["remove one previously added area"] = "Eliminar la última área que fue agregada"
La["Remove one previously added area"] = "Eliminar la última área que fue agregada"
La["Reset All Settings"] = "Restablecer todo"
La["Reset Position"] = "Restablecer posición"
La["Resets all settings to defaults"] = "Restablece todas las configuraciones a los valores por defecto."
La["Resets window position to the center of the screen"] = "Restablece la posición de la ventana al centro de la pantalla."
La["Right Click"] = "Clic derecho"
La["Scale main window Tooltips"] = "Escala de la información de la ventana principal."
La["Scaling"] = "Escala"
La["Show compass"] = "Mostrar brújula"
La["Show digsites on the Battlefield Minimap"] = "Mostrar excavaciones en el Mapa de zona"
La["Show digsites on the Minimap"] = "Mostrar excavaciones en el Minimapa"
La["Show GatherMate2 pins on the HUD (recomended)"] = "Iconos de GatherMate2 en el HUD (recomendado)"
La["Show/Hide all %s areas"] = "Mostrar/ocultar toda el área %s"
La["show/hide all %s areas on the HUD"] = "Mostrar/ocultar toda el área %s en el HUD"
La["Show/Hide Config"] = "Mostrar/ocultar el panel de configuración"
La["show/hide digsites on minimap"] = "Mostrar/ocultar excavaciones en el Minimapa"
La["Show/Hide the HUD"] = "Mostrar/ocultar el HUD"
La["Show/Hide the Main Window"] = "Mostrar/ocultar la ventana principal"
La["Show/Hide window when entering/leaving a digsite"] = "Mostrar/Ocultar ventana al entrar/salir de la excavación" -- Needs review
La["Show/Hide window when you show/hide Archy addon"] = "Muestra/oculta la ventana cuando se muestra/oculta el Addon Archy."
La["Show Player Arrow"] = "Mostrar flecha del jugador"
La["Show Success Circle"] = "Círculo de acierto"
La["Show Tooltips"] = "Mostrar información"
La["Show Tooltips in the main window"] = "Muestra información en la ventana principal."
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[Tamaño del HUD.
Si necesitas acercar/alejar, mejor utiliza los botones del Minimapa.]=]
La["Size of the main window"] = "Tamaño de la ventana principal."
La["Size of the Player Arrow"] = "Tamaño de la flecha del jugador."
La["%s Line Alpha"] = "Transp. de la línea %s"
La["%s Sector Alpha"] = "Transp. del área %s"
La["Success Circle Color"] = "Color del círculo de acierto"
La["Survey will succeed if fragment lies within this circle"] = "Estudiar tendrá éxito si el fragmento se encuentra dentro de este círculo."
La["This will overwrite current settings!"] = "¡Esto sobrescribirá la configuración actual!"
La["This will reset Main Window position"] = "¡Esto restablecerá la posición de la ventana principal!"
La["Toggle with Archy"] = "Mostrar con Archy"
La["Toggle with digsite"] = "Alternar con excavación" -- Needs review
La["Tooltips Scaling"] = "Escala de información"
La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "Utiliza |cff69ccf0Mayús+M|r para mostrar/ocultar el Mapa de zona."
La["Vertical position of HUD relative to screen center"] = "Posición vertical del HUD con respecto al centro de la pantalla."
La["Visible"] = "Visible"
La["Visual Settings"] = "Configuración visual"
La["Whether window is visible"] = "Si es visible la ventana."
La["yellow"] = "amarilla"
La["Yellow"] = "amarilla"
La["You can also use %s command for this action"] = "También puedes usar el comando %s para esta acción."

elseif locale == "ruRU" then do end
La["add new %s zone to the HUD"] = "добавить новую %s зону в HUD-дисплей"
La["Add %s area to the HUD"] = "Добавить %s зону в HUD-дисплей"
La["Alpha"] = "Прозрачность"
La["Annulus Sectors Settings"] = "Настройки Секторов Кольца"
La["Archaeology Helper"] = "Помощник Археолога"
La["Arch nodes only"] = "Только отметки Archy." -- Needs review
La["Arrow Alpha"] = "Направляющая Прозрачности"
La["Arrow Scaling"] = "Направляющая Масштабирования"
La["Audio Settings"] = "Настройки Аудио"
La["Automatically mount when adding this color to the HUD"] = "Автоматически оседлать маунта после установки маркера этого цвета "
La["cast Survey"] = "начать Раскопку"
La["Cast Survey"] = "Начать Раскопку"
La["clear HUD"] = "очистить HUD-дисплей"
La["Color of Compass Direction Marks (you can also set alpha here)"] = "Цвет Направляющих Маркеров Компаса (возможно использовать прозрачность)"
La["Color of the Compass Circle (you can also set alpha here)"] = "Цвет Круга Компаса (возможно использовать прозрачность)"
La["Color of the Success Circle (you can also set alpha here)"] = "Цвет Кольца Успеха (возможно использовать прозрачность)"
La["Compass Circle Color"] = "Цвет Круга Компаса"
La["Compass Settings"] = "Настройки Компаса"
La["Dig Sites"] = "Зоны Раскопок"
La["Direction Marks Color"] = "Цвет Направляющих Маркеров"
La["Display minimap icon"] = "Отображать иконку на миникарте"
La["Draw arrow in the center of the HUD"] = "Нарисовать направляющую в центре HUD-дисплея"
La["Draw compass-like circle on the HUD"] = "Нарисовать компас в виде круга на HUD-дисплее"
La["General HUD Settings"] = "Основные Настройки HUD-дисплея"
La["green"] = "зелёный"
La["Green"] = "Зелёный"
La["Hide on combat"] = "Скрывать во время боя"
La["Hide when resting"] = "Скрывать во время отдыха"
La["Horizontal position of HUD relative to screen center"] = "Горизонтальное положение HUD-дисплея (относительно центра экрана)"
La["How transparent is HUD"] = "Прозрачность HUD-дисплея"
La["How transparent is Player Arrow"] = "Прозрачность Направляющей Игрока"
La["How transparent is %s Annulus Sector"] = "Прозрачность %s Сектора Кольца"
La["How transparent is %s Direction Line"] = "Прозрачность %s Направляющей Линии"
La["How transparent is window"] = "Прозрачность окна"
La["HUD"] = "HUD-дисплей"
La["HUD Alpha"] = "HUD-дисплей (Прозрачность)"
La["HUD Scaling"] = "Масштабирование HUD-дисплея"
La["HUD settings"] = "Настройки HUD-дисплея"
La["HUD X-Offset"] = "HUD-дисплей (Смещение по оси X)"
La["HUD Y-Offset"] = "HUD-дисплей (Смещение по оси Y)"
La["Key Bindings Settings"] = "Настройки Комбинаций Клавиш"
La["Left Click"] = "Клик ЛКМ"
La["Locked"] = "Заблокировано"
La["Locks window to prevent accidental repositioning"] = "Блокировка окна (дабы избежать случайного перетаскивания)"
La["Main Window"] = "Основное Окно"
La["Main window settings"] = "Настройки основного окна"
La["Middle Click"] = "Клик Средней Кнопкой Мыши"
La["Minimap Icon"] = "Иконка на Миникарте"
La["Misc Settings"] = "Другие Настройки"
La["Mount %s"] = "Маунт %s"
La["move window"] = "передвигать окно"
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "Показывать только археологические отметки GatherMate2 на пользовательском интерфейсе." -- Needs review
La["Open archaeology window"] = "Открыть окно археологии"
La["Play confirmation sounds for various actions"] = "Проигрывать подтверждающие звуки для различных действий"
La["Play Sounds"] = "Воспроизводить Звуки"
La["Radius of the compass circle"] = "Радиус круга компаса"
La["Radius (yards)"] = "Радиус (ярды)"
La["red"] = "красный"
La["Red"] = "Красный"
La["Redirect GatherMate2 output to the HUD when visible"] = "Переправить данные GatherMate2 на пользовательский интерфейс, если есть." -- Needs review
La["remove one previously added area"] = "удалить последнюю добавленную зону"
La["Remove one previously added area"] = "Удалить последнюю добавленную зону "
La["Reset All Settings"] = "Сбросить Настройки"
La["Reset Position"] = "Сбросить Позицию"
La["Resets all settings to defaults"] = "Вернуться к настройкам по умолчанию"
La["Resets window position to the center of the screen"] = "Сбросить позицию окна в центр экрана"
La["Right Click"] = "Клик ПКМ"
La["Scale main window Tooltips"] = "Масштабирование Подсказок на главном окне"
La["Scaling"] = "Масштабирование "
La["Show compass"] = "Показать компас"
La["Show digsites on the Battlefield Minimap"] = "Показывать зоны раскопок на Миникарте Игровой Зоны"
La["Show digsites on the Minimap"] = "Показывать зоны раскопок на Миникарте"
La["Show GatherMate2 pins on the HUD (recomended)"] = "Показывать отметки GatherMate2 на пользовательском интерфейсе. (рекомендуется)" -- Needs review
La["Show/Hide all %s areas"] = "Показать/Скрыть все %s зоны"
La["show/hide all %s areas on the HUD"] = "показать/скрыть все %s зоны в HUD-дисплей"
La["Show/Hide Config"] = "Показать/Скрыть Конфигурацию"
La["show/hide digsites on minimap"] = "показать/скрыть зоны раскопок на миникарте"
La["Show/Hide the HUD"] = "Показать/Скрыть HUD-дислпей"
La["Show/Hide the Main Window"] = "Показать/Скрыть Основное Окно"
La["Show/Hide window when entering/leaving a digsite"] = "Отображать/Скрывать окно, когда входишь/покидаешь зону раскопок"
La["Show/Hide window when you show/hide Archy addon"] = "Отображать/Скрывать окно, когда Вы отображаете/скрываете Archy аддон"
La["Show Player Arrow"] = "Показывать Направляющую Игрока"
La["Show Success Circle"] = "Показывать Круг Успеха"
La["Show Tooltips"] = "Отображать Подсказки"
La["Show Tooltips in the main window"] = "Показывать Подсказки в основном окне "
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[Размер HUD-дисплея
Если Вам нужно Приблизить - лучше используйте Приближение Миникарты]=]
La["Size of the main window"] = "Размер основного окна"
La["Size of the Player Arrow"] = "Размер Направляющей Игрока"
La["%s Line Alpha"] = "%s Линия Прозрачности"
La["%s Sector Alpha"] = "%s Сектор Прозрачности"
La["Success Circle Color"] = "Цвет Круга Успеха"
La["Survey will succeed if fragment lies within this circle"] = "Раскопка будет успешной, если фрагмент лежит внутри этого круга"
La["This will overwrite current settings!"] = "Это сотрёт нынешние настройки!!!"
La["This will reset Main Window position"] = "Это сбросит позицию Основного Окна"
La["Toggle with Archy"] = "Включать с Archy." -- Needs review
La["Toggle with digsite"] = "Отображать в зоне раскопок"
La["Tooltips Scaling"] = "Подсказки к Масштабированию"
La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "Используйте |cff69ccf0Shift-M|r, чтобы отобразить/скрыть Миникарту Игровой Зоны"
La["Vertical position of HUD relative to screen center"] = "Вертикальное положение HUD-дисплея (относительно центра экрана)"
La["Visible"] = "Видимость"
La["Visual Settings"] = "Визуальные Настройки"
La["Whether window is visible"] = "Вкл/выкл отображение интерфейса"
La["yellow"] = "жёлтый"
La["Yellow"] = "Жёлтый"
La["You can also use %s command for this action"] = "Также Вы можете использовать %s команду для этого действия"

elseif locale == "zhCN" then do end
La["add new %s zone to the HUD"] = "增加新的%s地域到HUD" -- Needs review
La["Add %s area to the HUD"] = "增加 %s 区域到HUD" -- Needs review
La["Alpha"] = "透明度" -- Needs review
La["Annulus Sectors Settings"] = "环型扇区设定" -- Needs review
La["Archaeology Helper"] = "考古助手" -- Needs review
La["Arch nodes only"] = "仅考古点" -- Needs review
La["Arrow Alpha"] = "箭头透明度" -- Needs review
La["Arrow Scaling"] = "箭头缩放" -- Needs review
La["Audio Settings"] = "声音设定" -- Needs review
-- La["Automatically mount when adding this color to the HUD"] = ""
La["cast Survey"] = "使用勘探" -- Needs review
La["Cast Survey"] = "使用勘测" -- Needs review
La["clear HUD"] = "清理HUD" -- Needs review
La["Color of Compass Direction Marks (you can also set alpha here)"] = "罗盘方位标志颜色(这里你也可以设定透明度)" -- Needs review
La["Color of the Compass Circle (you can also set alpha here)"] = "罗盘圆圈颜色(这里你也可以设定透明度)" -- Needs review
La["Color of the Success Circle (you can also set alpha here)"] = "成功圈圈颜色(这里你也可以设定透明度)" -- Needs review
La["Compass Circle Color"] = "罗盘圆圈颜色" -- Needs review
La["Compass Settings"] = "罗盘设置" -- Needs review
La["Dig Sites"] = "挖掘场" -- Needs review
La["Direction Marks Color"] = "方位标志颜色" -- Needs review
La["Display minimap icon"] = "显示小地图图标" -- Needs review
La["Draw arrow in the center of the HUD"] = "将箭头放置在HUD的中心" -- Needs review
La["Draw compass-like circle on the HUD"] = "将类似罗盘的圆圈放置在HUD上" -- Needs review
La["General HUD Settings"] = "一般HUD设置" -- Needs review
La["green"] = "绿色" -- Needs review
La["Green"] = "绿色" -- Needs review
La["Hide on combat"] = "战斗时隐藏" -- Needs review
La["Hide when resting"] = "休息时隐藏" -- Needs review
La["Horizontal position of HUD relative to screen center"] = "HUD相对于屏幕中心的水平位置" -- Needs review
La["How transparent is HUD"] = "设置HUD的透明度" -- Needs review
La["How transparent is Player Arrow"] = "设置玩家箭头的透明度" -- Needs review
La["How transparent is %s Annulus Sector"] = "设置在 %s 环型扇区的透明度" -- Needs review
La["How transparent is %s Direction Line"] = "设置在 %s 方位线的透明度" -- Needs review
La["How transparent is window"] = "设置在窗口的透明度" -- Needs review
La["HUD"] = "HUD" -- Needs review
La["HUD Alpha"] = "HUD透明度" -- Needs review
La["HUD Scaling"] = "HUD缩放" -- Needs review
La["HUD settings"] = "HUD设置" -- Needs review
La["HUD X-Offset"] = "HUD X轴偏移量" -- Needs review
La["HUD Y-Offset"] = "HUD Y轴偏移量" -- Needs review
La["Key Bindings Settings"] = "按键绑定设置" -- Needs review
La["Left Click"] = "左键点击" -- Needs review
La["Locked"] = "锁定" -- Needs review
La["Locks window to prevent accidental repositioning"] = "锁定窗口以防止意外改变位置" -- Needs review
La["Main Window"] = "主窗口" -- Needs review
La["Main window settings"] = "主窗口设置" -- Needs review
La["Middle Click"] = "中键点击" -- Needs review
La["Minimap Icon"] = "小地图图标" -- Needs review
-- La["Misc Settings"] = ""
-- La["Mount %s"] = ""
La["move window"] = "移动窗口" -- Needs review
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "只在HUD上显示 GatherMate2 的考古点" -- Needs review
La["Open archaeology window"] = "开启考古学窗口" -- Needs review
La["Play confirmation sounds for various actions"] = "为各种改动播放确认声音" -- Needs review
La["Play Sounds"] = "播放声音" -- Needs review
La["Radius of the compass circle"] = "罗盘圆圈的半径" -- Needs review
La["Radius (yards)"] = "半径(码)" -- Needs review
La["red"] = "红色" -- Needs review
La["Red"] = "红色" -- Needs review
La["Redirect GatherMate2 output to the HUD when visible"] = "重定向 GatherMate2 的数据到可见时的HUD" -- Needs review
La["remove one previously added area"] = "移除一个先前增加的区域" -- Needs review
La["Remove one previously added area"] = "移除一个先前增加的区域" -- Needs review
La["Reset All Settings"] = "重设所有设置" -- Needs review
La["Reset Position"] = "重设位置" -- Needs review
La["Resets all settings to defaults"] = "重设所有设定至默认设置" -- Needs review
La["Resets window position to the center of the screen"] = "重设窗口位置至屏幕中间" -- Needs review
La["Right Click"] = "右键点击" -- Needs review
La["Scale main window Tooltips"] = "缩放主窗口鼠标提示" -- Needs review
La["Scaling"] = "缩放" -- Needs review
La["Show compass"] = "显示罗盘" -- Needs review
La["Show digsites on the Battlefield Minimap"] = "在战场小地图上显示挖掘场" -- Needs review
La["Show digsites on the Minimap"] = "在小地图上显示挖掘场" -- Needs review
La["Show GatherMate2 pins on the HUD (recomended)"] = "在HUD上显示 GatherMate2 的点(建议)" -- Needs review
La["Show/Hide all %s areas"] = "显示/隐藏 所有 %s 区域" -- Needs review
La["show/hide all %s areas on the HUD"] = "显示/隐藏HUD上所有%s的区域" -- Needs review
La["Show/Hide Config"] = "显示/隐藏设置" -- Needs review
La["show/hide digsites on minimap"] = "显示/隐藏小地图上的挖掘场" -- Needs review
La["Show/Hide the HUD"] = "显示/隐藏 HUD" -- Needs review
La["Show/Hide the Main Window"] = "显示/隐藏主窗口" -- Needs review
La["Show/Hide window when entering/leaving a digsite"] = "当进入/离开挖掘场时显示/隐藏窗口" -- Needs review
La["Show/Hide window when you show/hide Archy addon"] = "当你显示/隐藏Archy插件时也同步显示/隐藏窗口" -- Needs review
La["Show Player Arrow"] = "显示玩家箭头" -- Needs review
La["Show Success Circle"] = "显示成功圆圈" -- Needs review
La["Show Tooltips"] = "显示鼠标提示" -- Needs review
La["Show Tooltips in the main window"] = "在主窗口显示鼠标提示" -- Needs review
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[HUD尺寸
如果你需要缩放 - 使用小地图缩放代替]=] -- Needs review
La["Size of the main window"] = "主窗口尺寸" -- Needs review
La["Size of the Player Arrow"] = "玩家箭头尺寸" -- Needs review
La["%s Line Alpha"] = "%s 线条透明度" -- Needs review
La["%s Sector Alpha"] = "%s 扇区透明度" -- Needs review
La["Success Circle Color"] = "成功圆圈颜色" -- Needs review
La["Survey will succeed if fragment lies within this circle"] = "如果碎片在此圆圈内将成功勘探" -- Needs review
La["This will overwrite current settings!"] = "这件覆盖现有设置！" -- Needs review
La["This will reset Main Window position"] = "这将重设主窗口位置" -- Needs review
La["Toggle with Archy"] = "跟Archy一起切换" -- Needs review
La["Toggle with digsite"] = "切换挖掘场" -- Needs review
La["Tooltips Scaling"] = "鼠标提示缩放" -- Needs review
La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "使用 |cff69ccf0Shift-M|r 以开启或隐藏战场小地图" -- Needs review
La["Vertical position of HUD relative to screen center"] = "HUD相对于屏幕中心的垂直位置" -- Needs review
La["Visible"] = "可视性" -- Needs review
La["Visual Settings"] = "视觉设置" -- Needs review
La["Whether window is visible"] = "窗口是否可见" -- Needs review
La["yellow"] = "黄色" -- Needs review
La["Yellow"] = "黄色" -- Needs review
La["You can also use %s command for this action"] = "你也可以使用%s的指令来作此动作" -- Needs review

elseif locale == "esES" then do end
La["add new %s zone to the HUD"] = "Añadir nueva zona %s al HUD"
La["Add %s area to the HUD"] = "Añadir área %s al HUD"
La["Alpha"] = "Transparencia"
La["Annulus Sectors Settings"] = "Configuración de las áreas del anillo"
La["Archaeology Helper"] = "Archaeology Helper"
La["Arch nodes only"] = "Sólo los nodos de arqueología"
La["Arrow Alpha"] = "Transparencia de la flecha"
La["Arrow Scaling"] = "Escala de la flecha"
La["Audio Settings"] = "Configuración de audio"
La["Automatically mount when adding this color to the HUD"] = "Montar automáticamente al añadir este color al HUD" -- Needs review
La["cast Survey"] = "Lanzar Estudiar"
La["Cast Survey"] = "Lanzar Estudiar"
La["clear HUD"] = "Limpiar HUD"
La["Color of Compass Direction Marks (you can also set alpha here)"] = "Color de las marcas de dirección de la brújula (también puedes establecer aquí la transparencia)."
La["Color of the Compass Circle (you can also set alpha here)"] = "Color del círculo de la brújula (también puedes establecer aquí la transparencia)."
La["Color of the Success Circle (you can also set alpha here)"] = "Color del círculo de acierto (también puedes establecer aquí la transparencia)."
La["Compass Circle Color"] = "Color del círculo de la brújula"
La["Compass Settings"] = "Configuración de la brújula"
La["Dig Sites"] = "Excavaciones"
La["Direction Marks Color"] = "Color de las marcas de dirección"
La["Display minimap icon"] = "Muestra el icono en el Minimapa."
La["Draw arrow in the center of the HUD"] = "Muestra una flecha en el centro del HUD."
La["Draw compass-like circle on the HUD"] = "Muestra un círculo similar a una brújula en el HUD."
La["General HUD Settings"] = "Configuración general del HUD"
La["green"] = "verde"
La["Green"] = "verde"
La["Hide on combat"] = "Ocultar en combate"
La["Hide when resting"] = "Ocultar en reposo"
La["Horizontal position of HUD relative to screen center"] = "Posición horizontal del HUD con respecto al centro de la pantalla."
La["How transparent is HUD"] = "Transparencia del HUD."
La["How transparent is Player Arrow"] = "Transparencia de la flecha del jugador."
La["How transparent is %s Annulus Sector"] = "Transparencia del área %s del anillo."
La["How transparent is %s Direction Line"] = "Transparencia de la línea de dirección %s."
La["How transparent is window"] = "Transparencia de la ventana."
La["HUD"] = "HUD"
La["HUD Alpha"] = "Transparencia del HUD"
La["HUD Scaling"] = "Escala del HUD"
La["HUD settings"] = "Configuración del HUD."
La["HUD X-Offset"] = "Posición horizontal"
La["HUD Y-Offset"] = "Posición vertical"
La["Key Bindings Settings"] = "Configuración de acceso rápido"
La["Left Click"] = "Clic izquierdo"
La["Locked"] = "Bloquear"
La["Locks window to prevent accidental repositioning"] = "Bloquea la ventana para evitar que puedas moverla accidentalmente."
La["Main Window"] = "General"
La["Main window settings"] = "Ventana principal de configuración."
La["Middle Click"] = "Clic medio"
La["Minimap Icon"] = "Icono en el Minimapa"
La["Misc Settings"] = "Configuración Miscelánea" -- Needs review
La["Mount %s"] = "Montar %s" -- Needs review
La["move window"] = "Mover ventana"
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "Muestra solo los nodos de arqueología de GatherMate2 en el HUD."
La["Open archaeology window"] = "Abrir el panel de arqueología"
La["Play confirmation sounds for various actions"] = "Reproduce sonidos de confirmación para algunas acciones."
La["Play Sounds"] = "Reproducir sonidos"
La["Radius of the compass circle"] = "Radio del círculo de la brújula."
La["Radius (yards)"] = "Radio (yardas)"
La["red"] = "roja"
La["Red"] = "roja"
La["Redirect GatherMate2 output to the HUD when visible"] = "Redirecciona la salida de GatherMate2 al HUD cuando está visible."
La["remove one previously added area"] = "Eliminar la última área que fue agregada"
La["Remove one previously added area"] = "Eliminar la última área que fue agregada"
La["Reset All Settings"] = "Restablecer todo"
La["Reset Position"] = "Restablecer posición"
La["Resets all settings to defaults"] = "Restablece todas las configuraciones a los valores por defecto."
La["Resets window position to the center of the screen"] = "Restablece la posición de la ventana al centro de la pantalla."
La["Right Click"] = "Clic derecho"
La["Scale main window Tooltips"] = "Escala de la información de la ventana principal."
La["Scaling"] = "Escala"
La["Show compass"] = "Mostrar brújula"
La["Show digsites on the Battlefield Minimap"] = "Mostrar excavaciones en el Mapa de zona"
La["Show digsites on the Minimap"] = "Mostrar excavaciones en el Minimapa"
La["Show GatherMate2 pins on the HUD (recomended)"] = "Iconos de GatherMate2 en el HUD (recomendado)"
La["Show/Hide all %s areas"] = "Mostrar/ocultar toda el área %s"
La["show/hide all %s areas on the HUD"] = "Mostrar/ocultar toda el área %s en el HUD"
La["Show/Hide Config"] = "Mostrar/ocultar el panel de configuración"
La["show/hide digsites on minimap"] = "Mostrar/ocultar excavaciones en el Minimapa"
La["Show/Hide the HUD"] = "Mostrar/ocultar el HUD"
La["Show/Hide the Main Window"] = "Mostrar/ocultar la ventana principal"
La["Show/Hide window when entering/leaving a digsite"] = "Mostrar / Ocultar ventana al entrar / salir un zona excavación"
La["Show/Hide window when you show/hide Archy addon"] = "Muestra/oculta la ventana cuando se muestra/oculta el Addon Archy."
La["Show Player Arrow"] = "Mostrar flecha del jugador"
La["Show Success Circle"] = "Círculo de acierto"
La["Show Tooltips"] = "Mostrar información"
La["Show Tooltips in the main window"] = "Muestra información en la ventana principal."
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[Tamaño del HUD.
Si necesitas acercar/alejar, mejor utiliza los botones del Minimapa.]=]
La["Size of the main window"] = "Tamaño de la ventana principal."
La["Size of the Player Arrow"] = "Tamaño de la flecha del jugador."
La["%s Line Alpha"] = "Transp. de la línea %s"
La["%s Sector Alpha"] = "Transp. del área %s"
La["Success Circle Color"] = "Color del círculo de acierto"
La["Survey will succeed if fragment lies within this circle"] = "Estudiar tendrá éxito si el fragmento se encuentra dentro de este círculo."
La["This will overwrite current settings!"] = "¡Esto sobrescribirá la configuración actual!"
La["This will reset Main Window position"] = "¡Esto restablecerá la posición de la ventana principal!"
La["Toggle with Archy"] = "Mostrar con Archy"
La["Toggle with digsite"] = "Alternar con zona excavación"
La["Tooltips Scaling"] = "Escala de información"
La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "Utiliza |cff69ccf0Mayús+M|r para mostrar/ocultar el Mapa de zona."
La["Vertical position of HUD relative to screen center"] = "Posición vertical del HUD con respecto al centro de la pantalla."
La["Visible"] = "Visible"
La["Visual Settings"] = "Configuración visual"
La["Whether window is visible"] = "Si es visible la ventana."
La["yellow"] = "amarilla"
La["Yellow"] = "amarilla"
La["You can also use %s command for this action"] = "También puedes usar el comando %s para esta acción."

elseif locale == "zhTW" then do end
La["add new %s zone to the HUD"] = "增加新的%s區域到HUD"
La["Add %s area to the HUD"] = "增加 %s 區域到HUD"
La["Alpha"] = "透明度"
La["Annulus Sectors Settings"] = "環型扇區設定"
La["Archaeology Helper"] = "考古學幫手"
La["Arch nodes only"] = "只有考古點"
La["Arrow Alpha"] = "箭頭透明度"
La["Arrow Scaling"] = "箭頭大小"
La["Audio Settings"] = "聲音設定"
La["Automatically mount when adding this color to the HUD"] = "當在HUD上加入此顏色時自動上坐騎"
La["cast Survey"] = "使用探勘"
La["Cast Survey"] = "使用探勘"
La["clear HUD"] = "清除HUD"
La["Color of Compass Direction Marks (you can also set alpha here)"] = "羅盤方位標誌顏色(這裏你也可以設定透明度)"
La["Color of the Compass Circle (you can also set alpha here)"] = "羅盤圓圈顏色(這裏你也可以設定透明度)"
La["Color of the Success Circle (you can also set alpha here)"] = "成功圈圈顏色(這裏你也可以設定透明度)"
La["Compass Circle Color"] = "羅盤圓圈顏色"
La["Compass Settings"] = "羅盤設定"
La["Dig Sites"] = "挖掘場"
La["Direction Marks Color"] = "方位標誌顏色"
La["Display minimap icon"] = "顯示小地圖圖標"
La["Draw arrow in the center of the HUD"] = "放置箭頭在HUD的中心"
La["Draw compass-like circle on the HUD"] = "放置類似羅盤的圓圈在HUD"
La["General HUD Settings"] = "一般HUD設定"
La["green"] = "綠色"
La["Green"] = "綠色"
La["Hide on combat"] = "戰鬥時隱藏"
La["Hide when resting"] = "休息時隱藏"
La["Horizontal position of HUD relative to screen center"] = "HUD相對於螢幕中央的水平位置"
La["How transparent is HUD"] = "設置HUD的透明度"
La["How transparent is Player Arrow"] = "設置玩家箭頭的透明度"
La["How transparent is %s Annulus Sector"] = "設置在 %s 環型扇區的透明度"
La["How transparent is %s Direction Line"] = "設置在 %s 方位線的透明度"
La["How transparent is window"] = "設置在視窗的透明度"
La["HUD"] = "HUD"
La["HUD Alpha"] = "HUD透明度"
La["HUD Scaling"] = "HUD縮放"
La["HUD settings"] = "HUD設定"
La["HUD X-Offset"] = "HUD X軸偏移量"
La["HUD Y-Offset"] = "HUD Y軸偏移量"
La["Key Bindings Settings"] = "按鍵綁定設置"
La["Left Click"] = "左鍵點擊"
La["Locked"] = "鎖定"
La["Locks window to prevent accidental repositioning"] = "鎖定視窗以防止意外改變位置"
La["Main Window"] = "主視窗"
La["Main window settings"] = "主視窗設置"
La["Middle Click"] = "中鍵點擊"
La["Minimap Icon"] = "小地圖圖標"
La["Misc Settings"] = "雜項設置"
La["Mount %s"] = "坐騎 %s"
La["move window"] = "移動視窗"
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "只顯示GatherMate2的考古點在HUD上"
La["Open archaeology window"] = "開啟考古學視窗"
La["Play confirmation sounds for various actions"] = "為各種行動撥放確認聲音"
La["Play Sounds"] = "播放聲音"
La["Radius of the compass circle"] = "羅盤圓圈的半徑"
La["Radius (yards)"] = "半徑(碼)"
La["red"] = "紅色"
La["Red"] = "紅色"
La["Redirect GatherMate2 output to the HUD when visible"] = "當可視時重新指向GatherMate2的輸出到HUD"
La["remove one previously added area"] = "移除一個先前增加的區域"
La["Remove one previously added area"] = "移除一個先前增加的區域範圍"
La["Reset All Settings"] = "重設所有設定"
La["Reset Position"] = "重設位置"
La["Resets all settings to defaults"] = "重設所有設定為預設"
La["Resets window position to the center of the screen"] = "重設視窗位置到螢幕中央"
La["Right Click"] = "右鍵點擊"
La["Scale main window Tooltips"] = "縮放主視窗工具提示"
La["Scaling"] = "縮放"
La["Show compass"] = "顯示羅盤"
La["Show digsites on the Battlefield Minimap"] = "在戰場小地圖上顯示挖掘場"
La["Show digsites on the Minimap"] = "在小地圖上顯示挖掘場"
La["Show GatherMate2 pins on the HUD (recomended)"] = "顯示GatherMate2的點在HUD(建議)"
La["Show/Hide all %s areas"] = "顯示/隱藏 所有 %s 區域"
La["show/hide all %s areas on the HUD"] = "顯示/隱藏HUD上所有%s的區域"
La["Show/Hide Config"] = "顯示/隱藏設置選項"
La["show/hide digsites on minimap"] = "顯示/隱藏小地圖上的挖掘場"
La["Show/Hide the HUD"] = "顯示/隱藏 HUD"
La["Show/Hide the Main Window"] = "顯示/隱藏主視窗"
La["Show/Hide window when entering/leaving a digsite"] = "當進入/離開探勘點時顯示/隱藏視窗"
La["Show/Hide window when you show/hide Archy addon"] = "當你顯示/隱藏Archy插件時也顯示/隱藏視窗"
La["Show Player Arrow"] = "顯示玩家箭頭"
La["Show Success Circle"] = "顯示成功圈圈"
La["Show Tooltips"] = "顯示工具提示"
La["Show Tooltips in the main window"] = "顯示工具提示在主視窗"
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = [=[HUD尺寸大小
如果你需要縮放 - 請使用小地圖縮放代替]=]
La["Size of the main window"] = "主視窗大小"
La["Size of the Player Arrow"] = "玩家箭頭大小"
La["%s Line Alpha"] = "%s 線條透明度"
La["%s Sector Alpha"] = "%s 扇區透明度"
La["Success Circle Color"] = "成功圈圈顏色"
La["Survey will succeed if fragment lies within this circle"] = "如果碎片在此圈圈內探勘將會成功"
La["This will overwrite current settings!"] = "這將會覆寫現有的設定"
La["This will reset Main Window position"] = "這會重設主視窗的位置"
La["Toggle with Archy"] = "跟Archy一起切換"
La["Toggle with digsite"] = "探勘點切換"
La["Tooltips Scaling"] = "工具提示縮放"
La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = "使用 |cff69ccf0Shift-M|r 以開啟或隱藏戰場小地圖"
La["Vertical position of HUD relative to screen center"] = "HUD相對於螢幕中央的垂直位置"
La["Visible"] = "可視性"
La["Visual Settings"] = "視覺設定"
La["Whether window is visible"] = "視窗是否可見"
La["yellow"] = "黃色"
La["Yellow"] = "黃色"
La["You can also use %s command for this action"] = "你也可以使用%s的指令來作此動作"

elseif locale == "ptBR" then do end
-- La["add new %s zone to the HUD"] = ""
La["Add %s area to the HUD"] = "Adicionar área %s ao HUD" -- Needs review
La["Alpha"] = "Transparência" -- Needs review
La["Annulus Sectors Settings"] = "Configurações de Setores do Anel" -- Needs review
La["Archaeology Helper"] = "Ajudante de Arqueologia" -- Needs review
-- La["Arch nodes only"] = ""
La["Arrow Alpha"] = "Transparência da seta" -- Needs review
La["Arrow Scaling"] = "Dimensão do Cursor" -- Needs review
La["Audio Settings"] = "Configurações de Audio" -- Needs review
-- La["Automatically mount when adding this color to the HUD"] = ""
-- La["cast Survey"] = ""
La["Cast Survey"] = "Sondar" -- Needs review
-- La["clear HUD"] = ""
-- La["Color of Compass Direction Marks (you can also set alpha here)"] = ""
-- La["Color of the Compass Circle (you can also set alpha here)"] = ""
-- La["Color of the Success Circle (you can also set alpha here)"] = ""
-- La["Compass Circle Color"] = ""
La["Compass Settings"] = "Configurações do Compasso" -- Needs review
La["Dig Sites"] = "Sitios Arqueologicos" -- Needs review
La["Direction Marks Color"] = "Cores das Marcas de Direção" -- Needs review
-- La["Display minimap icon"] = ""
La["Draw arrow in the center of the HUD"] = "Dezenhar cursor no centro do HUD" -- Needs review
-- La["Draw compass-like circle on the HUD"] = ""
La["General HUD Settings"] = "Configurações gerais do HUD" -- Needs review
-- La["green"] = ""
La["Green"] = "Verde" -- Needs review
-- La["Hide on combat"] = ""
-- La["Hide when resting"] = ""
-- La["Horizontal position of HUD relative to screen center"] = ""
La["How transparent is HUD"] = "Transparência do HUD" -- Needs review
La["How transparent is Player Arrow"] = "Transparência do cursor" -- Needs review
-- La["How transparent is %s Annulus Sector"] = ""
-- La["How transparent is %s Direction Line"] = ""
La["How transparent is window"] = "Transparência da janela" -- Needs review
-- La["HUD"] = ""
-- La["HUD Alpha"] = ""
La["HUD Scaling"] = "Escala do HUD" -- Needs review
La["HUD settings"] = "Configurações do HUD" -- Needs review
-- La["HUD X-Offset"] = ""
-- La["HUD Y-Offset"] = ""
-- La["Key Bindings Settings"] = ""
-- La["Left Click"] = ""
La["Locked"] = "Travado" -- Needs review
La["Locks window to prevent accidental repositioning"] = "Travar janela para previnir deslocamento acidental" -- Needs review
La["Main Window"] = "Janela principal" -- Needs review
La["Main window settings"] = "Configurções da janela principal" -- Needs review
-- La["Middle Click"] = ""
-- La["Minimap Icon"] = ""
-- La["Misc Settings"] = ""
-- La["Mount %s"] = ""
-- La["move window"] = ""
-- La["Only show Archaeology nodes from GatherMate2 on the HUD"] = ""
-- La["Open archaeology window"] = ""
La["Play confirmation sounds for various actions"] = "Tocar som de confirmação para diversas ações" -- Needs review
La["Play Sounds"] = "Tocar Sons" -- Needs review
La["Radius of the compass circle"] = "Raio do circulo do compasso" -- Needs review
La["Radius (yards)"] = "Raio (metros)" -- Needs review
-- La["red"] = ""
La["Red"] = "Vermelho" -- Needs review
-- La["Redirect GatherMate2 output to the HUD when visible"] = ""
-- La["remove one previously added area"] = ""
-- La["Remove one previously added area"] = ""
-- La["Reset All Settings"] = ""
-- La["Reset Position"] = ""
-- La["Resets all settings to defaults"] = ""
-- La["Resets window position to the center of the screen"] = ""
-- La["Right Click"] = ""
-- La["Scale main window Tooltips"] = ""
-- La["Scaling"] = ""
-- La["Show compass"] = ""
-- La["Show digsites on the Battlefield Minimap"] = ""
-- La["Show digsites on the Minimap"] = ""
-- La["Show GatherMate2 pins on the HUD (recomended)"] = ""
-- La["Show/Hide all %s areas"] = ""
-- La["show/hide all %s areas on the HUD"] = ""
-- La["Show/Hide Config"] = ""
-- La["show/hide digsites on minimap"] = ""
-- La["Show/Hide the HUD"] = ""
-- La["Show/Hide the Main Window"] = ""
-- La["Show/Hide window when entering/leaving a digsite"] = ""
-- La["Show/Hide window when you show/hide Archy addon"] = ""
-- La["Show Player Arrow"] = ""
-- La["Show Success Circle"] = ""
-- La["Show Tooltips"] = ""
-- La["Show Tooltips in the main window"] = ""
--[==[ La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = "" ]==]
-- La["Size of the main window"] = ""
-- La["Size of the Player Arrow"] = ""
La["%s Line Alpha"] = "Tranparência da Linha %s" -- Needs review
La["%s Sector Alpha"] = "Transparência do Setor %s" -- Needs review
-- La["Success Circle Color"] = ""
-- La["Survey will succeed if fragment lies within this circle"] = ""
-- La["This will overwrite current settings!"] = ""
-- La["This will reset Main Window position"] = ""
-- La["Toggle with Archy"] = ""
-- La["Toggle with digsite"] = ""
-- La["Tooltips Scaling"] = ""
-- La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = ""
-- La["Vertical position of HUD relative to screen center"] = ""
-- La["Visible"] = ""
-- La["Visual Settings"] = ""
-- La["Whether window is visible"] = ""
-- La["yellow"] = ""
-- La["Yellow"] = ""
-- La["You can also use %s command for this action"] = ""

elseif locale == "itIT" then do end
-- La["add new %s zone to the HUD"] = ""
La["Add %s area to the HUD"] = "Aggiungi un'area %s all'interfaccia" -- Needs review
La["Alpha"] = "Alfa" -- Needs review
-- La["Annulus Sectors Settings"] = ""
La["Archaeology Helper"] = "Archaelogy Helper" -- Needs review
La["Arch nodes only"] = "Solo nodi ad arco" -- Needs review
-- La["Arrow Alpha"] = ""
La["Arrow Scaling"] = "Scala il Puntatore" -- Needs review
La["Audio Settings"] = "Impostazioni Audio" -- Needs review
-- La["Automatically mount when adding this color to the HUD"] = ""
-- La["cast Survey"] = ""
La["Cast Survey"] = "Lancia Rilevamento" -- Needs review
-- La["clear HUD"] = ""
-- La["Color of Compass Direction Marks (you can also set alpha here)"] = ""
-- La["Color of the Compass Circle (you can also set alpha here)"] = ""
-- La["Color of the Success Circle (you can also set alpha here)"] = ""
-- La["Compass Circle Color"] = ""
La["Compass Settings"] = "Impostazioni della Bussola" -- Needs review
La["Dig Sites"] = "Siti di Scavo" -- Needs review
-- La["Direction Marks Color"] = ""
La["Display minimap icon"] = "Mostra icona sulla minimappa" -- Needs review
La["Draw arrow in the center of the HUD"] = "Disegna il puntatore al centro dell'HUD" -- Needs review
La["Draw compass-like circle on the HUD"] = "Disegna cerchi simili ad una Bussola sull'HUD" -- Needs review
La["General HUD Settings"] = "Impostazioni Generali dell'HUD" -- Needs review
-- La["green"] = ""
La["Green"] = "Verde" -- Needs review
La["Hide on combat"] = "Nascondi durante il combattimento" -- Needs review
La["Hide when resting"] = "Nascondi quando riposi" -- Needs review
La["Horizontal position of HUD relative to screen center"] = "Posizione orizzontale dell'HUD relativa al centro dello schermo" -- Needs review
La["How transparent is HUD"] = "Trasparenza HUD" -- Needs review
La["How transparent is Player Arrow"] = "Trasparenza del Puntatore del Giocatore" -- Needs review
La["How transparent is %s Annulus Sector"] = "Trasparenza del Settore Anulare %s" -- Needs review
La["How transparent is %s Direction Line"] = "Trasparenza della Linea di Direzione %s" -- Needs review
La["How transparent is window"] = "Trasparenza della Finestra" -- Needs review
La["HUD"] = "HUD" -- Needs review
La["HUD Alpha"] = "HUD Alfa" -- Needs review
La["HUD Scaling"] = "Scala dell'HUD" -- Needs review
La["HUD settings"] = "Impostazioni dell'HUD" -- Needs review
La["HUD X-Offset"] = "HUD X-Offset" -- Needs review
La["HUD Y-Offset"] = "HUD Y-Offset" -- Needs review
La["Key Bindings Settings"] = "Impostazioni Tasti" -- Needs review
La["Left Click"] = "Click Sinistro" -- Needs review
La["Locked"] = "Bloccato" -- Needs review
La["Locks window to prevent accidental repositioning"] = "Blocca la finestra per evitare un riposizionamento accidentale" -- Needs review
La["Main Window"] = "Finestra Principare" -- Needs review
La["Main window settings"] = "Impostazioni della Finestra Principale" -- Needs review
La["Middle Click"] = "Click Centrale" -- Needs review
La["Minimap Icon"] = "Icona sulla minimappa" -- Needs review
-- La["Misc Settings"] = ""
-- La["Mount %s"] = ""
La["move window"] = "Muovi la finestra" -- Needs review
La["Only show Archaeology nodes from GatherMate2 on the HUD"] = "Mostra solo i nodi di Archeologia provenienti da GatherMate2 sull'HUD" -- Needs review
La["Open archaeology window"] = "Apri la Finestra di Archeologia" -- Needs review
La["Play confirmation sounds for various actions"] = "Esegui suoni di Conferma per varie Azioni" -- Needs review
La["Play Sounds"] = "Esegui i Suoni" -- Needs review
La["Radius of the compass circle"] = "Raggio del cerchio della Bussola" -- Needs review
La["Radius (yards)"] = "Raggio(Yards)" -- Needs review
La["red"] = "Rosso" -- Needs review
La["Red"] = "Rosso" -- Needs review
La["Redirect GatherMate2 output to the HUD when visible"] = "Ridireziona l'output di GatherMate2 sull'HUD, quando visibile" -- Needs review
La["remove one previously added area"] = "Rimuovi un'area aggiunta precedentemente" -- Needs review
La["Remove one previously added area"] = "Rimuovi un'area precedentemente aggiunta." -- Needs review
La["Reset All Settings"] = "Resetta tutte le Impostazioni" -- Needs review
La["Reset Position"] = "Resetta la Posizione" -- Needs review
La["Resets all settings to defaults"] = "Resetta tutte le Impostazioni al valore iniziale" -- Needs review
La["Resets window position to the center of the screen"] = "Resetta la posizione della finestra al centro dello schermo" -- Needs review
La["Right Click"] = "Click destro" -- Needs review
-- La["Scale main window Tooltips"] = ""
La["Scaling"] = "Scala" -- Needs review
La["Show compass"] = "Mostra Bussola" -- Needs review
-- La["Show digsites on the Battlefield Minimap"] = ""
La["Show digsites on the Minimap"] = "Mostra i siti di scavo sulla minimappa" -- Needs review
La["Show GatherMate2 pins on the HUD (recomended)"] = "Mostra i punti di GatherMate2 sull'HUD (Raccomandato)" -- Needs review
La["Show/Hide all %s areas"] = "Mostra/Nascondi tutte le aree &s" -- Needs review
La["show/hide all %s areas on the HUD"] = "Mostra/Nascondi tutte le aree %s sull'HUD" -- Needs review
La["Show/Hide Config"] = "Mostra/Nascondi Configurazione" -- Needs review
La["show/hide digsites on minimap"] = "Mostra/Nascondi i siti di scavo sulla minimappa" -- Needs review
La["Show/Hide the HUD"] = "Mostra/Nascondi l'HUD" -- Needs review
La["Show/Hide the Main Window"] = "Mostra/Nascondi la Finestra principale" -- Needs review
La["Show/Hide window when entering/leaving a digsite"] = "Mostra/Nascondi la finestra quando entri/lasci un sito di scavo" -- Needs review
-- La["Show/Hide window when you show/hide Archy addon"] = ""
La["Show Player Arrow"] = "Mostra il puntatore del giocatore" -- Needs review
La["Show Success Circle"] = "Mostra il cerchio di successo" -- Needs review
-- La["Show Tooltips"] = ""
-- La["Show Tooltips in the main window"] = ""
La[ [=[Size of the HUD
If you need ZOOM - use Minimap ZOOM instead]=] ] = "Dimensione dell'HUD" -- Needs review
La["Size of the main window"] = "Dimensione della finestra principale" -- Needs review
La["Size of the Player Arrow"] = "Dimensione del puntatore del giocatore" -- Needs review
-- La["%s Line Alpha"] = ""
-- La["%s Sector Alpha"] = ""
La["Success Circle Color"] = "Colore del cerchio di successo" -- Needs review
-- La["Survey will succeed if fragment lies within this circle"] = ""
La["This will overwrite current settings!"] = "Questo sovrascriverà le impostazioni attuali!" -- Needs review
La["This will reset Main Window position"] = "Questo resetterà la posizione della finestra principale" -- Needs review
-- La["Toggle with Archy"] = ""
-- La["Toggle with digsite"] = ""
-- La["Tooltips Scaling"] = ""
-- La["Use |cff69ccf0Shift-M|r to open or hide Battlefield Minimap"] = ""
La["Vertical position of HUD relative to screen center"] = "Posizione verticale dell'HUD relativa al centro dello schermo" -- Needs review
-- La["Visible"] = ""
-- La["Visual Settings"] = ""
-- La["Whether window is visible"] = ""
La["yellow"] = "Giallo" -- Needs review
-- La["Yellow"] = ""
-- La["You can also use %s command for this action"] = ""

end
