--[[
SayMyName 0.59
09/24/2013
Author of SayMyName: Bubblesz of Echo Isles-[US]
Former-Authors: Vux of Dragonblight-[US] & CKlausi of Biny of Anetheron-[EU]

Description:
Alerts you with a sound when someone says your name in chat. To use, type /saymyname. Updated by Bubblesz of Echo Isles
]]--

function SayMyName_OnLoad(self)
	self:RegisterEvent("CHAT_MSG_CHANNEL")
	self:RegisterEvent("CHAT_MSG_EMOTE")
	self:RegisterEvent("CHAT_MSG_GUILD")
	self:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
	self:RegisterEvent("CHAT_MSG_OFFICER")
	self:RegisterEvent("CHAT_MSG_PARTY")
	self:RegisterEvent("CHAT_MSG_PARTY_LEADER")
	self:RegisterEvent("CHAT_MSG_RAID")
	self:RegisterEvent("CHAT_MSG_RAID_BOSS_EMOTE")
	self:RegisterEvent("CHAT_MSG_RAID_LEADER")
	self:RegisterEvent("CHAT_MSG_RAID_WARNING")
	self:RegisterEvent("CHAT_MSG_INSTANCE")
	self:RegisterEvent("CHAT_MSG_SAY")
	self:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
	self:RegisterEvent("CHAT_MSG_WHISPER")
	self:RegisterEvent("CHAT_MSG_YELL")

	self:RegisterEvent("ADDON_LOADED")

	SLASH_MYSLASHCOMMANDS1 = "/saymyname";
	SLASH_MYSLASHCOMMANDS2 = "/smn"
	SlashCmdList["MYSLASHCOMMANDS"] = SayMyName_SlashCommandHandler;
end

-- ##################################################

function SayMyName_OnEvent(self, event, ...)

	--local player_name = strlower( UnitName("player") )
	arg1, arg2, arg3, arg4 = ...

	---------------------------------------------------------------------------
	-- Initialize Table of Names

	if ( event == "ADDON_LOADED" and arg1 == "SayMyName" ) then
		if ( not namesTable ) then
			ChatFrame1:AddMessage("SayMyName First Run")
			namesTable = { UnitName("player") }
		end
		if ( not ignoredPlayers ) then
			ignoredPlayers = { }
		end
	end

	---------------------------------------------------------------------------
	-- Feast

	if ( event == "CHAT_MSG_MONSTER_EMOTE" ) then
		if ( strfind(arg1, "Feast") ) then
			SayMyName_output( "Feast", arg2, arg1 )
		end
	end

	---------------------------------------------------------------------------
	-- Emote directed at you

	if ( event == "CHAT_MSG_EMOTE" or event == "CHAT_MSG_TEXT_EMOTE" ) then
		if ( SayMyName_LookForNames(arg1, arg2) or strfind(arg1, "you") ) then
			SayMyName_output( "Emote", arg2, arg1 )
		end
	end

	---------------------------------------------------------------------------
	-- Someone said your name (or nickname/trigger) in chat

	if ( SayMyName_LookForNames(arg1, arg2) ) then

		if ( event == "CHAT_MSG_CHANNEL" ) then
			SayMyName_output( arg4, arg2, arg1 )

		elseif ( event == "CHAT_MSG_SAY" ) then
			SayMyName_output( "Say", arg2, arg1 )

		elseif ( event == "CHAT_MSG_PARTY" ) then
			SayMyName_output( "Party", arg2, arg1 )

		elseif ( event == "CHAT_MSG_PARTY_LEADER" ) then
			SayMyName_output( "Party_Leader", arg2, arg1 )
			
		elseif ( event == "CHAT_MSG_GUILD" ) then
			SayMyName_output( "Guild", arg2, arg1 )

		elseif ( event == "CHAT_MSG_OFFICER" ) then
			SayMyName_output( "Officer", arg2, arg1 )

		elseif ( event == "CHAT_MSG_RAID" ) then
			SayMyName_output( "Raid", arg2, arg1 )

		elseif ( event == "CHAT_MSG_RAID_BOSS_EMOTE" ) then
			SayMyName_output( "Boss_Emote", arg2, arg1 )

		elseif ( event == "CHAT_MSG_RAID_LEADER" ) then
			SayMyName_output( "Raid_Leader", arg2, arg1 )

		elseif ( event == "CHAT_MSG_RAID_WARNING" ) then
			SayMyName_output( "Raid_Warning", arg2, arg1 )
			
		elseif ( event == "CHAT_MSG_INSTANCE" ) then
			SayMyName_output( "Instance", arg2, arg1 )

		elseif ( event == "CHAT_MSG_WHISPER" ) then
			SayMyName_output( "Whisper", arg2, arg1 )

		elseif ( event == "CHAT_MSG_YELL" ) then
			SayMyName_output( "Yell", arg2, arg1 )

		end

	end
	---------------------------------------------------------------------------

end

-- ##################################################

function SayMyName_LookForNames( message, speaker )

	if ( not speaker ) then
		return false -- to prevent errors from messages without a speaker
	end

	for i=1,# namesTable do
		message = strlower(message)
		speaker = strlower(speaker)
		
		if (	strfind( message, strlower(namesTable[i]) )			-- message contains a trigger
			and ( not strfind( message, "%a"..strlower(namesTable[i]) )	-- if there are any letters before trigger
			and not strfind( message, strlower(namesTable[i]).."%a" ) )	-- or any letters after trigger

		) then
			if ( #ignoredPlayers > 0 ) then
				ignored_found = 0
				for i=1,# ignoredPlayers do
					if ( speaker == ignoredPlayers[i] ) then
						ignored_found = 1
					end
				end
				if ( ignored_found == 0 ) then
					return true
				end
			else
				return true
			end
		end

	end

	return false

end

-- ##################################################

function SayMyName_output(channel_name, speaker, message)

	ChatFrame7:AddMessage(	channel_name .. " [" .. speaker .."]: " .. message, 0.0, 1.0, 0.0)
	UIErrorsFrame:AddMessage(	channel_name .. " [" .. speaker .."]: " .. message, 0.0, 1.0, 0.0, 5.0)
	PlaySound( "AuctionWindowClose","Master")
end

-- ##################################################

function SayMyName_SlashCommandHandler(cmd)

	local command, arg1 = strsplit(" ", cmd)

	if ( command == "add" ) then

		if ( arg1 == "" or arg1 == nil ) then
			ChatFrame1:AddMessage("Error Adding: No nickname/trigger given")
		else
			ChatFrame1:AddMessage("Adding: " .. arg1)
			table.insert( namesTable, strlower(arg1) )
		end

	elseif ( command == "remove" ) then

		if ( arg1 == "" or arg1 == nil ) then
			ChatFrame1:AddMessage("Error Removing: No nickname/trigger given")
		else
			local namefound = 0
			for i=1,# namesTable do
				if ( namesTable[i] == strlower(arg1) ) then
					ChatFrame1:AddMessage("Removing: " .. arg1)
					table.remove( namesTable, i )
					namefound = 1;
				end
			end
			if ( namefound == 0 ) then
				print("Error Removing: Nickname/trigger not found")
			end
		end

	elseif ( command == "ignore" ) then

		if ( arg1 == "" or arg1 == nil ) then
			ChatFrame1:AddMessage("Error Ignoring: No nickname/trigger given")
		else
			ChatFrame1:AddMessage("Now Ignoring: " .. arg1)
			table.insert( ignoredPlayers, strlower(arg1) )
		end

	elseif ( command == "unignore" ) then

		if ( arg1 == "" or arg1 == nil ) then
			ChatFrame1:AddMessage("Error Unignoring: No nickname/trigger given")
		else
			local namefound = 0
			for i=1,# ignoredPlayers do
				if ( ignoredPlayers[i] == strlower(arg1) ) then
					ChatFrame1:AddMessage("Unignoring: " .. arg1)
					table.remove( ignoredPlayers, i )
					namefound = 1;
				end
			end
			if ( namefound == 0 ) then
				print("Error Unignoring: Player not found")
			end
		end

	else
		ChatFrame1:AddMessage("SayMyName Updated by Bubblesz of Echo Isles")
		ChatFrame1:AddMessage("SayMyName Help:")
		ChatFrame1:AddMessage("   /saymyname add <trigger>")
		ChatFrame1:AddMessage("   /saymyname remove <trigger>")
		ChatFrame1:AddMessage("   /saymyname ignore <player>")
		ChatFrame1:AddMessage("   /saymyname unignore <player>")

		ChatFrame1:AddMessage("Current Triggers (not case sensitive): " )
		for i=1,# namesTable do
			ChatFrame1:AddMessage( "   " .. namesTable[i] )
		end
		ChatFrame1:AddMessage("Currently Ignored Players (not case sensitive): " )
		for i=1,# ignoredPlayers do
			ChatFrame1:AddMessage( "   " .. ignoredPlayers[i] )
		end

	end

end

