-- @release $Id: Bars.lua 426 2016-08-18 01:41:53Z reighnman $

if not SlamAndAwe then return end

SlamAndAwe.barTable = {}

--/run print(SlamAndAwe:barPos(SlamAndAwe.constants["Battle Cry ID"]))
function SlamAndAwe:barPos(spellid)
  local loc = 1
  for k,v in pairs(SlamAndAwe.barTable) do
    if v == spellid then
      loc = k
    end
  end

  return loc
end

--/run SlamAndAwe:barPosTest(SlamAndAwe.constants["Dragon Roar ID"])
function SlamAndAwe:barPosTest(spellid)
  local loc = 1
  for k,v in pairs(SlamAndAwe.barTable) do
    if v == spellid then
      loc = k
    end
  end

  print (loc)
end

--/run SlamAndAwe:barPosTest(SlamAndAwe.constants["Dragon Roar ID"])
function SlamAndAwe:barPosUpdate()

  local barHeight = SlamAndAwe.db.char.fHeight / 7
  local baseOffset = (-1 * barHeight) + 3

  for k,v in pairs(SlamAndAwe.barTable) do
    v:SetPoint("TOPLEFT", SlamAndAwe.BaseFrame, "TOPLEFT", barHeight, k * baseOffset)
  end
end

function SlamAndAwe:barInsert(spellid)
  if not tContains(SlamAndAwe.barTable, spellid) then
    tinsert(SlamAndAwe.barTable, spellid)
    if SlamAndAwe.db.char.debug then
      print("Added ", spellid)
      print("Size is now ", getn(SlamAndAwe.barTable))
    end
    SlamAndAwe:barPosUpdate()
  end
  --SlamAndAwe:RedrawFrames() Redraw frames has protected functions and hides bars... needs alot work
end

--/run SlamAndAwe:barRemove(SlamAndAwe.constants["Commanding Shout ID"])
--/run print(SlamAndAwe:KeyPos(SlamAndAwe.barOffset,SlamAndAwe.constants["Last Stand ID"]))
function SlamAndAwe:barRemove(spellid)
  for k,v in pairs(SlamAndAwe.barTable) do
    if v == spellid then
      table.remove(SlamAndAwe.barTable,k)
      if SlamAndAwe.db.char.debug then
        print("Removed ", spellid)
        print("Size is now ", getn(SlamAndAwe.barTable))
      end
      SlamAndAwe:barPosUpdate()
    end
  end
  --SlamAndAwe:RedrawFrames() Redraw frames has protected functions and hides bars... needs alot work
end

--/run SlamAndAwe:test1()
function SlamAndAwe:test1()
  SlamAndAwe:barInsert(SlamAndAwe.constants["Dragon Roar ID"])
  SlamAndAwe:barInsert(SlamAndAwe.constants["Commanding Shout ID"])
  SlamAndAwe:barInsert(SlamAndAwe.constants["Last Stand ID"])
  SlamAndAwe:barInsert(SlamAndAwe.constants["Battle Cry ID"])
  SlamAndAwe:barInsert(SlamAndAwe.constants["Avatar ID"])

  print(getn(SlamAndAwe.barTable))
end

--/run SlamAndAwe:DebugPrintTable(SlamAndAwe.frames["FocusedRage"])
function SlamAndAwe:DebugPrintTable(t)
  for k,v in pairs(t) do
    print (k,v)
  end
end
