-- @release $Id: Options.lua 445 2016-08-31 11:29:44Z reighnman $

if not SlamAndAwe then return end

local L = LibStub("AceLocale-3.0"):GetLocale("SlamAndAwe")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
if not C then
  SlamAndAwe:SetConstants()
end
local _, _, _, clientVersion = GetBuildInfo()

SlamAndAwe.emptyOptions = { "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }
SlamAndAwe.furyOptions = { "bc", "ava_bbc", "odf", "ram_mass100", "br_out", "drr_apl", "ava_dr", "blb_dr", "bc_dr", "ram_ne", "fur_fr3", "ex_wtf", "ava_dr", "blb_dr", "bc_dr", "ram_ne", "fur_fr3", "ex_wtf", "bt_ir", "whwi_ir", "rb_en", "whwi_wben", "ex_wtf2", "bt_en", "rb", "bt", "fur", "none", "none", "none" }
SlamAndAwe.protectionOptions = { "igpa_ra", "igpa_du", "fr_90", "shbl_ip", "shs", "reve", "deva", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }
SlamAndAwe.armsOptions = { "bc_cs", "ava_apl1", "rend_2s", "cs_ncs", "war_ncs", "rav", "ovpo", "most", "ex_sh", "cs_apl1", "war_nsd", "fr_apl1", "sl_apl1", "whwi_apl3", "rend_03", "whwi_apl2", "sl_apl2", "shw", "stb", "blst", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }
SlamAndAwe.furyAOEOptions = { "whwi_mc", "ram_apl1", "bt_en", "rb_ir", "drr", "bt", "whwi", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }
SlamAndAwe.armsAOEOptions = { "bc_cs", "ava_apl1", "rend_2s", "cs_ncs", "war_ncs", "rav", "ovpo", "most", "ex_sh", "cs_apl1", "war_nsd", "whwi_apl1", "rend_03", "blst", "cle", "whwi_60", "shw", "stb", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }

SlamAndAwe.fonteffects = {
  ["none"] = L["None"],
  ["OUTLINE"] = L["OUTLINE"],
  ["THICKOUTLINE"] = L["THICKOUTLINE"],
  ["MONOCHROME"] = L["MONOCHROME"],
}

-------------------
-- Config details
-------------------
function SlamAndAwe:SetDefaultOptions()
  SlamAndAwe.defaults = {
    char = {
      disabled = false,
      specchangewarning = true,
      message = "Welcome Home!",
      movingframes = false,
      showicons = true,
      relativeTo = "UIParent",
      relativePoint = "CENTER",
      point = "CENTER",
      texture = "Blizzard",
      barfont = "Friz Quadrata TT",
      barfontsize = 12,
      barfonteffect = "none",
      msgfont = "Friz Quadrata TT",
      msgfontsize = 24,
      msgfonteffect = "none",
      border = "None",
      barborder = "Blizzard Tooltip",
      fr3flash = true,
      fr3sound = "Sound\\SPELLS\\SlowTaget.ogg",
      fr3soundname = "SAA Maelstrom 2",
      tfb5flash = true,
      tfb4sound = "Sound\\Spells\\ShootWandLaunchLightning.wav",
      tfb4soundname = "SAA Maelstrom 1",
      tfb5sound = "Sound\\SPELLS\\SlowTaget.ogg",
      tfb5soundname = "SAA Maelstrom 2",
      shieldsound = "Sound\\Doodad\\BellowIn.wav",
      shieldsoundname = "SAA Shield 1",
      weaponsound = "Sound\\Doodad\\BellowIn.wav",
      weaponsoundname = "SAA Shield 1",
      framestratalevel = "LOW",
      xOffset = 0,
      yOffset = -220,
      fWidth = 300,
      fHeight = 175,
      resetOn = true,
      scale = 1,
      ShockPercent = .6,
      ShearPercent = .6,
      shockshow = true,
      shearshow = false,
      ssshow = true,
      firetotemshow = true,
      wfshow = true,
      fsdotshow = true,
      gcdshow = true,
      gcdfullwidth = false,
      fnshow = true,
      fsshow = true,
      petshow = false,
      disablebars = false,
      maelstromTalents = 0,
      feralSpiritTalented = false,
      tfb4soundplay = true,
      tfb5soundplay = true,
      tfb5repeat = 3,
      tfbflash = true,
      shieldshow = true,
      tfbshow = true,
      tfbstacks = 0,
      frshow = true,
      frstacks = 0,
      frflash = true,
      fr3repeat = 3,
      fr3soundplay = true,
      arena = false,
      barstext = true,
      SSlen = 8,
      maxLen = 10,

      --SlamAndAwe
      rageshow = true,
      hsshow = true,
      rageThreshold = 90,
      csshow = true,
      bcshow = true,
      bbshow = true,
      ipshow = true,
      sblshow = true,
      swshow = true,
      avashow = true,
      drshow = true,
      demoshoutshow = true,
      laststandshow = true,
      commandingshoutshow = true,
      CSLen = 8,
      BBLen = 6,
      IPLen = 15,
      ipMultiplier = 1,
      SBlLen = 6,
      SWLen = 8,
      BCLen = 9,
      AVALen = 20,
      TFBLen = 8,
      FRLen = 30,
      CSHLen = 10,
      threatThreshold = 90,
      DSLen = 8,
      LSLen = 15,
      enableTimeRemaining = false,
      enableDisableBorder = false,
      hideRageBarOOC = false,
      enableProtSpec = true,
      enableFurySpec = true,
      enableArmsSpec = true,
      currentspec = "None",

      --Talents
      talFrenzy = false,
      talAvatar = false,
      talDauntless = false,
      talOutburst = false,
      talBloodbath = false,
      talMassacre = false,
      talInnerRage = false,
      talDragonRoar = false,
      talHeavyRepercussions = false,
      talInForTheKill = false,
      talFervorOfBattle = false,
      talFocusedRage = false,
      talDeadlyCalm = false,
      talVengeance = false,
      talCracklingThunder = false,

      --SlamAndAwe Announcements
      announce_skull_banner = true,
      announce_skull_banner_where = 1,
      announce_demoralizing_banner = true,
      announce_demoralizing_banner_where = 1,
      announce_mocking_banner = true,
      announce_mocking_banner_where = 1,
      announce_interrupt = true,
      announce_interrupt_where = 1,
      announce_laststand= true,
      announce_laststand_where = 1,
      announce_shieldwall= true,
      announce_shieldwall_where = 1,
      sBannerLen = 10,
      dBannerLen = 15,
      mBannerLen = 30,

      --SlamAndAwe CDs
      PurgeLen = 10,
      RagingBlowLen = 6,
      BloodthirstLen = 3,
      BattleShoutLen = 30,
      ColossusSmashLen = 20,
      AVALen = 90,
      DRLen = 6,
      ShockLen = 6,
      ShearLen = 6,
      lastshock = "",
      debug = false,
      msg = { r = 1, g = .5, b = 0, },
      msgtime = 2,
      newsitem = 0,
      castweaponrebuff = false,
      MSBToutputarea = "Notification",
      colors = {
        watershield = { r=.6, g=.6, b=1, a=.3 },
        lightningshield = { r=0, g=0, b=1, a=.5 },
        earthshield = { r=0, g=1, b=0, a=.5 },
        noshield = { r=1, g=0, b=0, a=1 },

        flameshock = { r=1, g=.6, b=.2, a=.9 },
        flameshockDot = { r=1, g=.6, b=.2, a=.6 },
        earthshock = { r=0, g=1, b=.3, a=.9 },
        frostshock = { r=.6, g=.6, b=1, a=.9 },
        windshear = { r=.6, g=.6, b=.6, a=.9 },
        magma = { r=.9, g=.4, b=0, a=.9 },
        feralspiritCD = { r=0, g=.6, b=.95, a=.9 },
        stormstrike = { r=1, g=1, b=.2, a=.9 },
        firenova = { r=1, g=.9, b=.4, a=.9 },
        windfury = { r=1, g=0, b=0, a=.5 },

        --SlamAndAwe

        rage = { r=1, g=0, b=0, a=.9 },
        sixtyrage = { r=0, g=1, b=0, a=.9},
        bloodthirst = { r=0, g=1, b=.3, a=.9 },
        ragingblow = { r=0, g=1, b=.3, a=.9 },
        bloodsurge = { r=0, g=1, b=.3, a=.9 },
        slam = { r=0, g=1, b=.3, a=.9 },
        heroicstrike = { r=0, g=1, b=.3, a=.9 },
        purge = { r=0, g=1, b=.3, a=.9 },
        colossussmash = { r=1, g=.8, b=0, a=.9 },
        avatar = { r=.5, g=.8, b=1, a=.9 },
        dragonroar = { r=1, g=.8, b=0, a=.9 },
        tfb = { r=1, g=.5, b=1, a=.3 },
        tfbalpha = .3,
        tfbalphaFull = .9,
        fr = { r=1, g=.4, b=2, a=.3 },
        fralpha = .3,
        fralphaFull = .9,
        battlecry = { r=1, g=.6, b=0, a=.9 },
        bloodbath = { r=1, g=.13, b=0, a=.9 },

        ignorepain = { r=.7, g=0, b=.7, a=.9 },
        shieldblock = { r=0, g=.8, b=0, a=.9 },
        shieldwall = { r=0, g=0, b=.8, a=.9 },
        demoshout = { r=.8, g=.4, b=0, a=.9},
        laststand = { r=.8, g=.8, b=0, a=.9},
        commandingshout = {r=.1,g=.1,b=.8, a=.9},
      },
      uptime = {
        show = true,
        fWidth = 130,
        fHeight = 140,
        barWidth = 100,
        barHeight = 20,
        relativeTo = "UIParent",
        relativePoint = "RIGHT",
        point = "CENTER",
        xOffset = -100,
        yOffset = 0,
        alpha = 0.4,
        scale = 1,
        -- flurry = { r = .2, g = .1, b = 1, a = 0.5, },
        ip = { r = .2, g = .1, b = 1, a = 0.5, },
        en = { r = 1, g = 1, b = .8, a = 0.5, },
        sb = { r = 1, g = .5, b = 0, a = 0.5, },
      },
      stats = {
        show = true,
        fWidth = 120,
        fHeight = 200,
        barWidth = 100,
        barHeight = 20,
        relativeTo = "SlamAndAwe.UptimeFrame",
        relativePoint = "TOPLEFT",
        point = "TOPLEFT",
        xOffset = 125,
        yOffset = 0,
        alpha = 0.4,
        scale = 1,
        wfcalc = true,
        wfcol = { r = 1, g = .5, b = 0, a = 0.8, },
        wftime = 2,
        best = {
          ap = 0,
          spellpower = 0,
          meleehit = 0,
          spellhit = 0,
          expertise = 0,
          meleecrit = 0,
          spellcrit = 0,
          wfmh = 0,
          wfoh = 0,
          stormstrike = 0,
        },
      },
      priority = {
        show = true,
        barborder = "Blizzard Tooltip",
        enableDisablePriorityBorder = "false",
        titleshow = false,
        relativeTo = "UIParent",
        relativePoint = "CENTER",
        point = "CENTER",
        fWidth = 50,
        fHeight = 50,
        xOffset = -215,
        yOffset = -60,
        alpha = 0.4,
        scale = 1,
        next = 1,
        cooldown = 0.5,
        fsticksleft = 2,
        totemtimeleft = 20,
        srmana = 10,
        wsmana = 0,
        shieldorbs = 1,
        magmaticks = 2,
        firetotemtime = 0,
        searingticks = 0,
        worldbossonly = true,
        hideImmune = true,
        -- combopoints = true,
        showpurge = true,
        showinterrupt = true,
        showcooldown = true,
        armsaoethreshold = 3,
        furyaoethreshold = 2,
        prOption = SlamAndAwe.singleOptions,
        groupnumber = 1,
        prOptions = {
          SlamAndAwe.furyOptions,
          SlamAndAwe.protectionOptions,
          SlamAndAwe.armsOptions,
          SlamAndAwe.furyAOEOptions,
          SlamAndAwe.armsAOEOptions }
      },
      ragebar = {
        relativeTo = "UIParent",
        relativePoint = "CENTER",
        point = "CENTER",
        fWidth = 300,
        fHeight = 20,
        xOffset = 0,
        yOffset = -120,
        alpha = 1,
        scale = 1,
        framestratalevel = "LOW",
        enableDisableRageBarBorder = "false",
        texture = "Blizzard",
        barfont = "Friz Quadrata TT",
        barfontsize = 12,
        barfonteffect = "none",
        barborder = "Blizzard Tooltip",
      },
      binding = {
        show = true,
        relativeTo = "UIParent",
        relativePoint = "CENTER",
        point = "CENTER",
        fWidth = 200,
        fHeight = 50,
        xOffset = -200,
        yOffset = -100,
        alpha = 0.4,
        scale = 1,
        mhspell = SlamAndAwe.constants["Windfury Weapon"],
        ohspell = SlamAndAwe.constants["Flametongue Weapon"],
        macroset = false,
      },
      warning = {
        show = true,
        duration = 3,
        shield = false,
        weapon = true,
        range = true,
        grounding = true,
        interrupt = true,
        purge = true,
        timeleft = 300,
        color = { r = 1, g = .5, b = 0, a = 0.5, },
        relativeTo = "UIParent",
        relativePoint = "TOP",
        point = "CENTER",
        fWidth = 600,
        fHeight = 100,
        xOffset = 0,
        yOffset = -250,
      },
    }
  }
end

function SlamAndAwe:VerifyOptions()
  SlamAndAwe.db.char.priority.option = nil -- remove old format of options
  SlamAndAwe.db.char.priority.options = nil
  if not SlamAndAwe.db.char.priority.prOption then -- fix for corruption in v5.50
    SlamAndAwe.db.char.priority.prOption = SlamAndAwe.emptyOptions
    SlamAndAwe:Print(L["SlamAndAwe Warning : No options set"])
  end
  for index = 1, 30 do
    if not SlamAndAwe.db.char.priority.prOption[index] then
      SlamAndAwe.db.char.priority.prOption[index] = "none"
    end
  end
  for group = 1, 5 do
    for index = 1, 30 do
      if not SlamAndAwe.db.char.priority.prOptions[group][index] then
        SlamAndAwe.db.char.priority.prOptions[group][index] = "none"
      end
    end
  end
end

function SlamAndAwe:GetOptions()
  local options = {
    name = "SlamAndAwe",
    handler = SlamAndAwe,
    type='group',
    childGroups ='tree',
    args = {
      priority = {
        name = L["Priority Options"],
        type = 'group',
        childGroups = 'tab',
        order = 1,
        args = {
          priority_general = {
            type = "group",
            order= 200,
            name = L["General"],
            args = {

              priority = {
                type = 'toggle',
                name = L["Priority Frame"],
                desc = L["help_priority"],
                get = "priorityQuery",
                set = "ActivatePriority",
                order = 40,
              },

              showinterrupt = {
                type = 'toggle',
                name = L["Show Interrupt"],
                desc = L["help_showinterrupt"],
                get = "showinterruptQuery",
                set = "ActivateShowInterrupt",
                order = 41,
              },

              -- heroicstrike = {
              -- type = 'toggle',
              -- name = SlamAndAwe.constants["Heroic Strike"],
              -- desc = L["help_heroicstrike"],
              -- get = "heroicstrikeQuery",
              -- set = "ActivateHeroicStrike",
              -- order = 44,
              -- },
              -- rage = {
              -- type = 'range',
              -- name = L["HS Rage Threshold"],
              -- desc = L["help_hsrage"],
              -- min = 1,
              -- max = 120,
              -- step = 1,
              ---- get = "GetRageThreshold",
              -- set = "SetRageThreshold",
              -- order = 45,
              -- },
              showcooldown = {
                type = 'toggle',
                name = L["Show Cooldown"],
                desc = L["help_showcooldown"],
                get = "showcooldownQuery",
                set = "ActivateShowCooldown",
                order = 42,
              },
              cooldown = {
                type = 'range',
                name = L["Cooldown Threshold"],
                desc = L["help_cooldown"],
                min = 0,
                max = 1.5,
                step = 0.05,
                get = "GetCooldownThreshold",
                set = "SetCooldownThreshold",
                order = 43,
              },
              furyaoethresh = {
                type = 'range',
                name = L["Fury AOE Threshold"],
                desc = L["help_aoe_threshold"],
                min = 2,
                max = 41,
                step = 1,
                get = "GetFuryAOEThreshold",
                set = "SetFuryAOEThreshold",
                order = 44,
              },
              armsaoethresh = {
                type = 'range',
                name = L["Arms AOE Threshold"],
                desc = L["help_aoe_threshold"],
                min = 2,
                max = 41,
                step = 1,
                get = "GetArmsAOEThreshold",
                set = "SetArmsAOEThreshold",
                order = 45,
              },

              -- threat = {
              -- type = 'range',
              -- name = L["Threat Threshold"],
              -- desc = L["help_threat"],
              -- min = 75,
              -- max = 110,
              -- step = 1,
              -- get = "GetThreatThreshold",
              -- set = "SetThreatThreshold",
              -- guiHidden = true,
              -- order = 47,
              -- },

            },
          },

          priority_Display = {
            type = "group",
            order= 201,
            name = L["Display"],
            args = {
              priorityscale = {
                type = 'range',
                name = L["Priority Bar Scale"],
                desc = L["help_priority_scale"],
                min = 0.50,
                max = 3.00,
                step = 0.01,
                get = "GetPriorityScale",
                set = "SetPriorityScale",
                order = 41,
              },

              resetpriority = {
                type = 'execute',
                name = L["Reset"],
                desc = L["help_reset_priority_frame"],
                func = "ResetPriority",
                order = 49,
              },
            },
          },
          priority_media = {
            type = "group",
            order= 202,
            name = L["Media"],
            args = {
              title = {
                type = 'toggle',
                name = L["Display frame title"],
                get = "priorityTitleQuery",
                set = "ActivatePriorityTitle",
                order = 6,
              },

              priority_barborder = {
                type = 'select', dialogControl = 'LSM30_Border',
                name = L["Bar Border Texture"],
                get = "GetPriorityBorderTexture",
                set = "SetPriorityBorderTexture",
                values = AceGUIWidgetLSMlists.border,
                order = 7,
              },
              priority_enableDisableBorder = {
                type = 'toggle',
                name = L["Disable Border"],
                desc = L["help_enableDisablePriorityBorder"],
                get = "enableDisablePriorityBorderQuery",
                set = "ActivateEnableDisablePriorityBorder",
                order = 8,
              },

              -- priority_enableDisableBorder = {
              -- type = 'toggle',
              -- name = L["Disable Borders"],
              -- desc = L["help_enableDisableBorder"],
              -- get = "enableDisablePriorityBorderQuery",
              -- set = "ActivateEnableDisablePriorityBorder",
              -- order = 8,
              -- },
            },
          },

        },
      },

      priorities = {
        name = L["Set Priorities"],
        type='group',
        childGroups ='tree',
        order = 2,
        args = {
          prioritygroup = {
            type = 'select',
            name = L["Priority Group"],
            get = "GetPriorityGroup",
            set = "SetPriorityGroup",
            values = { L["Fury Priorities"], L["Protection Priorities"], L["Arms Priorities"], L["Fury AOE Priorities"], L["Arms AOE Priorities"] },
            order = 100,
          },
          priority1 = {
            type = 'select',
            name = L["First Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(1),
            set = SlamAndAwe:SetPriority(1),
            values = SlamAndAwe.priorityTable.name,
            order = 101,
            desc = SlamAndAwe:GetPriorityDesc(1),
          },
          priority2 = {
            type = 'select',
            name = L["Second Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(2),
            set = SlamAndAwe:SetPriority(2),
            values = SlamAndAwe.priorityTable.name,
            order = 102,
            desc = SlamAndAwe:GetPriorityDesc(2),
          },
          priority3 = {
            type = 'select',
            name = L["Third Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(3),
            set = SlamAndAwe:SetPriority(3),
            values = SlamAndAwe.priorityTable.name,
            order = 103,
            desc = SlamAndAwe:GetPriorityDesc(3),
          },
          priority4 = {
            type = 'select',
            name = L["Fourth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(4),
            set = SlamAndAwe:SetPriority(4),
            values = SlamAndAwe.priorityTable.name,
            order = 104,
            desc = SlamAndAwe:GetPriorityDesc(4),
          },
          priority5 = {
            type = 'select',
            name = L["Fifth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(5),
            set = SlamAndAwe:SetPriority(5),
            values = SlamAndAwe.priorityTable.name,
            order = 105,
            desc = SlamAndAwe:GetPriorityDesc(5),
          },
          priority6 = {
            type = 'select',
            name = L["Sixth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(6),
            set = SlamAndAwe:SetPriority(6),
            values = SlamAndAwe.priorityTable.name,
            order = 106,
            desc = SlamAndAwe:GetPriorityDesc(6),
          },
          priority7 = {
            type = 'select',
            name = L["Seventh Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(7),
            set = SlamAndAwe:SetPriority(7),
            values = SlamAndAwe.priorityTable.name,
            order = 107,
            desc = SlamAndAwe:GetPriorityDesc(7),
          },
          priority8 = {
            type = 'select',
            name = L["Eighth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(8),
            set = SlamAndAwe:SetPriority(8),
            values = SlamAndAwe.priorityTable.name,
            order = 108,
            desc = SlamAndAwe:GetPriorityDesc(8),
          },
          priority9 = {
            type = 'select',
            name = L["Ninth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(9),
            set = SlamAndAwe:SetPriority(9),
            values = SlamAndAwe.priorityTable.name,
            order = 109,
            desc = SlamAndAwe:GetPriorityDesc(9),
          },
          priority10 = {
            type = 'select',
            name = L["Tenth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(10),
            set = SlamAndAwe:SetPriority(10),
            values = SlamAndAwe.priorityTable.name,
            order = 110,
            desc = SlamAndAwe:GetPriorityDesc(10),
          },
          priority11 = {
            type = 'select',
            name = L["Eleventh Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(11),
            set = SlamAndAwe:SetPriority(11),
            values = SlamAndAwe.priorityTable.name,
            order = 111,
            desc = SlamAndAwe:GetPriorityDesc(11),
          },
          priority12 = {
            type = 'select',
            name = L["Twelfth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(12),
            set = SlamAndAwe:SetPriority(12),
            values = SlamAndAwe.priorityTable.name,
            order = 112,
            desc = SlamAndAwe:GetPriorityDesc(12),
          },
          priority13 = {
            type = 'select',
            name = L["Thirteenth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(13),
            set = SlamAndAwe:SetPriority(13),
            values = SlamAndAwe.priorityTable.name,
            order = 113,
            desc = SlamAndAwe:GetPriorityDesc(13),
          },
          priority14 = {
            type = 'select',
            name = L["Fourteenth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(14),
            set = SlamAndAwe:SetPriority(14),
            values = SlamAndAwe.priorityTable.name,
            order = 114,
            desc = SlamAndAwe:GetPriorityDesc(14),
          },
          priority15 = {
            type = 'select',
            name = L["Fifteenth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(15),
            set = SlamAndAwe:SetPriority(15),
            values = SlamAndAwe.priorityTable.name,
            order = 115,
            desc = SlamAndAwe:GetPriorityDesc(15),
          },
          priority16 = {
            type = 'select',
            name = L["Sixteenth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(16),
            set = SlamAndAwe:SetPriority(16),
            values = SlamAndAwe.priorityTable.name,
            order = 116,
            desc = SlamAndAwe:GetPriorityDesc(16),
          },
          priority17 = {
            type = 'select',
            name = L["Seventeenth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(17),
            set = SlamAndAwe:SetPriority(17),
            values = SlamAndAwe.priorityTable.name,
            order = 117,
            desc = SlamAndAwe:GetPriorityDesc(17),
          },
          priority18 = {
            type = 'select',
            name = L["Eighteenth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(18),
            set = SlamAndAwe:SetPriority(18),
            values = SlamAndAwe.priorityTable.name,
            order = 118,
            desc = SlamAndAwe:GetPriorityDesc(18),
          },
          priority19 = {
            type = 'select',
            name = L["Nineteenth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(19),
            set = SlamAndAwe:SetPriority(19),
            values = SlamAndAwe.priorityTable.name,
            order = 119,
            desc = SlamAndAwe:GetPriorityDesc(19),
          },
          priority20 = {
            type = 'select',
            name = L["Twentieth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(20),
            set = SlamAndAwe:SetPriority(20),
            values = SlamAndAwe.priorityTable.name,
            order = 120,
            desc = SlamAndAwe:GetPriorityDesc(20),
          },
          priority21= {
            type = 'select',
            name = L["Twentyfirst Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(21),
            set = SlamAndAwe:SetPriority(21),
            values = SlamAndAwe.priorityTable.name,
            order = 121,
            desc = SlamAndAwe:GetPriorityDesc(21),
          },
          priority22 = {
            type = 'select',
            name = L["Twentysecond Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(22),
            set = SlamAndAwe:SetPriority(22),
            values = SlamAndAwe.priorityTable.name,
            order = 122,
            desc = SlamAndAwe:GetPriorityDesc(22),
          },
          priority23 = {
            type = 'select',
            name = L["Twentythird Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(23),
            set = SlamAndAwe:SetPriority(23),
            values = SlamAndAwe.priorityTable.name,
            order = 123,
            desc = SlamAndAwe:GetPriorityDesc(23),
          },
          priority24 = {
            type = 'select',
            name = L["Twentyfourth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(24),
            set = SlamAndAwe:SetPriority(24),
            values = SlamAndAwe.priorityTable.name,
            order = 124,
            desc = SlamAndAwe:GetPriorityDesc(24),
          },
          priority25 = {
            type = 'select',
            name = L["Twentyfifth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(25),
            set = SlamAndAwe:SetPriority(25),
            values = SlamAndAwe.priorityTable.name,
            order = 125,
            desc = SlamAndAwe:GetPriorityDesc(25),
          },
          priority26 = {
            type = 'select',
            name = L["Twentysixth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(26),
            set = SlamAndAwe:SetPriority(26),
            values = SlamAndAwe.priorityTable.name,
            order = 126,
            desc = SlamAndAwe:GetPriorityDesc(26),
          },
          priority27 = {
            type = 'select',
            name = L["Twentyseventh Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(27),
            set = SlamAndAwe:SetPriority(27),
            values = SlamAndAwe.priorityTable.name,
            order = 127,
            desc = SlamAndAwe:GetPriorityDesc(27),
          },
          priority28 = {
            type = 'select',
            name = L["Twentyeighth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(28),
            set = SlamAndAwe:SetPriority(28),
            values = SlamAndAwe.priorityTable.name,
            order = 128,
            desc = SlamAndAwe:GetPriorityDesc(28),
          },
          priority29 = {
            type = 'select',
            name = L["Twentyninth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(29),
            set = SlamAndAwe:SetPriority(29),
            values = SlamAndAwe.priorityTable.name,
            order = 129,
            desc = SlamAndAwe:GetPriorityDesc(29),
          },
          priority30 = {
            type = 'select',
            name = L["Thirtieth Priority"],
            width = 'full',
            get = SlamAndAwe:GetPriority(30),
            set = SlamAndAwe:SetPriority(30),
            values = SlamAndAwe.priorityTable.name,
            order = 130,
            desc = SlamAndAwe:GetPriorityDesc(30),
          },
        },
      },

      bars = {
        name = L["General Bar Options"],
        type = 'group',
        childGroups = 'tab',
        order = 3,
        args = {
          general = {
            type = "group",
            order= 200,
            name = L["General"],
            args = {
              enableTimeRemaining = {
                type = 'toggle',
                name = L["Enable Time Remaining"],
                desc = L["help_enableTimeRemaining"],
                get = "enableTimeRemainingQuery",
                set = "ActivateEnableTimeRemaining",
                order = 2,
              },

              abc = {
                type = 'toggle',
                name = L["Show bar icons"],
                desc = L["help_baricons"],
                get = "bariconsQuery",
                set = "ActivateBarIcons",
                order = 2,
              },
              icons = {
                type = 'toggle',
                name = L["Show bar icons"],
                desc = L["help_baricons"],
                get = "bariconsQuery",
                set = "ActivateBarIcons",
                order = 2,
              },
              gcdfullwidth = {
                type = 'toggle',
                name = L["GCD full width"],
                desc = L["help_gcd_fullwidth"],
                get = "gcdFullwidthQuery",
                set = "ActivateGCDfullwidth",
                order = 2
              },
              tb_break1 = {
                type = 'header',
                name = L["Misc Bars"],
                order = 3,
              },
              gcd = {
                type = 'toggle',
                name = L["GCD"],
                desc = L["help_gcd"],
                get = "gcdQuery",
                set = "ActivateGCD",
                order = 4,
              },
              CSHBar = {
                type = 'toggle',
                name = L["Commanding Shout Bar"],
                desc = L["help_CSH"],
                get = "commandingShoutQuery",
                set = "ActivateCommandingShout",
                order = 5,
              },
              tb_break2 = {
                type = 'header',
                name = L["DPS Bars"],
                order = 6,
              },
              CSbar = {
                type = 'toggle',
                name = L["Colossus Smash Bar"],
                desc = L["help_CS"],
                get = "colossussmashQuery",
                set = "ActivateColossusSmash",
                order = 7,
              },
              tfbbar = {
                type = 'toggle',
                name = L["Taste for Blood Bar"],
                desc = L["help_tfb"],
                get = "tfbQuery",
                set = "ActivateTasteForBlood",
                order = 8,
              },
              frbar = {
                type = 'toggle',
                name = L["Focused Rage Bar"],
                desc = L["help_fr"],
                get = "frQuery",
                set = "ActivateFocusedRage",
                order = 8,
              },
              AVAbar = {
                type = 'toggle',
                name = L["Avatar Bar"],
                desc = L["help_AVA"],
                get = "avatarQuery",
                set = "ActivateAvatar",
                order = 9,
              },
              DCbar = {
                type = 'toggle',
                name = L["Battle Cry Bar"],
                desc = L["help_BC"],
                get = "battlecryQuery",
                set = "ActivateBattleCry",
                order = 10,
              },
              BBbar = {
                type = 'toggle',
                name = L["Bloodbath Bar"],
                desc = L["help_RE"],
                get = "bloodbathQuery",
                set = "ActivateBloodbath",
                order = 11,
              },
              DRbar = {
                type = 'toggle',
                name = L["Dragon Roar Bar"],
                desc = L["help_DR"],
                get = "dragonroarQuery",
                set = "ActivateDragonRoar",
                order = 12,
              },
              tb_break3 = {
                type = 'header',
                name = L["Protection Bars"],
                order = 13,
              },
              IPbar = {
                type = 'toggle',
                name = L["Ignore Pain Bar"],
                desc = L["help_IP"],
                get = "ignorepainQuery",
                set = "ActivateIgnorePain",
                order = 14,
              },
              SBlbar = {
                type = 'toggle',
                name = L["Shield Block Bar"],
                desc = L["help_SBl"],
                get = "shieldblockQuery",
                set = "ActivateShieldBlock",
                order = 15,
              },
              SWbar = {
                type = 'toggle',
                name = L["Shield Wall Bar"],
                desc = L["help_SW"],
                get = "shieldwallQuery",
                set = "ActivateShieldWall",
                order = 16,
              },
              LSBar = {
                type = 'toggle',
                name = L["Last Stand Bar"],
                desc = L["help_LS"],
                get = "lastStandQuery",
                set = "ActivateLastStand",
                order = 17,
              },
              DSBar = {
                type = 'toggle',
                name = L["Demoralizing Shout Bar"],
                desc = L["help_DS"],
                get = "demoShoutQuery",
                set = "ActivateDemoShout",
                order = 18,
              },
            },
          },
          colors = {
            type = "group",
            order= 201,
            name = L["Colors"],
            args = {
              bc_break1 = {
                type = 'header',
                name = L["Misc Bars"],
                order = 1,
              },
              commandingshout = {
                type = 'color',
                name = L["Commanding Shout Bar Color"],
                desc = L["colCommandingShout"],
                get = "getCommandingShoutColor",
                set = "setCommandingShoutColor",
                hasAlpha = true,
                order = 2,
              },
              fr = {
                type = 'color',
                name = L["Focused Rage Bar Color"],
                desc = L["colFocusedRage"],
                get = "getFocusedRageColor",
                set = "setFocusedRageColor",
                hasAlpha = false,
                order = 3,
              },
              fralpha = {
                type = 'range',
                name = L["Focused Rage Alpha"],
                desc = L["colFocusedRageAlpha"],
                min = 0,
                max = 1,
                isPercent = true,
                get = "GetFRalpha",
                set = "SetFRalpha",
                order = 4,
              },
              fralphaFull = {
                type = 'range',
                name = L["Focused Rage Full Alpha"],
                desc = L["colFocusedRageFullAlpha"],
                min = 0,
                max = 1,
                isPercent = true,
                get = "GetFRalphaFull",
                set = "SetFRalphaFull",
                order = 5,
              },
              bc_break2 = {
                type = 'header',
                name = L["DPS Bars"],
                order = 10,
              },
              ColossusSmash = {
                type = 'color',
                name = L["Colossus Smash Bar Color"],
                desc = L["colColossusSmash"],
                get = "getColossusSmashColor",
                set = "setColossusSmashColor",
                hasAlpha = true,
                order = 11,
              },
              BattleCry = {
                type = 'color',
                name = L["Battle Cry Bar Color"],
                desc = L["colBattleCry"],
                get = "getBattleCryColor",
                set = "setBattleCryColor",
                hasAlpha = true,
                order = 12,
              },
              Bloodbath = {
                type = 'color',
                name = L["Bloodbath Bar Color"],
                desc = L["colBloodbath"],
                get = "getBloodbathColor",
                set = "setBloodbathColor",
                hasAlpha = true,
                order = 13,
              },
              Avatar = {
                type = 'color',
                name = L["Avatar Bar Color"],
                desc = L["colAvatar"],
                get = "getAvatarColor",
                set = "setAvatarColor",
                hasAlpha = true,
                order = 14,
              },
              DragonRoar = {
                type = 'color',
                name = L["Dragon Roar Bar Color"],
                desc = L["colDragonRoar"],
                get = "getDragonRoarColor",
                set = "setDragonRoarColor",
                hasAlpha = true,
                order = 15,
              },
              tfb = {
                type = 'color',
                name = L["Taste for Blood Bar Color"],
                desc = L["colTasteForBlood"],
                get = "getTasteForBloodColor",
                set = "setTasteForBloodColor",
                hasAlpha = false,
                order = 16,
              },
              tfbalpha = {
                type = 'range',
                name = L["Taste for Blood Alpha"],
                desc = L["colTasteForBloodAlpha"],
                min = 0,
                max = 1,
                isPercent = true,
                get = "GetTFBalpha",
                set = "SetTFBalpha",
                order = 17,
              },
              tfbalphaFull = {
                type = 'range',
                name = L["Taste for Blood Full Alpha"],
                desc = L["colTasteForBloodFullAlpha"],
                min = 0,
                max = 1,
                isPercent = true,
                get = "GetTFBalphaFull",
                set = "SetTFBalphaFull",
                order = 18,
              },
              bc_break3 = {
                type = 'header',
                name = L["Protection Bars"],
                order = 20,
              },
              IgnorePain= {
                type = 'color',
                name = L["Ignore Pain Color"],
                desc = L["colIgnorePain"],
                get = "getIgnorePainColor",
                set = "setIgnorePainColor",
                hasAlpha = true,
                order = 21,
              },
              ShieldBlock = {
                type = 'color',
                name = L["Shield Block Color"],
                desc = L["colShieldBlock"],
                get = "getShieldBlockColor",
                set = "setShieldBlockColor",
                hasAlpha = true,
                order = 22,
              },
              ShieldWall = {
                type = 'color',
                name = L["Shield Wall Color"],
                desc = L["colShieldWall"],
                get = "getShieldWallColor",
                set = "setShieldWallColor",
                hasAlpha = true,
                order = 23,
              },
              demoshout = {
                type = 'color',
                name = L["Demoralizing Shout Color"],
                desc = L["colDemoShout"],
                get = "getDemoShoutColor",
                set = "setDemoShoutColor",
                hasAlpha = true,
                order = 24,
              },
              laststand = {
                type = 'color',
                name = L["Last Stand Color"],
                desc = L["colLastStand"],
                get = "getLastStandColor",
                set = "setLastStandColor",
                hasAlpha = true,
                order = 25,
              },
            },
          },
          Display = {
            type = "group",
            order= 203,
            name = L["Display"],
            args = {
              width = {
                type = 'range',
                name = L["Bar Width"],
                desc = L["help_width"],
                min = 100,
                max = 600,
                step = 10,
                get = "GetWidth",
                set = "SetWidth",
                order = 10,
              },
              height = {
                type = 'range',
                name = L["Bar Height"],
                desc = L["help_height"],
                min = 100,
                max = 700,
                step = 10,
                get = "GetHeight",
                set = "SetHeight",
                order = 11,
              },
              scale = {
                type = 'range',
                name = L["Bar Scale"],
                desc = L["help_scale"],
                min = 0.10,
                max = 2.00,
                step = 0.05,
                get = "GetScale",
                set = "SetScale",
                order = 12,
              },
              framestrata = {
                type = 'select',
                name = L["Frame Strata"],
                get = "getFrameStrataLevel",
                set = "setFrameStrataLevel",
                values = { L["BACKGROUND"], L["LOW"], L["MEDIUM"], L["HIGH"] },
                order = 13,
              },
              resetbars = {
                type = 'execute',
                name = L["Reset"],
                desc = L["help_reset"],
                func = "ResetBars",
                order = 14,
              },

            },
          },

          media = {
            type = "group",
            order= 204,
            name = L["Media"],
            args = {
              texture = {
                type = 'select', dialogControl = 'LSM30_Statusbar',
                name = L["Bar Texture"],
                get = "GetBarTexture",
                set = "SetBarTexture",
                values = AceGUIWidgetLSMlists.statusbar,
                order = 2,
              },
              barborder = {
                type = 'select', dialogControl = 'LSM30_Border',
                name = L["Bar Border Texture"],
                get = "GetBarBorderTexture",
                set = "SetBarBorderTexture",
                values = AceGUIWidgetLSMlists.border,
                order = 3,
              },
              enableDisableBorder = {
                type = 'toggle',
                name = L["Disable Borders"],
                desc = L["help_enableDisableBorder"],
                get = "enableDisableBorderQuery",
                set = "ActivateEnableDisableBorder",
                order = 7,
              },
              barfont = {
                type = 'select', dialogControl = 'LSM30_Font',
                name = L["Bar Font"],
                get = "GetBarFont",
                set = "SetBarFont",
                values = AceGUIWidgetLSMlists.font,
                order = 4,
              },
              barfonteffect = {
                name = L["Bar Font Effect"],
                type = "select",
                get = "GetBarFontEffect",
                set = "SetBarFontEffect",
                values = SlamAndAwe.fonteffects,
                order = 5,
              },

              barfontsize = {
                type = 'range',
                name = L["Bar Font Size"],
                min = 6,
                max = 64,
                step = 1,
                get = "GetBarFontSize",
                set = "SetBarFontSize",
                order = 13,
              },
            },
          },

        },
      },

      ragebaroptions = {
        name = L["Rage Bar Options"],
        type = 'group',
        childGroups = 'tab',
        order = 4,
        args = {
          ragebaroptions_general = {
            type = "group",
            order= 200,
            name = L["General"],
            args = {
              rage_bar = {
                type = 'toggle',
                name = L["Rage Bar"],
                desc = L["help_Rage"],
                get = "ragebarQuery",
                set = "ActivateRage",
                order = 1,
              },
              hideRageBarOOC = {
                type = 'toggle',
                name = L["Hide Rage Bar Out of Combat"],
                desc = L["help_hideRageBarOOC"],
                get = "hideRageBarOOCQuery",
                set = "ActivateHideRageBarOOC",
                order = 2,
              },
            },
          },

          ragebaroptions_colors = {
            type = "group",
            order= 201,
            name = L["Colors"],
            args = {
              Rage = {
                type = 'color',
                name = L["Rage Bar Color"],
                desc = L["Rage Bar Color"],
                get = "getRageColor",
                set = "setRageColor",
                hasAlpha = true,
                order = 2,
              },
              sixtyrage = {
                type = 'color',
                name = L["Rage Bar Color > 60"],
                desc = L["help_rage_60"],
                get = "getSixtyRageColor",
                set = "setSixtyRageColor",
                hasAlpha = true,
                order = 2,
              },
            },
          },

          ragebaroptions_Display = {
            type = "group",
            order= 202,
            name = L["Display"],
            args = {
              ragebar_width = {
                type = 'range',
                name = L["Bar Width"],
                desc = L["help_width"],
                min = 100,
                max = 1200,
                step = 5,
                get = "GetRageBarWidth",
                set = "SetRageBarWidth",
                order = 30,
              },
              ragebar_height = {
                type = 'range',
                name = L["Bar Height"],
                desc = L["help_height"],
                min = 20,
                max = 600,
                step = 5,
                get = "GetRageBarHeight",
                set = "SetRageBarHeight",
                order = 31,
              },
              ragebar_scale = {
                type = 'range',
                name = L["Bar Scale"],
                desc = L["help_scale"],
                min = 0.10,
                max = 2.00,
                step = 0.05,
                get = "GetRageBarScale",
                set = "SetRageBarScale",
                order = 32,
              },

              rageframe_strata = {
                type = 'select',
                name = L["Frame Strata"],
                get = "getFrameStrataLevel",
                set = "setFrameStrataLevel",
                values = { L["BACKGROUND"], L["LOW"], L["MEDIUM"], L["HIGH"] },
                order = 33,
              },

              rage_reset = {
                type = 'execute',
                name = L["Reset"],
                desc = L["help_rage_reset"],
                func = "ResetRageBar",
                order = 40,
              },

            },
          },

          ragebaroptions_media = {
            type = "group",
            order= 203,
            name = L["Media"],
            args = {

              ragebar_texture = {
                type = 'select', dialogControl = 'LSM30_Statusbar',
                name = L["Bar Texture"],
                get = "GetRageBarTexture",
                set = "SetRageBarTexture",
                values = AceGUIWidgetLSMlists.statusbar,
                order = 2,
              },
              ragebar_border = {
                type = 'select', dialogControl = 'LSM30_Border',
                name = L["Bar Border Texture"],
                get = "GetRageBarBorderTexture",
                set = "SetRageBarBorderTexture",
                values = AceGUIWidgetLSMlists.border,
                order = 3,
              },
              ragebar_enableDisableBorder = {
                type = 'toggle',
                name = L["Disable Borders"],
                desc = L["help_enableDisableBorder"],
                get = "enableDisableRageBarBorderQuery",
                set = "ActivateEnableDisableRageBarBorder",
                order = 7,
              },
              ragebar_font = {
                type = 'select', dialogControl = 'LSM30_Font',
                name = L["Bar Font"],
                get = "GetRageBarFont",
                set = "SetRageBarFont",
                values = AceGUIWidgetLSMlists.font,
                order = 4,
              },
              ragebar_fonteffect = {
                name = L["Bar Font Effect"],
                type = "select",
                get = "GetRageBarFontEffect",
                set = "SetRageBarFontEffect",
                values = SlamAndAwe.fonteffects,
                order = 5,
              },

              ragebar_fontsize = {
                type = 'range',
                name = L["Bar Font Size"],
                min = 6,
                max = 64,
                step = 1,
                get = "GetRageBarFontSize",
                set = "SetRageBarFontSize",
                order = 13,
              },

            },
          },

        },
      },

      announcer = {
        name = L["Announcer Options"],
        type = 'group',
        childGroups = 'tab',
        order = 5,
        args = {

          announcer_general = {
            type = "group",
            order= 201,
            name = L["General"],
            args = {
              -- announcer_b1 = {
              -- type = 'header',
              -- name = L["Banners"],
              -- order = 1,
              -- },
              -- announceskullbanner = {
              -- type = 'toggle',
              -- name = L["Skull Banner"],
              -- desc = L["help_skull_banner"],
              -- get = "SkullBannerAnnounceQuery",
              -- set = "ActivateAnnounceSkullBanner",
              -- order = 2,
              -- },
              -- announceskullbannerwhere = {
              -- type = 'select',
              -- name = L["Output Location"],
              -- get = "GetSkullBannerAnnounceLocation",
              -- set = "SetSkullBannerAnnounceLocation",
              -- values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
              -- order = 3,
              -- },
              -- announcedemoralizingbanner = {
              -- type = 'toggle',
              -- name = L["Demoralizing Banner"],
              -- desc = L["help_demoralizing_banner"],
              -- get = "DemoralizingBannerAnnounceQuery",
              -- set = "ActivateAnnounceDemoralizingBanner",
              -- order = 5,
              -- },
              -- announcedemoralizingbannerwhere = {
              --- type = 'select',
              -- name = L["Output Location"],
              -- get = "GetDemoralizingBannerAnnounceLocation",
              -- set = "SetDemoralizingBannerAnnounceLocation",
              -- values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
              -- order = 6,
              -- },
              -- announcemockingbanner = {
              -- type = 'toggle',
              -- name = L["Mocking Banner"],
              -- desc = L["help_mocking_banner"],
              -- get = "MockingBannerAnnounceQuery",
              -- set = "ActivateAnnounceMockingBanner",
              -- order = 8,
              -- },
              -- announcemockingbannerwhere = {
              -- type = 'select',
              -- name = L["Output Location"],
              -- get = "GetMockingBannerAnnounceLocation",
              -- set = "SetMockingBannerAnnounceLocation",
              -- values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
              -- order = 9,
              -- },
              -- announcer_b2 = {
              -- type = 'header',
              -- name = L["Cooldowns"],
              -- order = 10,
              -- },

              announceinterrupt = {
                type = 'toggle',
                name = L["Spell Interrupts"],
                desc = L["help_announce_interrupt"],
                get = "InterruptAnnounceQuery",
                set = "ActivateAnnounceInterrupt",
                order = 12,
              },
              announceinterruptwhere = {
                type = 'select',
                name = L["Output Location"],
                get = "GetInterruptAnnounceLocation",
                set = "SetInterruptAnnounceLocation",
                values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
                order = 13,
              },

              announcelaststand = {
                type = 'toggle',
                name = SlamAndAwe.constants["Last Stand"],
                desc = L["help_announce_laststand"],
                get = "LastStandAnnounceQuery",
                set = "ActivateAnnounceLastStand",
                order = 15,
              },
              announcelaststandwhere = {
                type = 'select',
                name = L["Output Location"],
                get = "GetLastStandAnnounceLocation",
                set = "SetLastStandAnnounceLocation",
                values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
                order = 16,
              },

              announceshieldwall = {
                type = 'toggle',
                name = SlamAndAwe.constants["Shield Wall"],
                desc = L["help_announce_shieldwall"],
                get = "ShieldWallAnnounceQuery",
                set = "ActivateAnnounceShieldWall",
                order = 18,
              },
              announceshieldwallwhere = {
                type = 'select',
                name = L["Output Location"],
                get = "GetShieldWallAnnounceLocation",
                set = "SetShieldWallAnnounceLocation",
                values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
                order = 19,
              },

            },
          },

        },
      },

      uptime = {
        name = L["Uptime Options"],
        type = 'group',
        childGroups = 'tab',
        order = 8,
        args = {
          uptime_general = {
            type = "group",
            order= 201,
            name = L["General"],
            args = {
              resetuptime = {
                type = 'execute',
                name = L["Reset Uptime Frame"],
                desc = L["help_reset_uptime_frame"],
                func = "ResetUptime",
                order = 14,
              },
              show = {
                type = 'toggle',
                name = L["Show Frame"],
                desc = L["help_showuptime"],
                get = "showUptimeQuery",
                set = "ActivateShowUptime",
                order = 84,
              },
              resetsession = {
                type = 'execute',
                name = L["Reset Session info"],
                desc = L["help_reset_session"],
                func = "ResetUptimeValues",
                order = 85,
              },
            },
          },

          uptime_colors = {
            type = "group",
            order= 202,
            name = L["Colors"],
            args = {

              en = {
                type = 'color',
                name = L["Enrage Color"],
                desc = L["colEN"],
                get = "getENColor",
                set = "setENColor",
                hasAlpha = true,
                order = 62,
              },
              ip = {
                type = 'color',
                name = L["Ignore Pain Color"],
                desc = L["colIP"],
                get = "getIPColor",
                set = "setIPColor",
                hasAlpha = true,
                order = 63,
              },
              sb = {
                type = 'color',
                name = L["Shield Block Color"],
                desc = L["colSB"],
                get = "getSBColor",
                set = "setSBColor",
                hasAlpha = true,
                order = 63,
              },
              -- flurry = {
              -- type = 'color',
              -- name = L["Flurry Color"],
              -- desc = L["colFlurry"],
              -- get = "getFlurryColor",
              -- set = "setFlurryColor",
              --hasAlpha = true,
              --order = 81,
              --},
              -- ip = {
              -- type = 'color',
              -- name = L["Ignore Pain Color"],
              -- desc = L["colIgnorePain"],
              -- get = "getIgnorePainColor",
              -- set = "setIgnorePainColor",
              --hasAlpha = true,
              --order = 81,
              --},
            },
          },

          uptime_media = {
            type = "group",
            order= 203,
            name = L["Media"],
            args = {

              uptime_media_br1 = {
                type = 'header',
                name = L["Coming Soon"],
                order = 3,
              },
            },
          },

        },
      },

      warning = {
        name = L["Warning Options"],
        type = 'group',
        childGroups = 'tab',
        order = 8,
        args = {
          warning_general = {
            type = "group",
            order= 201,
            name = L["General"],
            args = {
              show = {
                type = 'toggle',
                name = L["Use Warning Frame"],
                desc = L["help_warningframe"],
                get = "WarningFrameQuery",
                set = "ActivateWarningFrame",
                order = 60,
              },

              range = {
                type = 'toggle',
                name = L["Out of range"],
                desc = L["help_outofrange"],
                get = "rangeWarnQuery",
                set = "ActivateRangeWarn",
                order = 61,
              },
              interrupt = {
                type = 'toggle',
                name = L["Interrupt Warning"],
                desc = L["help_interruptwarning"],
                get = "interruptWarnQuery",
                set = "ActivateInterruptWarn",
                order = 62,
              },
              duration = {
                type = 'range',
                name = L["Warning Message Duration"],
                min = 1,
                max = 10,
                step = .2,
                get = "GetWarningDuration",
                set = "SetWarningDuration",
                order = 64,
              },
            },
          },
          warning_colors = {
            type = "group",
            order= 202,
            name = L["Colors"],
            args = {

              warningcolor = {
                type = 'color',
                name = L["Warning Msg Color"],
                desc = L["colWarningMessage"],
                get = "getWarningColor",
                set = "setWarningColor",
                hasAlpha = true,
                order = 63,
              },
            },
          },
          warning_media = {
            type = "group",
            order= 203,
            name = L["Media"],
            args = {

              msgfont = {
                type = 'select', dialogControl = 'LSM30_Font',
                name = L["Message Font"],
                get = "GetMsgFont",
                set = "SetMsgFont",
                values = AceGUIWidgetLSMlists.font,
                order = 31,
              },
              msgfonteffect = {
                name = L["Message Font Effect"],
                type = "select",
                get = "GetMsgFontEffect",
                set = "SetMsgFontEffect",
                values = SlamAndAwe.fonteffects,
                order = 32,
              },
              msgfontsize = {
                type = 'range',
                name = L["Message Font Size"],
                min = 6,
                max = 64,
                step = 1,
                get = "GetMsgFontSize",
                set = "SetMsgFontSize",
                order = 33,
              },
            },
          },
          --~ msbt = {
          --~ type = 'select',
          --~ name = L["MSBT output area"],
          --~ get = "GetMSBTareas",
          --~ set = "SetMSBTareas",
          --~ values = SlamAndAwe.MSBT.areas,
          --~ order = 12,
          --~ },
          --~ rebuff = {
          --~ type = 'range',
          --~ name = L["Weapon Rebuff time"],
          --~ desc = L["help_weaponrebuff"],
          --~ min = 0,
          --~ max = 900,
          --~ step = 10,
          --~ get = "GetRebuffTime",
          --~ set = "SetRebuffTime",
          --~ order = 6,
          --~ },
        },
      },

      debug = {
        type = 'toggle',
        name = L["Debug mode"],
        desc = L["help_debug"],
        get = "debugQuery",
        set = "ActivateDebug",
        order = 99,
      },
      moveframes = {
        type = 'toggle',
        name = L["Move Frames"],
        desc = L["help_display"],
        get = "MovingFramesQuery",
        set = "ShowHideBars",
        order = 100,
      },
      -- specchangewarning = {
      -- type = 'toggle',
      -- name = L["Warn on Spec Change"],
      -- desc = L["help_specchangewarning"],
      -- get = "specchangewarningQuery",
      -- set = "Activatespecchangewarning",
      -- order = 92,
      -- },
      resetdefaults = {
        type = 'execute',
        name = L["Reset Defaults"],
        desc = L["help_resetdefaults"],
        func = "ResetToDefault",
        order = 101,
      },
      enable = {
        type = 'execute',
        name = L["Enable/Disable"],
        desc = L["help_disable"],
        func = "EnableDisable",
        order = 98,
      },
      disable = {
        type = 'execute',
        name = L["Enable/Disable"],
        desc = L["help_disable"],
        func = "EnableDisable",
        guiHidden = true,
        order = 99,
      },

      enableProtSpec = {
        type = 'toggle',
        name = L["Enable Addon - Prot"],
        desc = L["help_enableProtSpec"],
        get = "enableProtSpecQuery",
        set = "ActivateProtSpec",
        order = 94,
      },
      enableArmsSpec = {
        type = 'toggle',
        name = L["Enable Addon - Arms"],
        desc = L["help_enableArmsSpec"],
        get = "enableArmsSpecQuery",
        set = "ActivateArmsSpec",
        order = 92,
      },
      enableFurySpec = {
        type = 'toggle',
        name = L["Enable Addon - Fury"],
        desc = L["help_enableFurySpec"],
        get = "enableFurySpecQuery",
        set = "ActivateFurySpec",
        order = 93,
      },
      config = {
        type = 'execute',
        name = L["Configure Options"],
        desc = L["help_config"],
        func = "OpenConfig",
        guiHidden = true,
        order = 95,
      },
      version = {
        type = 'execute',
        name = L["Version"],
        desc = L["help_version"],
        func = "DisplayVersion",
        order = 96,
        guiHidden = true,
      },
      help = {
        type = 'description',
        name = L["help"],
        guiHidden = true,
        order = 97,
      },
    }
  }
  return options
end

function SlamAndAwe:ActivateShear()
  SlamAndAwe.db.char.shearshow = not SlamAndAwe.db.char.shearshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.shearshow) then
    SlamAndAwe:Print(L["config_Shear_on"])
  else
    SlamAndAwe:Print(L["config_Shear_off"])
  end
end

function SlamAndAwe:ActivateShowUptime()
  SlamAndAwe.db.char.uptime.show = not SlamAndAwe.db.char.uptime.show
  if (SlamAndAwe.db.char.uptime.show) and not SlamAndAwe.db.char.disabled then
    SlamAndAwe.UptimeFrame:Show()
    SlamAndAwe:Print(L["config_Uptime_on"])
  else
    SlamAndAwe.UptimeFrame:Hide()
    SlamAndAwe:Print(L["config_Uptime_off"])
  end
end

function SlamAndAwe:ActivateTasteForBlood()
  SlamAndAwe.db.char.tfbshow = not SlamAndAwe.db.char.tfbshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.tfbshow) then
    SlamAndAwe:Print(L["config_tfb_on"])
  else
    SlamAndAwe:Print(L["config_tfb_off"])
  end
end

function SlamAndAwe:ActivateFocusedRage()
  SlamAndAwe.db.char.frshow = not SlamAndAwe.db.char.frshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.frshow) then
    SlamAndAwe:Print(L["config_fr_on"])
  else
    SlamAndAwe:Print(L["config_fr_off"])
  end
end

function SlamAndAwe:ActivateColossusSmash()
  SlamAndAwe.db.char.csshow = not SlamAndAwe.db.char.csshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.csshow) then
    SlamAndAwe:Print(L["config_CS_on"])
  else
    SlamAndAwe.frames["ColossusSmash"]:Hide()
    SlamAndAwe:Print(L["config_CS_off"])
  end
end

function SlamAndAwe:ActivateAvatar()
  SlamAndAwe.db.char.avashow = not SlamAndAwe.db.char.avashow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.avashow) then
    SlamAndAwe:Print(L["config_AVA_on"])
  else
    SlamAndAwe.frames["Avatar"]:Hide()
    SlamAndAwe:Print(L["config_AVA_off"])
  end
end

function SlamAndAwe:ActivateDragonRoar()
  SlamAndAwe.db.char.drshow = not SlamAndAwe.db.char.drshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.drshow) then
    SlamAndAwe:Print(L["config_DR_on"])
  else
    SlamAndAwe.frames["DragonRoar"]:Hide()
    SlamAndAwe:Print(L["config_DR_off"])
  end
end

function SlamAndAwe:ActivateBattleCry()
  SlamAndAwe.db.char.bcshow = not SlamAndAwe.db.char.bcshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.bcshow) then
    SlamAndAwe:Print(L["config_BC_on"])
  else
    SlamAndAwe.frames["BattleCry"]:Hide()
    SlamAndAwe:Print(L["config_BC_off"])
  end
end

function SlamAndAwe:ActivateBloodbath()
  SlamAndAwe.db.char.bbshow = not SlamAndAwe.db.char.bbshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.bbshow) then
    SlamAndAwe:Print(L["config_BB_on"])
  else
    SlamAndAwe.frames["Bloodbath"]:Hide()
    SlamAndAwe:Print(L["config_BB_off"])
  end
end

function SlamAndAwe:ActivateShieldBlock()
  SlamAndAwe.db.char.sblshow = not SlamAndAwe.db.char.sblshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.sblshow) then
    SlamAndAwe:Print(L["config_SBl_on"])
  else
    SlamAndAwe.frames["ShieldBlock"]:Hide()
    SlamAndAwe:Print(L["config_SBl_off"])
  end
end

function SlamAndAwe:ActivateShieldWall()
  SlamAndAwe.db.char.swshow = not SlamAndAwe.db.char.swshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.swshow) then
    SlamAndAwe:Print(L["config_SW_on"])
  else
    SlamAndAwe.frames["ShieldWall"]:Hide()
    SlamAndAwe:Print(L["config_SW_off"])
  end
end

function SlamAndAwe:ActivateLastStand()
  SlamAndAwe.db.char.laststandshow = not SlamAndAwe.db.char.laststandshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.laststandshow) then
    SlamAndAwe:Print(L["config_LS_on"])
  else
    SlamAndAwe.frames["LastStand"]:Hide()
    SlamAndAwe:Print(L["config_LS_off"])
  end
end
function SlamAndAwe:ActivateCommandingShout()
  SlamAndAwe.db.char.commandingshoutshow = not SlamAndAwe.db.char.commandingshoutshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.commandingshoutshow) then
    SlamAndAwe:Print(L["config_CSH_on"])
  else
    SlamAndAwe.frames["CommandingShout"]:Hide()
    SlamAndAwe:Print(L["config_CSH_off"])
  end
end
function SlamAndAwe:ActivateCommandingShout()
  SlamAndAwe.db.char.commandingshoutshow = not SlamAndAwe.db.char.commandingshoutshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.commandingshoutshow) then
    SlamAndAwe:Print(L["config_CSH_on"])
  else
    SlamAndAwe.frames["CommandingShout"]:Hide()
    SlamAndAwe:Print(L["config_CSH_off"])
  end
end
function SlamAndAwe:ActivateDemoShout()
  SlamAndAwe.db.char.demoshoutshow = not SlamAndAwe.db.char.demoshoutshow
  SlamAndAwe:CreateBaseFrame()
  if (SlamAndAwe.db.char.demoshoutshow) then
    SlamAndAwe:Print(L["config_DS_on"])
  else
    SlamAndAwe.frames["DemoShout"]:Hide()
    SlamAndAwe:Print(L["config_DS_off"]) end
  end

  function SlamAndAwe:ActivateIgnorePain()
    SlamAndAwe.db.char.ipshow = not SlamAndAwe.db.char.ipshow
    SlamAndAwe:CreateBaseFrame()
    if (SlamAndAwe.db.char.ipshow) then
      SlamAndAwe:Print(L["config_IP_on"])
    else
      SlamAndAwe.frames["IgnorePain"]:Hide()
      SlamAndAwe:Print(L["config_IP_off"])
    end
  end

  function SlamAndAwe:ActivateGCD()
    SlamAndAwe.db.char.gcdshow = not SlamAndAwe.db.char.gcdshow
    SlamAndAwe:CreateBaseFrame()
    if (SlamAndAwe.db.char.gcdshow) then
      SlamAndAwe.frames["GCD"]:Show()
      SlamAndAwe:Print(L["config_GCD_on"])
    else
      SlamAndAwe.frames["GCD"]:Hide()
      SlamAndAwe:Print(L["config_GCD_off"])
    end
  end

  function SlamAndAwe:ActivateRage()
    SlamAndAwe.db.char.rageshow = not SlamAndAwe.db.char.rageshow
    SlamAndAwe:CreateRageFrame()
    if (SlamAndAwe.db.char.rageshow) then
      SlamAndAwe:RageBar()
      SlamAndAwe:Print(L["config_RageBar_on"])
    else
      SlamAndAwe.frames["Rage"]:Hide()
      SlamAndAwe:Print(L["config_RageBar_off"])
    end
  end

  function SlamAndAwe:ActivateGCDfullwidth()
    SlamAndAwe.db.char.gcdfullwidth = not SlamAndAwe.db.char.gcdfullwidth
    SlamAndAwe:SetTalentEffects()
    SlamAndAwe:CreateBaseFrame()
    if (SlamAndAwe.db.char.gcdfullwidth) then
      SlamAndAwe:Print(L["config_GCD_fullwidth_on"])
    else
      SlamAndAwe:Print(L["config_GCD_fullwidth_off"])
    end
  end

  function SlamAndAwe:Activatedisablebars()
    SlamAndAwe.db.char.disablebars = not SlamAndAwe.db.char.disablebars
    if (SlamAndAwe.db.char.disablebars) then
      if not InCombatLockdown() then
        if SlamAndAwe.db.char.rageshow then
          SlamAndAwe:RageBar()
        else
          SlamAndAwe.BaseFrame:Hide()
        end
      end
      SlamAndAwe:Print(L["config_disable_on"])
    else
      SlamAndAwe.BaseFrame:Show()
      SlamAndAwe:Print(L["config_disable_off"])
    end
  end

  function SlamAndAwe:ActivateBarIcons()
    SlamAndAwe.db.char.showicons = not SlamAndAwe.db.char.showicons
    if (SlamAndAwe.db.char.showicons) then
      SlamAndAwe:Print(L["config_baricons_on"])
    else
      SlamAndAwe:Print(L["config_baricons_off"])
    end
  end

  function SlamAndAwe:ActivateDebug()
    SlamAndAwe.db.char.debug = not SlamAndAwe.db.char.debug
    if (SlamAndAwe.db.char.debug) then
      SlamAndAwe:Print(L["config_debug_on"])
    else
      SlamAndAwe:Print(L["config_debug_off"])
    end
  end

  function SlamAndAwe:Activatespecchangewarning()
    SlamAndAwe.db.char.specchangewarning = not SlamAndAwe.db.char.specchangewarning
    if (SlamAndAwe.db.char.specchangewarning) then
      SlamAndAwe:Print(L["config_specchangewarning_on"])
    else
      SlamAndAwe:Print(L["config_specchangewarning_off"])
    end
  end

  function SlamAndAwe:ActivateHeroicStrike()
    -- SlamAndAwe.db.char.hsshow = not SlamAndAwe.db.char.hsshow
    -- if (SlamAndAwe.db.char.hsshow) then
    -- SlamAndAwe:Print(L["config_HS_on"])
    -- else
    -- SlamAndAwe:Print(L["config_HS_off"])
    -- end
  end

  function SlamAndAwe:ActivateHideImmune()
    SlamAndAwe.db.char.priority.hideImmune = not SlamAndAwe.db.char.priority.hideImmune
    if (SlamAndAwe.db.char.priority.hideImmune) then
      SlamAndAwe:Print(L["config_hideimmune_on"])
    else
      SlamAndAwe:Print(L["config_hideimmune_off"])
    end
  end

  function SlamAndAwe:ActivateShowInterrupt()
    SlamAndAwe.db.char.priority.showinterrupt = not SlamAndAwe.db.char.priority.showinterrupt
    if (SlamAndAwe.db.char.priority.showinterrupt) then
      --SlamAndAwe.PriorityFrame.interrupt.frame:Show()
      SlamAndAwe:Print(L["config_showinterrupt_on"])
    else
      --SlamAndAwe.PriorityFrame.interrupt.frame:Hide()
      SlamAndAwe:Print(L["config_showinterrupt_off"])
    end
  end

  function SlamAndAwe:ActivateShowPurge()
    SlamAndAwe.db.char.hsshow = not SlamAndAwe.db.char.hsshow
    if (SlamAndAwe.db.char.hsshow) then
      SlamAndAwe.PriorityFrame.purge.frame:Show()
      SlamAndAwe:Print(L["config_showpurge_on"])
    else
      SlamAndAwe.PriorityFrame.purge.frame:Hide()
      SlamAndAwe:Print(L["config_showpurge_off"])
    end
  end

  function SlamAndAwe:ActivateShowCooldown()
    SlamAndAwe.db.char.priority.showcooldown = not SlamAndAwe.db.char.priority.showcooldown
    if (SlamAndAwe.db.char.priority.showcooldown) then
      SlamAndAwe:Print(L["config_showcooldown_on"])
    else
      SlamAndAwe:Print(L["config_showcooldown_off"])
    end
  end

  function SlamAndAwe:ActivateTextOnBars()
    SlamAndAwe.db.char.barstext = not SlamAndAwe.db.char.barstext
    if (SlamAndAwe.db.char.barstext) then
      SlamAndAwe:Print(L["config_Barstext_on"])
    else
      SlamAndAwe:Print(L["config_Barstext_off"])
    end
  end

  function SlamAndAwe:ActivateEnableTimeRemaining()
    SlamAndAwe.db.char.enableTimeRemaining = not SlamAndAwe.db.char.enableTimeRemaining
    if (SlamAndAwe.db.char.enableTimeRemaining) then
      SlamAndAwe:Print(L["config_enableTimeRemaining_on"])
    else
      SlamAndAwe:Print(L["config_enableTimeRemaining_off"])
    end
  end

  function SlamAndAwe:ActivateHideRageBarOOC()
    SlamAndAwe.db.char.hideRageBarOOC = not SlamAndAwe.db.char.hideRageBarOOC
    if (SlamAndAwe.db.char.hideRageBarOOC) then
      SlamAndAwe:Print(L["config_hideRageBarOOC_on"])
      SlamAndAwe:RageBar()
    else
      SlamAndAwe:Print(L["config_hideRageBarOOC_off"])
      SlamAndAwe:RageBar()
    end
  end

  function SlamAndAwe:ActivateProtSpec()
    local currentSpec = GetSpecialization()
    SlamAndAwe.db.char.enableProtSpec = not SlamAndAwe.db.char.enableProtSpec
    if (SlamAndAwe.db.char.enableProtSpec) then
      SlamAndAwe:Print(L["config_enableProtSpec_on"])
      if SlamAndAwe.db.char.disabled and currentSpec == 3 then
        SlamAndAwe:Enable()
      end
    else
      SlamAndAwe:Print(L["config_enableProtSpec_off"])
      if SlamAndAwe.db.char.disabled == false and currentSpec == 3 then
        SlamAndAwe:Disable()
      end
    end
  end

  function SlamAndAwe:ActivateFurySpec()
    local currentSpec = GetSpecialization()
    SlamAndAwe.db.char.enableFurySpec = not SlamAndAwe.db.char.enableFurySpec
    if (SlamAndAwe.db.char.enableFurySpec) then
      SlamAndAwe:Print(L["config_enableFurySpec_on"])
      if SlamAndAwe.db.char.disabled and currentSpec == 2 then
        SlamAndAwe:Enable()
      end
    else
      SlamAndAwe:Print(L["config_enableFurySpec_off"])
      if SlamAndAwe.db.char.disabled == false and currentSpec == 2 then
        SlamAndAwe:Disable()
      end
    end
  end

  function SlamAndAwe:ActivateArmsSpec()
    local currentSpec = GetSpecialization()
    SlamAndAwe.db.char.enableArmsSpec = not SlamAndAwe.db.char.enableArmsSpec
    if (SlamAndAwe.db.char.enableArmsSpec) then
      SlamAndAwe:Print(L["config_enableArmsSpec_on"])
      if SlamAndAwe.db.char.disabled and currentSpec == 1 then
        SlamAndAwe:Enable()
      end
    else
      SlamAndAwe:Print(L["config_enableArmsSpec_off"])
      if not SlamAndAwe.db.char.disabled and currentSpec == 1 then
        SlamAndAwe:Disable()
      end
    end
  end

  function SlamAndAwe:ActivateBars()
    -- All specs have these

    SlamAndAwe:BattleCryBar()
    if SlamAndAwe.db.char.talBloodbath then
      SlamAndAwe:BloodbathBar()
    end
    if SlamAndAwe.db.char.talAvatar then
      SlamAndAwe:AvatarBar()
    end
    if SlamAndAwe.db.char.currentspec == "Fury" then
      SlamAndAwe:CommandingShoutBar()
      if SlamAndAwe.db.char.talDragonRoar then
        SlamAndAwe:DragonRoarBar()
      end
    elseif SlamAndAwe.db.char.currentspec == "Protection" then
      -- SlamAndAwe:IgnorePainBar() -- Don't show this since it isn't timer based and will get stuck.
      SlamAndAwe:ShieldBlockBar()
      SlamAndAwe:ShieldWallBar()
      SlamAndAwe:DemoShoutBar()
      SlamAndAwe:LastStandBar()
    elseif SlamAndAwe.db.char.currentspec == "Arms" then
      SlamAndAwe:ColossusSmashBar()
      SlamAndAwe:CommandingShoutBar()
    end

  end

  function SlamAndAwe:ShowHideBars()
    if InCombatLockdown() then
      SlamAndAwe:Print(L["Cannot move frames in combat"])
      return
    end
    SlamAndAwe.db.char.movingframes = not SlamAndAwe.db.char.movingframes
    if SlamAndAwe.db.char.movingframes then
      SlamAndAwe.PriorityFrame:EnableMouse(1)
      SlamAndAwe.PriorityFrame:SetBackdropColor(0, 0, 0, 1)
      SlamAndAwe.PriorityFrame:Show()
      SlamAndAwe.UptimeFrame:EnableMouse(1)
      SlamAndAwe.UptimeFrame:SetBackdropColor(0, 0, 0, 1)
      SlamAndAwe.UptimeFrame:Show()
      SlamAndAwe.msgFrame:EnableMouse(1)
      SlamAndAwe.msgFrame:SetBackdropColor(0, 0, 0, 1)
      SlamAndAwe.msgFrame:Show()
      SlamAndAwe.BaseFrame:EnableMouse(1)
      SlamAndAwe.BaseFrame:SetBackdropColor(0, 0, 0, 1);
      SlamAndAwe.frames["GCD"]:Show()
      SlamAndAwe.UptimeFrame:Show()
      SlamAndAwe.RageFrame:EnableMouse(1)
      SlamAndAwe.RageFrame:SetBackdropColor(0, 0, 0, 1)
      SlamAndAwe.RageFrame:Show()
      SlamAndAwe:RageBar()
      SlamAndAwe:ActivateBars()
    else
      SlamAndAwe.PriorityFrame:EnableMouse(false);
      SlamAndAwe.PriorityFrame:SetBackdropColor(1, 1, 1, 0);
      SlamAndAwe.BaseFrame:EnableMouse(false);
      SlamAndAwe.BaseFrame:SetBackdropColor(1, 1, 1, 0);
      SlamAndAwe.UptimeFrame:EnableMouse(false)
      SlamAndAwe.UptimeFrame:SetBackdropColor(0, 0, 0, 0.3);
      SlamAndAwe.msgFrame:EnableMouse(false)
      SlamAndAwe.msgFrame:SetBackdropColor(1, 1, 1, 0);
      SlamAndAwe.RageFrame:EnableMouse(false)
      SlamAndAwe.RageFrame:SetBackdropColor(1, 1, 1, 0);
      -- SlamAndAwe.BaseFrame:Hide()
      SlamAndAwe.frames["GCD"]:Hide()
      if SlamAndAwe.db.char.priority.show and InCombatLockdown() then
        SlamAndAwe.PriorityFrame:Show()
      else
        SlamAndAwe.PriorityFrame:Hide()
      end
      if SlamAndAwe.db.char.uptime.show and SlamAndAwe.db.char.currentspec ~= "Arms" and not SlamAndAwe.db.char.disabled then --Currently Uptime fram is disabled for Arms
        SlamAndAwe.UptimeFrame:Show()
      else
        SlamAndAwe.UptimeFrame:Hide()
      end

      SlamAndAwe:RageBar()
    end
    SlamAndAwe:SetPriorityUpdateScript()
  end

  function SlamAndAwe:FinishedMoving(var, frame)
    local point, relativeTo, relativePoint, xOffset, yOffset = frame:GetPoint();
    var.point = point
    var.relativeTo = relativeTo
    var.relativePoint = relativePoint
    var.xOffset = xOffset
    var.yOffset = yOffset
  end

  function SlamAndAwe:MovingFramesQuery()
    return SlamAndAwe.db.char.movingframes
  end

  function SlamAndAwe:enableProtSpecQuery()
    return SlamAndAwe.db.char.enableProtSpec
  end

  function SlamAndAwe:enableFurySpecQuery()
    return SlamAndAwe.db.char.enableFurySpec
  end

  function SlamAndAwe:enableArmsSpecQuery()
    return SlamAndAwe.db.char.enableArmsSpec
  end

  function SlamAndAwe:PetFrameQuery()
    return SlamAndAwe.db.char.petframeshow
  end

  function SlamAndAwe:SSQuery()
    return SlamAndAwe.db.char.ssshow
  end

  function SlamAndAwe:FireTotemQuery()
    return SlamAndAwe.db.char.firetotemshow
  end

  function SlamAndAwe:WFQuery()
    return SlamAndAwe.db.char.wfshow
  end

  function SlamAndAwe:shockQuery()
    return SlamAndAwe.db.char.shockshow
  end

  function SlamAndAwe:fsdotbarQuery()
    return SlamAndAwe.db.char.fsdotshow
  end

  function SlamAndAwe:shearQuery()
    return SlamAndAwe.db.char.shearshow
  end

  function SlamAndAwe:gcdQuery()
    return SlamAndAwe.db.char.gcdshow
  end

  function SlamAndAwe:gcdFullwidthQuery()
    return SlamAndAwe.db.char.gcdfullwidth
  end

  function SlamAndAwe:heroicstrikeQuery()
    return SlamAndAwe.db.char.hsshow
  end

  --function SlamAndAwe:combopointsQuery()
  -- return SlamAndAwe.db.char.priority.combopoints
  --end

  function SlamAndAwe:worldbossQuery()
    return SlamAndAwe.db.char.priority.worldbossonly
  end

  function SlamAndAwe:hideImmuneQuery()
    return SlamAndAwe.db.char.priority.hideImmune
  end

  function SlamAndAwe:showinterruptQuery()
    return SlamAndAwe.db.char.priority.showinterrupt
  end

  function SlamAndAwe:showpurgeQuery()
    return SlamAndAwe.db.char.hsshow
  end

  function SlamAndAwe:showcooldownQuery()
    return SlamAndAwe.db.char.priority.showcooldown
  end

  function SlamAndAwe:disablebarsQuery()
    return SlamAndAwe.db.char.disablebars
  end

  function SlamAndAwe:bariconsQuery()
    return SlamAndAwe.db.char.showicons
  end

  function SlamAndAwe:arenaQuery()
    return SlamAndAwe.db.char.arena
  end

  function SlamAndAwe:showUptimeQuery()
    return SlamAndAwe.db.char.uptime.show
  end

  function SlamAndAwe:tfbQuery()
    return SlamAndAwe.db.char.tfbshow
  end

  function SlamAndAwe:frQuery()
    return SlamAndAwe.db.char.frshow
  end

  --SlamAndAwe
  function SlamAndAwe:ignorepainQuery()
    return SlamAndAwe.db.char.ipshow
  end

  function SlamAndAwe:shieldblockQuery()
    return SlamAndAwe.db.char.sblshow
  end

  function SlamAndAwe:shieldwallQuery()
    return SlamAndAwe.db.char.swshow
  end

  function SlamAndAwe:lastStandQuery()
    return SlamAndAwe.db.char.laststandshow
  end

  function SlamAndAwe:commandingShoutQuery()
    return SlamAndAwe.db.char.commandingshoutshow
  end

  function SlamAndAwe:demoShoutQuery()
    return SlamAndAwe.db.char.demoshoutshow
  end

  function SlamAndAwe:enableTimeRemainingQuery()
    return SlamAndAwe.db.char.enableTimeRemaining
  end

  function SlamAndAwe:hideRageBarOOCQuery()
    return SlamAndAwe.db.char.hideRageBarOOC
  end

  function SlamAndAwe:colossussmashQuery()
    return SlamAndAwe.db.char.csshow
  end

  function SlamAndAwe:dragonroarQuery()
    return SlamAndAwe.db.char.drshow
  end

  function SlamAndAwe:avatarQuery()
    return SlamAndAwe.db.char.avashow
  end

  function SlamAndAwe:battlecryQuery()
    return SlamAndAwe.db.char.bcshow
  end

  function SlamAndAwe:bloodbathQuery()
    return SlamAndAwe.db.char.bbshow
  end

  function SlamAndAwe:ragebarQuery()
    return SlamAndAwe.db.char.rageshow
  end

  function SlamAndAwe:firenovaQuery()
    return SlamAndAwe.db.char.fnshow
  end

  function SlamAndAwe:textOnBarsQuery()
    return SlamAndAwe.db.char.barstext
  end

  function SlamAndAwe:mw5soundplayQuery()
    return SlamAndAwe.db.char.mw5soundplay
  end

  function SlamAndAwe:mw4soundplayQuery()
    return SlamAndAwe.db.char.mw4soundplay
  end

  function SlamAndAwe:mw5flashQuery()
    return SlamAndAwe.db.char.mw5flash
  end

  function SlamAndAwe:debugQuery()
    return SlamAndAwe.db.char.debug
  end

  function SlamAndAwe:specchangewarningQuery()
    return SlamAndAwe.db.char.specchangewarning
  end

  function SlamAndAwe:GetBarTexture()
    return SlamAndAwe.db.char.texture
  end

  function SlamAndAwe:GetRageBarTexture()
    return SlamAndAwe.db.char.ragebar.texture
  end

  function SlamAndAwe:GetBorderTexture()
    return SlamAndAwe.db.char.border
  end

  function SlamAndAwe:GetBarBorderTexture()
    return SlamAndAwe.db.char.barborder
  end

  function SlamAndAwe:GetPriorityBorderTexture()
    return SlamAndAwe.db.char.priority.barborder
  end

  function SlamAndAwe:GetRageBarBorderTexture()
    return SlamAndAwe.db.char.ragebar.barborder
  end

  function SlamAndAwe:GetBarFont()
    return SlamAndAwe.db.char.barfont
  end

  function SlamAndAwe:GetRageBarFont()
    return SlamAndAwe.db.char.ragebar.barfont
  end

  function SlamAndAwe:GetBarFontSize()
    return SlamAndAwe.db.char.barfontsize
  end

  function SlamAndAwe:GetRageBarFontSize()
    return SlamAndAwe.db.char.ragebar.barfontsize
  end

  function SlamAndAwe:GetBarFontEffect()
    return SlamAndAwe.db.char.barfonteffect
  end

  function SlamAndAwe:GetRageBarFontEffect()
    return SlamAndAwe.db.char.ragebar.barfonteffect
  end

  function SlamAndAwe:GetMsgFont()
    return SlamAndAwe.db.char.msgfont
  end

  function SlamAndAwe:GetMsgFontSize()
    return SlamAndAwe.db.char.msgfontsize
  end

  function SlamAndAwe:GetMsgFontEffect()
    return SlamAndAwe.db.char.msgfonteffect
  end

  function SlamAndAwe:GetWidth()
    return SlamAndAwe.db.char.fWidth
  end

  function SlamAndAwe:GetHeight()
    return SlamAndAwe.db.char.fHeight
  end

  function SlamAndAwe:GetScale()
    return SlamAndAwe.db.char.scale
  end

  function SlamAndAwe:GetRageBarWidth()
    return SlamAndAwe.db.char.ragebar.fWidth
  end

  function SlamAndAwe:GetRageBarHeight()
    return SlamAndAwe.db.char.ragebar.fHeight
  end

  function SlamAndAwe:GetRageBarScale()
    return SlamAndAwe.db.char.ragebar.scale
  end

  function SlamAndAwe:GetPriorityScale()
    return SlamAndAwe.db.char.priority.scale
  end

  function SlamAndAwe:GetTFBalpha()
    return SlamAndAwe.db.char.colors.tfbalpha
  end

  function SlamAndAwe:GetTFBalphaFull()
    return SlamAndAwe.db.char.colors.tfbalphaFull
  end

  function SlamAndAwe:GetFRalpha()
    return SlamAndAwe.db.char.colors.fralpha
  end

  function SlamAndAwe:GetFRalphaFull()
    return SlamAndAwe.db.char.colors.fralphaFull
  end

  function SlamAndAwe:GetWeaponSound()
    return SlamAndAwe.db.char.weaponsoundname
  end

  function SlamAndAwe:Gettfb5sound()
    return SlamAndAwe.db.char.tfb5soundname
  end

  function SlamAndAwe:Gettfb5repeat()
    return SlamAndAwe.db.char.tfb5repeat
  end

  function SlamAndAwe:Gettfb4sound()
    return SlamAndAwe.db.char.tfb4soundname
  end

  function SlamAndAwe:GetThreatThreshold()
    return SlamAndAwe.db.char.threatThreshold
  end

  function SlamAndAwe:GetRageThreshold()
    return SlamAndAwe.db.char.rageThreshold
  end

  function SlamAndAwe:GetCooldownThreshold()
    return SlamAndAwe.db.char.priority.cooldown
  end

  function SlamAndAwe:GetArmsAOEThreshold()
    return SlamAndAwe.db.char.priority.armsaoethreshold
  end

  function SlamAndAwe:GetFuryAOEThreshold()
    return SlamAndAwe.db.char.priority.furyaoethreshold
  end

  function SlamAndAwe:GetTotemTimeLeft()
    return SlamAndAwe.db.char.priority.totemtimeleft
  end

  function SlamAndAwe:GetRebuffTime()
    return SlamAndAwe.db.char.warning.timeleft
  end

  function SlamAndAwe:GetShowWFTotals()
    return SlamAndAwe.db.char.stats.wfcalc
  end

  function SlamAndAwe:SetBarFont(info, newValue)
    SlamAndAwe.db.char.barfont = newValue
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:RageBar()
  end

  function SlamAndAwe:SetRageBarFont(info, newValue)
    SlamAndAwe.db.char.ragebar.barfont = newValue
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:RageBar()
  end

  function SlamAndAwe:SetBarFontSize(info, newValue)
    SlamAndAwe.db.char.barfontsize = newValue
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:RageBar()
  end

  function SlamAndAwe:SetRageBarFontSize(info, newValue)
    SlamAndAwe.db.char.ragebar.barfontsize = newValue
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:RageBar()
  end

  function SlamAndAwe:SetBarFontEffect(info, newValue)
    SlamAndAwe.db.char.barfonteffect = newValue
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:RageBar()
  end

  function SlamAndAwe:SetRageBarFontEffect(info, newValue)
    SlamAndAwe.db.char.ragebar.barfonteffect = newValue
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:RageBar()
  end

  function SlamAndAwe:SetMsgFont(info, newValue)
    SlamAndAwe.db.char.msgfont = newValue
    SlamAndAwe:CreateMsgFrame()
    SlamAndAwe:PrintMsg("Out Of Range", SlamAndAwe.db.char.warning.color)
  end

  function SlamAndAwe:SetMsgFontSize(info, newValue)
    SlamAndAwe.db.char.msgfontsize = newValue
    SlamAndAwe:CreateMsgFrame()
    SlamAndAwe:PrintMsg("Out Of Range", SlamAndAwe.db.char.warning.color)
  end

  function SlamAndAwe:SetMsgFontEffect(info, newValue)
    SlamAndAwe.db.char.msgfonteffect = newValue
    SlamAndAwe:CreateMsgFrame()
    SlamAndAwe:PrintMsg("Out Of Range", SlamAndAwe.db.char.warning.color)
  end

  function SlamAndAwe:SetBarTexture(info, newValue)
    SlamAndAwe.db.char.texture = newValue
    local barTexture = media:Fetch('statusbar', newValue)
    SlamAndAwe.frames["GCD"].statusbar:SetStatusBarTexture(barTexture)
    SlamAndAwe:RedrawFrames()
  end

  function SlamAndAwe:SetRageBarTexture(info, newValue)
    SlamAndAwe.db.char.ragebar.texture = newValue
    local barTexture = media:Fetch('statusbar', newValue)
    SlamAndAwe.frames["GCD"].statusbar:SetStatusBarTexture(barTexture)
    SlamAndAwe:RedrawFrames()
  end

  function SlamAndAwe:SetBorderTexture(info, newValue)
    SlamAndAwe.db.char.border = newValue
    local newTexture = media:Fetch("border", SlamAndAwe.db.char.border)
    if newTexture then
      SlamAndAwe.frameBackdrop.edgeFile = newTexture
      SlamAndAwe:RedrawFrames()
    else
      if SlamAndAwe.db.char.debug then
        SlamAndAwe:Print("border texture not found. Trying to set "..SlamAndAwe.db.char.border)
      end
    end
  end

  function SlamAndAwe:SetBarBorderTexture(info, newValue)
    SlamAndAwe.db.char.barborder = newValue
    local newTexture = media:Fetch("border", SlamAndAwe.db.char.barborder)
    if newTexture then
      SlamAndAwe.barBackdrop.edgeFile = newTexture
      SlamAndAwe.frames["GCD"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["IgnorePain"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ShieldBlock"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ShieldWall"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ColossusSmash"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["BattleCry"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["Bloodbath"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["Avatar"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["DragonRoar"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["DemoShout"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["LastStand"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["CommandingShout"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe:RedrawFrames()
    else
      if SlamAndAwe.db.char.debug then
        SlamAndAwe:Print("bar border texture not found. Trying to set "..SlamAndAwe.db.char.barborder)
      end
    end
  end

  function SlamAndAwe:SetPriorityBorderTexture(info, newValue)
    SlamAndAwe.db.char.priority.barborder = newValue
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.debug then
      SlamAndAwe:Print("bar border texture not found. Trying to set "..SlamAndAwe.db.char.priority.barborder)
    end
  end

  function SlamAndAwe:SetRageBarBorderTexture(info, newValue)
    SlamAndAwe.db.char.ragebar.barborder = newValue
    local newTexture = media:Fetch("border", SlamAndAwe.db.char.ragebar.barborder)
    if newTexture then
      SlamAndAwe.ragebarBackdrop.edgeFile = newTexture
      SlamAndAwe.frames["Rage"]:SetBackdrop(SlamAndAwe.ragebarBackdrop)
      SlamAndAwe:RedrawFrames()
    else
      if SlamAndAwe.db.char.debug then
        SlamAndAwe:Print("bar border texture not found. Trying to set "..SlamAndAwe.db.char.ragebar.barborder)
      end
    end
  end

  function SlamAndAwe:SetWeaponSound(info, newValue)
    local newSound = media:Fetch("sound", newValue)
    SlamAndAwe.db.char.weaponsoundname = newValue
    if newSound then
      SlamAndAwe.db.char.weaponsound = newSound
      PlaySoundFile(newSound)
    else
      if SlamAndAwe.db.char.debug then
        SlamAndAwe:Print("Sound not found. Trying to set "..newSound)
      end
    end
  end

  function SlamAndAwe:SetMW5sound(info, newValue)
    local newSound = media:Fetch("sound", newValue)
    SlamAndAwe.db.char.mw5soundname = newValue
    if newSound then
      SlamAndAwe.db.char.mw5sound = newSound
      PlaySoundFile(newSound)
    else
      if SlamAndAwe.db.char.debug then
        SlamAndAwe:Print("Sound not found. Trying to set "..newSound)
      end
    end
  end

  function SlamAndAwe:SetMW5repeat(info, newValue)
    SlamAndAwe.db.char.mw5repeat = newValue
  end

  function SlamAndAwe:SetMW4sound(info, newValue)
    local newSound = media:Fetch("sound", newValue)
    SlamAndAwe.db.char.mw4soundname = newValue
    if newSound then
      SlamAndAwe.db.char.mw4sound = newSound
      PlaySoundFile(newSound)
    else
      if SlamAndAwe.db.char.debug then
        SlamAndAwe:Print("Sound not found. Trying to set "..newSound)
      end
    end
  end

  function SlamAndAwe:SetThreatThreshold(info, newValue)
    SlamAndAwe.db.char.threatThreshold = newValue
    SlamAndAwe:Print(L["config_Threat"]..newValue)
  end

  function SlamAndAwe:SetRageThreshold(info, newValue)
    SlamAndAwe.db.char.rageThreshold = newValue
    SlamAndAwe:Print(L["config_Rage"]..newValue)
  end

  function SlamAndAwe:SetCooldownThreshold(info, newValue)
    SlamAndAwe.db.char.priority.cooldown = newValue
    SlamAndAwe:Print(L["config_Cooldown"]..newValue)
  end

  function SlamAndAwe:SetFuryAOEThreshold(info, newValue)
    SlamAndAwe.db.char.priority.furyaoethreshold = newValue
    SlamAndAwe:Print(L["config_FuryAOE"]..newValue)
  end

  function SlamAndAwe:SetArmsAOEThreshold(info, newValue)
    SlamAndAwe.db.char.priority.armsaoethreshold = newValue
    SlamAndAwe:Print(L["config_ArmsAOE"]..newValue)
  end

  function SlamAndAwe:SetRebuffTime(info, newValue)
    SlamAndAwe.db.char.warning.timeleft = newValue
  end

  function SlamAndAwe:SetWidth(info,newValue)
    if InCombatLockdown() then
      SlamAndAwe:Print(L["Cannot change bar width in combat"])
      return
    end
    local wasMoving = SlamAndAwe.db.char.movingframes
    SlamAndAwe.db.char.fWidth = newValue
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.rageshow then
      SlamAndAwe:RageBar()
    end
    SlamAndAwe:ActivateBars()
    if SlamAndAwe.db.char.movingframes then
        SlamAndAwe:ShowHideBars()
    end
    SlamAndAwe:DebugPrint(L["Frame width set to : "]..SlamAndAwe.db.char.fWidth)
  end

  function SlamAndAwe:SetRageBarWidth(info,newValue)
    if InCombatLockdown() then
      SlamAndAwe:Print(L["Cannot change bar width in combat"])
      return
    end
    local wasMoving = SlamAndAwe.db.char.movingframes
    SlamAndAwe.db.char.ragebar.fWidth = newValue
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.rageshow then
      SlamAndAwe:RageBar()
    end
    SlamAndAwe:ActivateBars()
    if SlamAndAwe.db.char.movingframes then
        SlamAndAwe:ShowHideBars()
    end
    SlamAndAwe:DebugPrint(L["Frame width set to : "]..SlamAndAwe.db.char.ragebar.fWidth)
  end

  function SlamAndAwe:SetHeight(info,newValue)
    if InCombatLockdown() then
      SlamAndAwe:Print(L["Cannot change bar height in combat"])
      return
    end
    local wasMoving = SlamAndAwe.db.char.movingframes
    SlamAndAwe.db.char.fHeight = newValue
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.rageshow then
      SlamAndAwe:RageBar()
    end
    SlamAndAwe:ActivateBars()
    if SlamAndAwe.db.char.movingframes then
        SlamAndAwe:ShowHideBars()
    end
    SlamAndAwe:DebugPrint(L["Frame height set to : "]..SlamAndAwe.db.char.fHeight)
  end

  function SlamAndAwe:SetRageBarHeight(info,newValue)
    if InCombatLockdown() then
      SlamAndAwe:Print(L["Cannot change bar height in combat"])
      return
    end
    local wasMoving = SlamAndAwe.db.char.movingframes
    SlamAndAwe.db.char.ragebar.fHeight = newValue
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.rageshow then
      SlamAndAwe:RageBar()
    end
    SlamAndAwe:ActivateBars()
    if SlamAndAwe.db.char.movingframes then
        SlamAndAwe:ShowHideBars()
    end
    SlamAndAwe:DebugPrint(L["Frame height set to : "]..SlamAndAwe.db.char.ragebar.fHeight)
  end

  function SlamAndAwe:SetScale(info,newValue)
    if InCombatLockdown() then
      SlamAndAwe:Print(L["Cannot change scale in combat"])
      return
    end
    local wasMoving = SlamAndAwe.db.char.movingframes
    SlamAndAwe.db.char.scale = newValue
    SlamAndAwe.BaseFrame:SetScale(SlamAndAwe.db.char.scale)
    SlamAndAwe:ActivateBars()
    if SlamAndAwe.db.char.movingframes then
        SlamAndAwe:ShowHideBars()
    end
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.rageshow then
      SlamAndAwe:RageBar()
    end
    SlamAndAwe:DebugPrint(L["Scale set to : "]..SlamAndAwe.db.char.scale)
  end

  function SlamAndAwe:SetRageBarScale(info,newValue)
    if InCombatLockdown() then
      SlamAndAwe:Print(L["Cannot change scale in combat"])
      return
    end
    local wasMoving = SlamAndAwe.db.char.movingframes
    SlamAndAwe.db.char.ragebar.scale = newValue
    SlamAndAwe.RageFrame:SetScale(SlamAndAwe.db.char.ragebar.scale)
    SlamAndAwe:ActivateBars()
    if SlamAndAwe.db.char.movingframes then
        SlamAndAwe:ShowHideBars()
    end
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.rageshow then
      SlamAndAwe:RageBar()
    end
    SlamAndAwe:DebugPrint(L["Scale set to : "]..SlamAndAwe.db.char.ragebar.scale)
  end

  function SlamAndAwe:SetPriorityScale(info,newValue)
    if InCombatLockdown() then
      SlamAndAwe:Print(L["Cannot change scale in combat"])
    end
    SlamAndAwe.db.char.priority.scale = newValue
    SlamAndAwe.PriorityFrame:SetScale(SlamAndAwe.db.char.priority.scale)
    SlamAndAwe:DebugPrint(L["Priority Scale set to : "]..SlamAndAwe.db.char.priority.scale)
  end

  function SlamAndAwe:SetTFBalpha(info,newValue)
    if SlamAndAwe.db.char.tfbshow then
      SlamAndAwe.db.char.colors.tfbalpha = newValue
      SlamAndAwe:Print(L["config_tfbAlpha_ooc"]..SlamAndAwe.db.char.colors.tfbalpha)
      SlamAndAwe:SetTasteForBloodAlpha(SlamAndAwe.db.char.colors.tfbalpha)
    end
  end

  function SlamAndAwe:SetTFBalphaFull(info,newValue)
    if SlamAndAwe.db.char.tfbshow then
      SlamAndAwe.db.char.colors.tfbalphaFull = newValue
      SlamAndAwe:Print(L["config_tfbAlpha_combat"]..SlamAndAwe.db.char.colors.tfbalphaFull)
      SlamAndAwe:SetTasteForBloodAlpha(SlamAndAwe.db.char.colors.tfbalphaFull)
    end
  end

  function SlamAndAwe:SetTasteForBloodAlpha(alphaValue)
    SlamAndAwe.frames["TasteForBlood"]:SetBackdropColor(0, 0, 0, alphaValue * .2)
    SlamAndAwe.frames["TasteForBlood"]:SetBackdropBorderColor( 1, 1, 1, alphaValue)
    local colors = SlamAndAwe.db.char.colors.tfb
    SlamAndAwe.frames["TasteForBlood"].statusbar:SetStatusBarColor( colors.r, colors.g, colors.b, alphaValue)
  end

  function SlamAndAwe:SetFRalpha(info,newValue)
    if SlamAndAwe.db.char.frshow then
      SlamAndAwe.db.char.colors.fralpha = newValue
      SlamAndAwe:Print(L["config_frAlpha_ooc"]..SlamAndAwe.db.char.colors.fralpha)
      SlamAndAwe:SetFocusedRageAlpha(SlamAndAwe.db.char.colors.fralpha)
    end
  end

  function SlamAndAwe:SetFRalphaFull(info,newValue)
    if SlamAndAwe.db.char.frshow then
      SlamAndAwe.db.char.colors.fralphaFull = newValue
      SlamAndAwe:Print(L["config_frAlpha_combat"]..SlamAndAwe.db.char.colors.fralphaFull)
      SlamAndAwe:SetFocusedRageAlpha(SlamAndAwe.db.char.colors.fralphaFull)
    end
  end

  function SlamAndAwe:SetFocusedRageAlpha(alphaValue)
    SlamAndAwe.frames["FocusedRage"]:SetBackdropColor(0, 0, 0, alphaValue * .2)
    SlamAndAwe.frames["FocusedRage"]:SetBackdropBorderColor( 1, 1, 1, alphaValue)
    local colors = SlamAndAwe.db.char.colors.fr
    SlamAndAwe.frames["FocusedRage"].statusbar:SetStatusBarColor( colors.r, colors.g, colors.b, alphaValue)
  end

  -----------------------------------------
  -- Color choices getter/setters
  -----------------------------------------

  function SlamAndAwe:getFlameShockColor(info)
    local colors = SlamAndAwe.db.char.colors.flameshock
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setFlameShockColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.flameshock.r = r
    SlamAndAwe.db.char.colors.flameshock.g = g
    SlamAndAwe.db.char.colors.flameshock.b = b
    SlamAndAwe.db.char.colors.flameshock.a = a
    SlamAndAwe:ShockBar(SlamAndAwe.db.char.colors.flameshock)
  end

  function SlamAndAwe:getFlameShockDotColor(info)
    local colors = SlamAndAwe.db.char.colors.flameshockDot
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setFlameShockDotColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.flameshockDot.r = r
    SlamAndAwe.db.char.colors.flameshockDot.g = g
    SlamAndAwe.db.char.colors.flameshockDot.b = b
    SlamAndAwe.db.char.colors.flameshockDot.a = a
    FSDotTime = GetTime() + 18
    SlamAndAwe:FlameShockDotBar(true)
  end

  function SlamAndAwe:getFrostShockColor(info)
    local colors = SlamAndAwe.db.char.colors.frostshock
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setFrostShockColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.frostshock.r = r
    SlamAndAwe.db.char.colors.frostshock.g = g
    SlamAndAwe.db.char.colors.frostshock.b = b
    SlamAndAwe.db.char.colors.frostshock.a = a
    SlamAndAwe:ShockBar(SlamAndAwe.db.char.colors.frostshock)
  end

  function SlamAndAwe:getWindShearColor(info)
    local colors = SlamAndAwe.db.char.colors.windshear
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setWindShearColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.windshear.r = r
    SlamAndAwe.db.char.colors.windshear.g = g
    SlamAndAwe.db.char.colors.windshear.b = b
    SlamAndAwe.db.char.colors.windshear.a = a
    SlamAndAwe:ShearBar()
  end

  function SlamAndAwe:getStormstrikeColor(info)
    local colors = SlamAndAwe.db.char.colors.stormstrike
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setStormstrikeColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.stormstrike.r = r
    SlamAndAwe.db.char.colors.stormstrike.g = g
    SlamAndAwe.db.char.colors.stormstrike.b = b
    SlamAndAwe.db.char.colors.stormstrike.a = a
    SlamAndAwe:StormstrikeBar()
  end

  function SlamAndAwe:getDemoShoutColor(info)
    local colors = SlamAndAwe.db.char.colors.demoshout
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setDemoShoutColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.demoshout.r = r
    SlamAndAwe.db.char.colors.demoshout.g = g
    SlamAndAwe.db.char.colors.demoshout.b = b
    SlamAndAwe.db.char.colors.demoshout.a = a
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.currentspec == "Protection" then
      SlamAndAwe:DemoShoutBar()
    end
  end

  function SlamAndAwe:getLastStandColor(info)
    local colors = SlamAndAwe.db.char.colors.laststand
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setLastStandColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.laststand.r = r
    SlamAndAwe.db.char.colors.laststand.g = g
    SlamAndAwe.db.char.colors.laststand.b = b
    SlamAndAwe.db.char.colors.laststand.a = a
    SlamAndAwe:RedrawFrames()
    if SlamAndAwe.db.char.currentspec == "Protection" then
      SlamAndAwe:LastStandBar()
    end
  end

  function SlamAndAwe:getWindfuryColor(info)
    local colors = SlamAndAwe.db.char.colors.windfury
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setWindfuryColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.windfury.r = r
    SlamAndAwe.db.char.colors.windfury.g = g
    SlamAndAwe.db.char.colors.windfury.b = b
    SlamAndAwe.db.char.colors.windfury.a = a
    SlamAndAwe:WFProcBar()
  end

  function SlamAndAwe:getIgnorePainColor(info)
    local colors = SlamAndAwe.db.char.colors.ignorepain
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setIgnorePainColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.ignorepain.r = r
    SlamAndAwe.db.char.colors.ignorepain.g = g
    SlamAndAwe.db.char.colors.ignorepain.b = b
    SlamAndAwe.db.char.colors.ignorepain.a = a
  end

  function SlamAndAwe:getShieldBlockColor(info)
    local colors = SlamAndAwe.db.char.colors.shieldblock
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setShieldBlockColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.shieldblock.r = r
    SlamAndAwe.db.char.colors.shieldblock.g = g
    SlamAndAwe.db.char.colors.shieldblock.b = b
    SlamAndAwe.db.char.colors.shieldblock.a = a
    if SlamAndAwe.db.char.currentspec == "Protection" then
      SlamAndAwe:ShieldBlockBar()
    end
  end

  function SlamAndAwe:getShieldWallColor(info)
    local colors = SlamAndAwe.db.char.colors.shieldwall
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setShieldWallColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.shieldwall.r = r
    SlamAndAwe.db.char.colors.shieldwall.g = g
    SlamAndAwe.db.char.colors.shieldwall.b = b
    SlamAndAwe.db.char.colors.shieldwall.a = a
    if SlamAndAwe.db.char.currentspec == "Protection" then
      SlamAndAwe:ShieldWallBar()
    end
  end

  function SlamAndAwe:getRageColor(info)
    local colors = SlamAndAwe.db.char.colors.rage
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:getSixtyRageColor(info)
    local colors = SlamAndAwe.db.char.colors.sixtyrage
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:getCommandingShoutColor(info)
    local colors = SlamAndAwe.db.char.colors.commandingshout
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setCommandingShoutColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.commandingshout.r = r
    SlamAndAwe.db.char.colors.commandingshout.g = g
    SlamAndAwe.db.char.colors.commandingshout.b = b
    SlamAndAwe.db.char.colors.commandingshout.a = a
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:CommandingShoutBar()
  end

  function SlamAndAwe:setRageColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.rage.r = r
    SlamAndAwe.db.char.colors.rage.g = g
    SlamAndAwe.db.char.colors.rage.b = b
    SlamAndAwe.db.char.colors.rage.a = a
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:RageBar()
  end

  function SlamAndAwe:setSixtyRageColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.sixtyrage.r = r
    SlamAndAwe.db.char.colors.sixtyrage.g = g
    SlamAndAwe.db.char.colors.sixtyrage.b = b
    SlamAndAwe.db.char.colors.sixtyrage.a = a
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:RageBar()
  end

  function SlamAndAwe:getTasteForBloodColor(info)
    local colors = SlamAndAwe.db.char.colors.tfb
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setTasteForBloodColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.tfb.r = r
    SlamAndAwe.db.char.colors.tfb.g = g
    SlamAndAwe.db.char.colors.tfb.b = b
    SlamAndAwe.db.char.colors.tfb.a = a
  end

  function SlamAndAwe:getFocusedRageColor(info)
    local colors = SlamAndAwe.db.char.colors.fr
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setFocusedRageColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.fr.r = r
    SlamAndAwe.db.char.colors.fr.g = g
    SlamAndAwe.db.char.colors.fr.b = b
    SlamAndAwe.db.char.colors.fr.a = a
  end

  function SlamAndAwe:getColossusSmashColor(info)
    local colors = SlamAndAwe.db.char.colors.colossussmash
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setColossusSmashColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.colossussmash.r = r
    SlamAndAwe.db.char.colors.colossussmash.g = g
    SlamAndAwe.db.char.colors.colossussmash.b = b
    SlamAndAwe.db.char.colors.colossussmash.a = a
    if SlamAndAwe.db.char.currentspec == "Arms" then
      SlamAndAwe:ColossusSmashBar()
    end
  end

  function SlamAndAwe:getAvatarColor(info)
    local colors = SlamAndAwe.db.char.colors.avatar
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setAvatarColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.avatar.r = r
    SlamAndAwe.db.char.colors.avatar.g = g
    SlamAndAwe.db.char.colors.avatar.b = b
    SlamAndAwe.db.char.colors.avatar.a = a
    if SlamAndAwe.db.char.talAvatar then
      SlamAndAwe:AvatarBar()
    end
  end

  function SlamAndAwe:getDragonRoarColor(info)
    local colors = SlamAndAwe.db.char.colors.dragonroar
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setDragonRoarColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.dragonroar.r = r
    SlamAndAwe.db.char.colors.dragonroar.g = g
    SlamAndAwe.db.char.colors.dragonroar.b = b
    SlamAndAwe.db.char.colors.dragonroar.a = a
    if SlamAndAwe.db.char.talDragonRoar then
      SlamAndAwe:DragonRoarBar()
    end
  end

  function SlamAndAwe:getBattleCryColor(info)
    local colors = SlamAndAwe.db.char.colors.battlecry
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setBattleCryColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.battlecry.r = r
    SlamAndAwe.db.char.colors.battlecry.g = g
    SlamAndAwe.db.char.colors.battlecry.b = b
    SlamAndAwe.db.char.colors.battlecry.a = a
    SlamAndAwe:BattleCryBar()
  end

  function SlamAndAwe:getBloodbathColor(info)
    local colors = SlamAndAwe.db.char.colors.bloodbath
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setBloodbathColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.bloodbath.r = r
    SlamAndAwe.db.char.colors.bloodbath.g = g
    SlamAndAwe.db.char.colors.bloodbath.b = b
    SlamAndAwe.db.char.colors.bloodbath.a = a
    SlamAndAwe:BloodbathBar()
  end

  function SlamAndAwe:getFireNovaColor(info)
    local colors = SlamAndAwe.db.char.colors.firenova
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setFireNovaColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.firenova.r = r
    SlamAndAwe.db.char.colors.firenova.g = g
    SlamAndAwe.db.char.colors.firenova.b = b
    SlamAndAwe.db.char.colors.firenova.a = a
    SlamAndAwe:FireNovaBar()
  end

  function SlamAndAwe:getMagmaColor(info)
    local colors = SlamAndAwe.db.char.colors.magma
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setMagmaColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.magma.r = r
    SlamAndAwe.db.char.colors.magma.g = g
    SlamAndAwe.db.char.colors.magma.b = b
    SlamAndAwe.db.char.colors.magma.a = a
    SlamAndAwe:MagmaBar()
  end

  function SlamAndAwe:getLavaBurstColor(info)
    local colors = SlamAndAwe.db.char.colors.lavaburst
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setLavaBurstColor(info,r,g,b,a)
    SlamAndAwe.db.char.colors.lavaburst.r = r
    SlamAndAwe.db.char.colors.lavaburst.g = g
    SlamAndAwe.db.char.colors.lavaburst.b = b
    SlamAndAwe.db.char.colors.lavaburst.a = a
    SlamAndAwe:LavaBurstBar()
  end

  function SlamAndAwe:getIPColor(info)
    local colors = SlamAndAwe.db.char.uptime.ip
    return colors.r, colors.g, colors.b, colors.a
  end
  --
  function SlamAndAwe:setIPColor(info,r,g,b,a)
    SlamAndAwe.db.char.uptime.ip.r = r
    SlamAndAwe.db.char.uptime.ip.g = g
    SlamAndAwe.db.char.uptime.ip.b = b
    SlamAndAwe.db.char.uptime.ip.a = a
    local buffColors = SlamAndAwe.db.char.uptime.ip
    SlamAndAwe.uptime.session.buffs[GetSpellInfo(SlamAndAwe.constants["Ignore Pain ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
    SlamAndAwe.uptime.lastfight.buffs[GetSpellInfo(SlamAndAwe.constants["Ignore Pain ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
  end
  --
  function SlamAndAwe:getENColor(info)
    local colors = SlamAndAwe.db.char.uptime.en
    return colors.r, colors.g, colors.b, colors.a
  end
  --
  function SlamAndAwe:setENColor(info,r,g,b,a)
    SlamAndAwe.db.char.uptime.en.r = r
    SlamAndAwe.db.char.uptime.en.g = g
    SlamAndAwe.db.char.uptime.en.b = b
    SlamAndAwe.db.char.uptime.en.a = a
    local buffColors = SlamAndAwe.db.char.uptime.en

    SlamAndAwe.uptime.session.buffs[GetSpellInfo(SlamAndAwe.constants["Enrage ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
    SlamAndAwe.uptime.lastfight.buffs[GetSpellInfo(SlamAndAwe.constants["Enrage ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
  end
  --
  function SlamAndAwe:getSBColor(info)
    local colors = SlamAndAwe.db.char.uptime.sb
    return colors.r, colors.g, colors.b, colors.a
  end
  --
  function SlamAndAwe:setSBColor(info,r,g,b,a)
    SlamAndAwe.db.char.uptime.sb.r = r
    SlamAndAwe.db.char.uptime.sb.g = g
    SlamAndAwe.db.char.uptime.sb.b = b
    SlamAndAwe.db.char.uptime.sb.a = a
    local buffColors = SlamAndAwe.db.char.uptime.sb

    SlamAndAwe.uptime.session.buffs[GetSpellInfo(SlamAndAwe.constants["Shield Block ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
    SlamAndAwe.uptime.lastfight.buffs[GetSpellInfo(SlamAndAwe.constants["Shield Block ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
  end

  function SlamAndAwe:getWFTotalsColor(info)
    local colors = SlamAndAwe.db.char.stats.wfcol
    return colors.r, colors.g, colors.b, colors.a
  end

  function SlamAndAwe:setWFTotalsColor(info,r,g,b,a)
    SlamAndAwe.db.char.stats.wfcol.r = r
    SlamAndAwe.db.char.stats.wfcol.g = g
    SlamAndAwe.db.char.stats.wfcol.b = b
    SlamAndAwe.db.char.stats.wfcol.a = a
  end

  function SlamAndAwe:getFrameStrataLevel(info)
    local retValue = SlamAndAwe.db.char.framestratalevel

    if retValue == "BACKGROUND" then
      return 1
    elseif retValue == "LOW" then
      return 2
    elseif retValue == "MEDIUM" then
      return 3
    else
      return 4
    end
  end

  function SlamAndAwe:setFrameStrataLevel(info, newValue)
    if newValue == 1 then
      newValue = "BACKGROUND"
    elseif newValue == 2 then
      newValue = "LOW"
    elseif newValue == 3 then
      newValue = "MEDIUM"
    else
      newValue = "HIGH"
    end
    SlamAndAwe.db.char.framestratalevel = newValue
    SlamAndAwe:RedrawFrames()
    SlamAndAwe:Print(L["config_framestratalevel"]..newValue)
  end
  -----------------------------------------
  -- Annoucement Functions
  -----------------------------------------
  function SlamAndAwe:MessageType(input)
    i = { "SAY", "YELL", "PARTY", "RAID" }
    return i[input]
  end

  --Skull Banner
  function SlamAndAwe:SkullBannerAnnounceQuery()
    -- return SlamAndAwe.db.char.announce_skull_banner
  end

  function SlamAndAwe:ActivateAnnounceSkullBanner()
    -- SlamAndAwe.db.char.announce_skull_banner = not SlamAndAwe.db.char.announce_skull_banner
    -- if (SlamAndAwe.db.char.announce_skull_banner) then
    -- SlamAndAwe:Print(L["config_skull_banner_announce_on"])
    -- else
    -- SlamAndAwe:Print(L["config_skull_banner_announce_off"])
    -- end
  end

  function SlamAndAwe:GetSkullBannerAnnounceLocation(info)
    -- return SlamAndAwe.db.char.announce_skull_banner_where
  end

  function SlamAndAwe:SetSkullBannerAnnounceLocation(info, newValue)
    -- SlamAndAwe.db.char.announce_skull_banner_where = newValue
    -- SlamAndAwe:Print(L["config_skull_banner_announce_where"]..SlamAndAwe:MessageType(newValue))
  end

  --Demoralizing Banner
  function SlamAndAwe:DemoralizingBannerAnnounceQuery()
    -- return SlamAndAwe.db.char.announce_demoralizing_banner
  end

  function SlamAndAwe:ActivateAnnounceDemoralizingBanner()
    -- SlamAndAwe.db.char.announce_demoralizing_banner = not SlamAndAwe.db.char.announce_demoralizing_banner
    -- if (SlamAndAwe.db.char.announce_demoralizing_banner) then
    -- SlamAndAwe:Print(L["config_demoralizing_banner_announce_on"])
    -- else
    -- SlamAndAwe:Print(L["config_demoralizing_banner_announce_off"])
    -- end
  end

  function SlamAndAwe:GetDemoralizingBannerAnnounceLocation(info)
    -- return SlamAndAwe.db.char.announce_demoralizing_banner_where
  end

  function SlamAndAwe:SetDemoralizingBannerAnnounceLocation(info, newValue)
    -- SlamAndAwe.db.char.announce_demoralizing_banner_where = newValue
    -- SlamAndAwe:Print(L["config_demoralizing_banner_announce_where"]..SlamAndAwe:MessageType(newValue))
  end

  --Mocking Banner
  function SlamAndAwe:MockingBannerAnnounceQuery()
    -- return SlamAndAwe.db.char.announce_mocking_banner
  end

  function SlamAndAwe:ActivateAnnounceMockingBanner()
    -- SlamAndAwe.db.char.announce_mocking_banner = not SlamAndAwe.db.char.announce_mocking_banner
    -- if (SlamAndAwe.db.char.announce_mocking_banner) then
    -- SlamAndAwe:Print(L["config_mocking_banner_announce_on"])
    -- else
    -- SlamAndAwe:Print(L["config_mocking_banner_announce_off"])
    -- end
  end

  function SlamAndAwe:GetMockingBannerAnnounceLocation(info)
    -- return SlamAndAwe.db.char.announce_mocking_banner_where
  end

  function SlamAndAwe:SetMockingBannerAnnounceLocation(info, newValue)
    -- SlamAndAwe.db.char.announce_mocking_banner_where = newValue
    -- SlamAndAwe:Print(L["config_mocking_banner_announce_where"]..SlamAndAwe:MessageType(newValue))
  end

  --Interrupt Announce
  function SlamAndAwe:InterruptAnnounceQuery()
    return SlamAndAwe.db.char.announce_interrupt
  end

  function SlamAndAwe:ActivateAnnounceInterrupt()
    SlamAndAwe.db.char.announce_interrupt = not SlamAndAwe.db.char.announce_interrupt
    if (SlamAndAwe.db.char.announce_interrupt) then
      SlamAndAwe:Print(L["config_interrupt_announce_on"])
    else
      SlamAndAwe:Print(L["config_interrupt_announce_off"])
    end
  end

  function SlamAndAwe:LastStandAnnounceQuery()
    return SlamAndAwe.db.char.announce_laststand
  end

  function SlamAndAwe:ActivateAnnounceLastStand()
    SlamAndAwe.db.char.announce_laststand = not SlamAndAwe.db.char.announce_laststand
    if (SlamAndAwe.db.char.announce_laststand) then
      SlamAndAwe:Print(L["config_laststand_announce_on"])
    else
      SlamAndAwe:Print(L["config_laststand_announce_off"])
    end
  end

  function SlamAndAwe:ShieldWallAnnounceQuery()
    return SlamAndAwe.db.char.announce_shieldwall
  end

  function SlamAndAwe:ActivateAnnounceShieldWall()
    SlamAndAwe.db.char.announce_shieldwall = not SlamAndAwe.db.char.announce_shieldwall
    if (SlamAndAwe.db.char.announce_shieldwall) then
      SlamAndAwe:Print(L["config_shieldwall_announce_on"])
    else
      SlamAndAwe:Print(L["config_shieldwall_announce_off"])
    end
  end

  function SlamAndAwe:GetInterruptAnnounceLocation(info)
    return SlamAndAwe.db.char.announce_interrupt_where
  end

  function SlamAndAwe:SetInterruptAnnounceLocation(info, newValue)
    SlamAndAwe.db.char.announce_interrupt_where = newValue
    SlamAndAwe:Print(L["config_interrupt_announce_where"]..SlamAndAwe:MessageType(newValue))
  end

  function SlamAndAwe:GetLastStandAnnounceLocation(info)
    return SlamAndAwe.db.char.announce_laststand_where
  end

  function SlamAndAwe:SetLastStandAnnounceLocation(info, newValue)
    SlamAndAwe.db.char.announce_laststand_where = newValue
    SlamAndAwe:Print(L["config_laststand_announce_where"]..SlamAndAwe:MessageType(newValue))
  end

  function SlamAndAwe:GetShieldWallAnnounceLocation(info)
    return SlamAndAwe.db.char.announce_shieldwall_where
  end

  function SlamAndAwe:SetShieldWallAnnounceLocation(info, newValue)
    SlamAndAwe.db.char.announce_shieldwall_where = newValue
    SlamAndAwe:Print(L["config_shieldwall_announce_where"]..SlamAndAwe:MessageType(newValue))
  end

  -----------------------------------------
  -- Priority Choices
  -----------------------------------------

  function SlamAndAwe:GetPriorityGroup(info)
    return SlamAndAwe.db.char.priority.groupnumber
  end

  function SlamAndAwe:SetPriorityGroup(info, groupnumber)
    SlamAndAwe.db.char.priority.groupnumber = groupnumber
    SlamAndAwe:SelectPrioritySet(groupnumber)
  end

  function SlamAndAwe:GetPriority(index)
    return
    function(info)
      return SlamAndAwe.db.char.priority.prOption[index]
    end
  end

  function SlamAndAwe:GetPriorityDesc(index)
    return
    function(info)
      return SlamAndAwe.priorityTable.name[SlamAndAwe.db.char.priority.prOption[index]]
    end
  end

  function SlamAndAwe:SetPriority(index)
    return
    function(info, priorityValue)
      SlamAndAwe:DebugPrint("Setting priority "..index.." to "..priorityValue)
      SlamAndAwe.db.char.priority.prOption[index] = priorityValue
      SlamAndAwe.db.char.priority.prOptions[SlamAndAwe.db.char.priority.groupnumber] = SlamAndAwe.db.char.priority.prOption
    end
  end

  function SlamAndAwe:priorityQuery()
    return SlamAndAwe.db.char.priority.show
  end

  function SlamAndAwe:ActivatePriority()
    SlamAndAwe.db.char.priority.show = not SlamAndAwe.db.char.priority.show
    if (SlamAndAwe.db.char.priority.show) then
      SlamAndAwe:Print(L["config_priority_on"])
    else
      SlamAndAwe.PriorityFrame:Hide()
      SlamAndAwe:Print(L["config_priority_off"])
    end
  end

  function SlamAndAwe:priorityTitleQuery()
    return SlamAndAwe.db.char.priority.titleshow
  end

  function SlamAndAwe:ActivatePriorityTitle()
    SlamAndAwe.db.char.priority.titleshow = not SlamAndAwe.db.char.priority.titleshow
    if SlamAndAwe.db.char.priority.titleshow then
      SlamAndAwe.PriorityFrame.topText:Show()
      SlamAndAwe:Print(L["config_prioritytitle_on"])
    else
      SlamAndAwe.PriorityFrame.topText:Hide()
      SlamAndAwe:Print(L["config_prioritytitle_off"])
    end
  end

  ---------------
  -- Warnings
  ---------------

  function SlamAndAwe:WarningFrameQuery()
    return SlamAndAwe.db.char.warning.show
  end

  function SlamAndAwe:ActivateWarningFrame()
    SlamAndAwe.db.char.warning.show = not SlamAndAwe.db.char.warning.show
    if (SlamAndAwe.db.char.warning.show) then
      SlamAndAwe:Print(L["config_warnframe_on"])
    else
      SlamAndAwe:Print(L["config_warnframe_off"])
    end
  end

  function SlamAndAwe:rangeWarnQuery()
    return SlamAndAwe.db.char.warning.range
  end

  function SlamAndAwe:ActivateRangeWarn()
    SlamAndAwe.db.char.warning.range = not SlamAndAwe.db.char.warning.range
    if (SlamAndAwe.db.char.warning.range) then
      SlamAndAwe:Print(L["config_rangewarn_on"])
    else
      SlamAndAwe:Print(L["config_rangewarn_off"])
    end
  end

  function SlamAndAwe:interruptWarnQuery()
    return SlamAndAwe.db.char.warning.interrupt
  end

  function SlamAndAwe:enableDisableBorderQuery()
    return SlamAndAwe.db.char.enableDisableBorder
  end

  function SlamAndAwe:enableDisableRageBarBorderQuery()
    return SlamAndAwe.db.char.ragebar.enableDisableBorder
  end

  function SlamAndAwe:enableDisablePriorityBorderQuery()
    return SlamAndAwe.db.char.priority.enableDisableBorder
  end

  function SlamAndAwe:ActivateEnableDisableBorder()
    SlamAndAwe.db.char.enableDisableBorder = not SlamAndAwe.db.char.enableDisableBorder
    if (SlamAndAwe.db.char.enableDisableBorder) then
      SlamAndAwe:Print("Borders will no longer be shown")
      SlamAndAwe.barBackdrop = {
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      }
      SlamAndAwe.frameBackdrop ={
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      }
      SlamAndAwe.frames["GCD"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["IgnorePain"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ShieldBlock"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ShieldWall"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ColossusSmash"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["BattleCry"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["Bloodbath"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["Avatar"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["DragonRoar"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["DemoShout"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["LastStand"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["CommandingShout"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["GCD"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["IgnorePain"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["ShieldBlock"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["ShieldWall"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["ColossusSmash"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["BattleCry"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["Bloodbath"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["Avatar"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["DragonRoar"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["DemoShout"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["LastStand"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["CommandingShout"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe:RedrawFrames()
    else
      SlamAndAwe.barBackdrop = {
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        tile = false, tileSize = 0, edgeSize = 12,
        insets = { left = 2, right = 2, top = 2, bottom = 2 }
      }
      SlamAndAwe.frameBackdrop ={
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        tile = false, tileSize = 0, edgeSize = 12,
        insets = { left = 0, right = 0, top = 0, bottom = 0 }
      }

      SlamAndAwe.frames["GCD"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["IgnorePain"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ShieldBlock"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ShieldWall"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["ColossusSmash"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["BattleCry"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["Bloodbath"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["Avatar"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["DragonRoar"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["DemoShout"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["LastStand"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["CommandingShout"]:SetBackdrop(SlamAndAwe.barBackdrop)
      SlamAndAwe.frames["GCD"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["IgnorePain"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["ShieldBlock"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["ShieldWall"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["ColossusSmash"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["BattleCry"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["Bloodbath"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["Avatar"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["DragonRoar"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["DemoShout"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["LastStand"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe.frames["CommandingShout"]:SetBackdrop(SlamAndAwe.frameBackdrop)
      SlamAndAwe:RedrawFrames()
    end
  end

  function SlamAndAwe:ActivateEnableDisablePriorityBorder()
    SlamAndAwe.db.char.priority.enableDisableBorder = not SlamAndAwe.db.char.priority.enableDisableBorder

    if (SlamAndAwe.db.char.priority.enableDisableBorder) then
      SlamAndAwe:Print("Priority border will no longer be shown")
      --[[ SlamAndAwe.priorityBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
    SlamAndAwe.priorityframeBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
    -- SlamAndAwe.PriorityFrame:SetBackdrop(SlamAndAwe.prioritybarBackdrop)
    -- SlamAndAwe.PriorityFrame:SetBackdrop(SlamAndAwe.priorityframeBackdrop)
    ]]
    SlamAndAwe:RedrawFrames()
  else
    --[[
    SlamAndAwe.priorityBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 2, right = 2, top = 2, bottom = 2 }
    }

    SlamAndAwe.priorityframeBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 0, right = 0, top = 0, bottom = 0 }
    }

    -- SlamAndAwe.PriorityFrame:SetBackdrop(SlamAndAwe.priorityBackdrop)
    -- SlamAndAwe.PriorityFrame:SetBackdrop(SlamAndAwe.priorityframeBackdrop)
    ]]
    SlamAndAwe:RedrawFrames()
  end
end

function SlamAndAwe:ActivateEnableDisableRageBarBorder()
  SlamAndAwe.db.char.ragebar.enableDisableBorder = not SlamAndAwe.db.char.ragebar.enableDisableBorder
  if (SlamAndAwe.db.char.ragebar.enableDisableBorder) then
    SlamAndAwe:Print("Borders will no longer be shown")
    SlamAndAwe.ragebarBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
    SlamAndAwe.rageframeBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
    SlamAndAwe.frames["Rage"]:SetBackdrop(SlamAndAwe.ragebarBackdrop)
    SlamAndAwe.frames["Rage"]:SetBackdrop(SlamAndAwe.rageframeBackdrop)
    SlamAndAwe:RedrawFrames()
  else

    SlamAndAwe.ragebarBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 2, right = 2, top = 2, bottom = 2 }
    }

    SlamAndAwe.rageframeBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 0, right = 0, top = 0, bottom = 0 }
    }

    SlamAndAwe.frames["Rage"]:SetBackdrop(SlamAndAwe.ragebarBackdrop)
    SlamAndAwe.frames["Rage"]:SetBackdrop(SlamAndAwe.rageframeBackdrop)
    SlamAndAwe:RedrawFrames()
  end

  SlamAndAwe:RageBar()
end

function SlamAndAwe:ActivateInterruptWarn()
  SlamAndAwe.db.char.warning.interrupt = not SlamAndAwe.db.char.warning.interrupt
  if (SlamAndAwe.db.char.warning.interrupt) then
    SlamAndAwe:Print(L["config_interruptwarn_on"])
  else
    SlamAndAwe:Print(L["config_interruptwarn_off"])
  end
end

function SlamAndAwe:EnableDisable()
  if SlamAndAwe.db.char.disabled then
    SlamAndAwe:Enable()
  else
    SlamAndAwe:Disable()
  end
end

function SlamAndAwe:Disable()
  if InCombatLockdown() then
    SlamAndAwe:Print(L["Cannot enable/disable addon in combat"])
    return
  end
  SlamAndAwe.db.char.disabled = true
  SlamAndAwe:OnDisable()
  SlamAndAwe.PriorityFrame:Hide()
  SlamAndAwe.UptimeFrame:Hide()
  SlamAndAwe.frames["Rage"]:Hide()
  SlamAndAwe.frames["IgnorePain"]:Hide()
  SlamAndAwe.frames["IgnorePain"].icon:Hide()
  SlamAndAwe:Print(L["config_disabled_on"])
end

function SlamAndAwe:Enable()

  local currentSpec = GetSpecialization()
  if InCombatLockdown() then
    SlamAndAwe:Print(L["Cannot enable/disable addon in combat"])
    return
  end
  SlamAndAwe.db.char.disabled = false
  SlamAndAwe:OnEnable()
  SlamAndAwe:RedrawFrames()
  if not SlamAndAwe.db.char.movingframes then -- need to ensure moving frames is false on enabled to disabled to enabled
    SlamAndAwe.db.char.movingframes = true -- forces false in ShowHideBars to re-enable frames -- need a better hack
  else
    SlamAndAwe.db.char.movingframes = false
  end

  SlamAndAwe:ShowHideBars()
  SlamAndAwe:Print(L["config_disabled_off"])
  SlamAndAwe:RageBar()

end

function SlamAndAwe:ResetImmunity()
  SlamAndAwe.db.char.immuneTargets = {}
  SlamAndAwe:Print(L["config_resetImmunity"])
end

function SlamAndAwe:GetMSBTareas(info)
  return SlamAndAwe.db.char.MSBToutputarea
end

function SlamAndAwe:SetMSBTareas(info, value)
  SlamAndAwe.db.char.MSBToutputarea = value
end

function SlamAndAwe:getWarningColor(info)
  local colors = SlamAndAwe.db.char.warning.color
  return colors.r, colors.g, colors.b, colors.a
end

function SlamAndAwe:setWarningColor(info,r,g,b,a)
  SlamAndAwe.db.char.warning.color.r = r
  SlamAndAwe.db.char.warning.color.g = g
  SlamAndAwe.db.char.warning.color.b = b
  SlamAndAwe.db.char.warning.color.a = a
end

function SlamAndAwe:GetWarningDuration(info)
  return SlamAndAwe.db.char.warning.duration
end

function SlamAndAwe:SetWarningDuration(info, priorityValue)
  SlamAndAwe.db.char.warning.duration = priorityValue
end

function SlamAndAwe:OpenConfig()
  if InterfaceOptionsFrame_OpenToCategory then
    InterfaceOptionsFrame_OpenToCategory("SlamAndAwe");
  else
    InterfaceOptionsFrame_OpenToFrame("SlamAndAwe");
  end
end

function SlamAndAwe:GetMSBTAreaDefaults()
  local i = 0;
  SlamAndAwe.MSBT = {}
  SlamAndAwe.MSBT.areas = {}
  if MikSBT ~= nil and MikSBT.IterateScrollAreas ~= nil then
    for scrollAreaKey, scrollAreaName in MikSBT.IterateScrollAreas() do
      i = i + 1
      SlamAndAwe.MSBT.areas[i] = scrollAreaName
    end
  end
end

function SlamAndAwe:DebugPrintPriorityGroups()
  for group = 1, 5 do
    for index = 1, 30 do
      print("SlamAndAwe.furyOptions = { \""..SlamAndAwe.db.char.priority.prOptions[group][index].."\"")
    end
  end
end
