-- @release $Id: SlamAndAwe.lua 450 2016-08-31 16:52:57Z reighnman $

-- Disable addon for non-warrior classes
if select(2, UnitClass('player')) ~= "WARRIOR" then
  DisableAddOn("SlamAndAwe")
  return
end

--Ace declaration
local L = LibStub("AceLocale-3.0"):GetLocale("SlamAndAwe")
local AceAddon = LibStub("AceAddon-3.0")
SlamAndAwe = AceAddon:NewAddon("SlamAndAwe", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local SCT = SCT
local REVISION = tonumber(("$Revision: 450 $"):match("%d+"))
local _, _, _, clientVersion = GetBuildInfo()
local queryDisable = false
local media = LibStub("LibSharedMedia-3.0")

--SpellCache
local spellcache = setmetatable({}, {__index=function(t,v) local a = {GetSpellInfo(v)} if GetSpellInfo(v) then t[v] = a end return a end})
local function GetSpellInfo(a)
  return unpack(spellcache[a])
end

--Bar declaration
SlamAndAwe.frames = {}

SlamAndAwe.BaseFrame = CreateFrame("Frame","SlamAndAweBase",UIParent)
SlamAndAwe.frames["TasteForBlood"] = CreateFrame("Frame","SAA_Bar1_Status", SlamAndAwe.BaseFrame)
SlamAndAwe.frames["TasteForBlood"].icon = CreateFrame("Frame","SAA_Bar1_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["IgnorePain"] = CreateFrame("Frame","SAA_Bar2_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["IgnorePain"].icon = CreateFrame("Frame","SAA_Bar2_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["ShieldBlock"] = CreateFrame("Frame","SAA_Bar3_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["ShieldBlock"].icon = CreateFrame("Frame","SAA_Bar3_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["ShieldWall"] = CreateFrame("Frame","SAA_Bar4_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["ShieldWall"].icon = CreateFrame("Frame","SAA_Bar4_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["ColossusSmash"] = CreateFrame("Frame","SAA_Bar5_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["ColossusSmash"].icon = CreateFrame("Frame","SAA_Bar5_StatusIcon",SlamAndAwe.BaseFrame)
--self.PriorityFrame.cooldown:SetSwipeTexture('Interface/Cooldown/edge')
-- self.PriorityFrame.cooldown:SetSwipeColor(0, 0, 0, 0.8)
SlamAndAwe.frames["Bloodbath"] = CreateFrame("Frame","SAA_Bar6_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["Bloodbath"].icon = CreateFrame("Frame","SAA_Bar6_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["BattleCry"] = CreateFrame("Frame","SAA_Bar7_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["BattleCry"].icon = CreateFrame("Frame","SAA_Bar7_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["Avatar"] = CreateFrame("Frame","SAA_Bar8_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["Avatar"].icon = CreateFrame("Frame","SAA_Bar8_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["DragonRoar"] = CreateFrame("Frame","SAA_Bar8_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["DragonRoar"].icon = CreateFrame("Frame","SAA_Bar8_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["GCD"] = CreateFrame("Frame", "SAA_Bar10_Status", SlamAndAwe.BaseFrame)
SlamAndAwe.frames["DemoShout"] = CreateFrame("Frame","SAA_Bar11_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["DemoShout"].icon = CreateFrame("Frame","SAA_Bar11_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["LastStand"] = CreateFrame("Frame","SAA_Bar12_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["LastStand"].icon = CreateFrame("Frame","SAA_Bar12_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["CommandingShout"] = CreateFrame("Frame","SAA_Bar13_Status",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["CommandingShout"].icon = CreateFrame("Frame","SAA_Bar13_StatusIcon",SlamAndAwe.BaseFrame)
SlamAndAwe.frames["FocusedRage"] = CreateFrame("Frame","SAA_Bar14_Status", SlamAndAwe.BaseFrame)
SlamAndAwe.frames["FocusedRage"].icon = CreateFrame("Frame","SAA_Bar14_StatusIcon",SlamAndAwe.BaseFrame)

SlamAndAwe.RageFrame = CreateFrame("Frame","SlamAndAweRage",UIParent)
SlamAndAwe.frames["Rage"] = CreateFrame("Frame","SAA_Bar9_Status",SlamAndAwe.RageFrame)

SlamAndAwe.msgFrame = CreateFrame("MessageFrame","SlamAndAweMsg",UIParent)
SlamAndAwe.questionFrame = CreateFrame("Frame","SlamAndAweQuestion",UIParent)

--Table declaration
SlamAndAwe.textures = {}
SlamAndAwe.borders = {}
SlamAndAwe.fonts = {}
SlamAndAwe.sounds = {}
SlamAndAwe.barOffset = {}

--Variable declaration (some of these are duplicates with the default db options??)
SlamAndAwe.GCDMin = 0
SlamAndAwe.GCDMax = 0
SlamAndAwe.GCDWidth = 0

local shearMin, ShearMax --Probably not needed anymore

local CSMin, CSMax, BBMin, BBMax, RageMin, RageMax, IPMin, IPMax, SBlMin, SBlPos, SWMin, SWMax, BCMin, BCMax, tfbMin, tfbMax, AVAMin, AVAMax, DRMin, DRMax,
DemoShoutMin, DemoShoutMax, LastStandMin, LastStandMax, CommandingShoutMin, CommandingShoutMax, BBTime, BBMin, BBMax, frMin, frMax
local updateActiveRage = false
local GCDPercent
local GCDTime = 0
local updateActiveGCD = true
local updateActiveColossusSmash = false
local CSTime = 0
local updateActiveIgnorePain = false
local IPTime = 0
local IPLast = 0
local SBMin = 0
local SBMax = 10
local SBActive = false
local updateActiveBloodbath = false
local RETime = 0
local updateActiveBattleCry = false
local BCTime = 0
local updateActiveShieldBlock = false
local SBlTime = 0
local SBlMax = 6
local updateActiveAvatar = false
local AVATime = 0
local updateActiveDragonRoar = false
local DRTime = 0
local updateActiveDemoShout = false
local DemoShoutTime = 0
local updateActiveLastStand = false
local LastStandTime = 0
local UpdateActiveCommandingShout = false
local CommandingShoutTime = 0
local updateActiveShieldWall = false
local SWTime = 0
local updateActiveTasteForBlood = false
local lastSound = 0
local tfbTime = 0
local tfbflashing = false
local tfb4played = false
local updateActiveFocusedRage = false
local frTime = 0
local frflashing = false
local fr3played = false
local updateActiveBanner = false
local last_banner_msg = nil
local last_banner_where = nil
local BannerTime = nil

-----------------------------------------
-- Initialization & Startup Routines
-----------------------------------------

function SlamAndAwe:OnInitialize()
  local AceConfigReg = LibStub("AceConfigRegistry-3.0")
  local AceConfigDialog = LibStub("AceConfigDialog-3.0")

  self:SetConstants()
  self:SetBindings()
  self:SetDefaultOptions()
  SlamAndAwe.db = LibStub("AceDB-3.0"):New("SlamAndAweDBPC", SlamAndAwe.defaults, "char")
  self:SetPriorityTable()
  self:GetMSBTAreaDefaults()
  LibStub("AceConfig-3.0"):RegisterOptionsTable("SlamAndAwe", self:GetOptions(), {"slamandawe", "saa"} )
  media.RegisterCallback(self, "LibSharedMedia_Registered")

  -- Add the options to blizzard frame (add them backwards so they show up in the proper order
  self.optionsFrame = AceConfigDialog:AddToBlizOptions("SlamAndAwe", "SlamAndAwe")
  SlamAndAwe.db:RegisterDefaults(SlamAndAwe.defaults)
  SlamAndAwe.db.RegisterCallback(self, "OnProfileReset", "SetSpecialization")
  if not SlamAndAwe.db.char.immuneTargets then
    SlamAndAwe.db.char.immuneTargets = {}
  end
  self:InitialiseUptime()
  self:InitialiseBindings()
  self:CreateUptimeFrame()
  self:CreatePriorityFrame()
  self:CreateMsgFrame()
  --self:News()
  self:VerifyOptions()

  if SlamAndAwe.db.char.enableDisableBorder then
    SlamAndAwe.barBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",

    }
    SlamAndAwe.frameBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
  else
    SlamAndAwe.barBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 2, right = 2, top = 2, bottom = 2 }
    }
    SlamAndAwe.frameBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 0, right = 0, top = 0, bottom = 0 }
    }
  end

  if SlamAndAwe.db.char.enableDisableRageBarBorder then
    SlamAndAwe.ragebarBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",

    }
    SlamAndAwe.rageframeBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
  else
    SlamAndAwe.ragebarBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 2, right = 2, top = 2, bottom = 2 }
    }
    SlamAndAwe.rageframeBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 0, right = 0, top = 0, bottom = 0 }
    }
  end

  --Specialization specific enable/disable
  if not SlamAndAwe.db.char.enableProtSpec and not SlamAndAwe.db.char.disabled and currentSpec == 3 then
    SlamAndAwe:Disable()
  elseif not SlamAndAwe.db.char.enableFurySpec and not SlamAndAwe.db.char.disabled and currentSpec == 2 then
    SlamAndAwe:Disable()
  elseif not SlamAndAwe.db.char.enableArmsSpec and not SlamAndAwe.db.char.disabled and currentSpec == 1 then
    SlamAndAwe:Disable()
  end

  --End initialization (print loaded message)
  local version = GetAddOnMetadata("SlamAndAwe","Version")
  self.version = ("SlamAndAwe v%s (r%s)"):format(version, REVISION)
  self:Print(self.version.." Loaded.")
end

-----------------------------------------
-- Constants / Spell Identifiers
-----------------------------------------

function SlamAndAwe:CreateConstant(Name, id)
  local icon_name = ""..Name.." Icon"
  local id_name = ""..Name.." ID"
  SlamAndAwe.constants[Name] = Name
  SlamAndAwe.constants[icon_name] = GetSpellTextureFileName(id)
  SlamAndAwe.constants[id_name] = id
end

function SlamAndAwe:SetConstants()
  SlamAndAwe.constants = {}
  local C = SlamAndAwe.constants

  local currentSpec = GetSpecialization()

  --Generic catch-all to prevent errors if no specialization set
  if currentSpec == nil then
    currentSpec = 1
  end

  if currentSpec == 3 then --They are listed for Prot as well so that these abilities are avaiable regardless of spec
    SlamAndAwe:CreateConstant("Ravager", 228920) --Prot
    SlamAndAwe:CreateConstant("Focused Rage", 204488) --Prot (The spell)
    SlamAndAwe:CreateConstant("Taste for Blood", 206333) --Fury (filler)
    SlamAndAwe:CreateConstant("Whirlwind", 190411) --Fury (filler)
    SlamAndAwe:CreateConstant("Execute", 5308) --Fury (filler)
    SlamAndAwe:CreateConstant("Bladestorm", 46924) --Fury (filler)
    -- SlamAndAwe.constants["SpellCoolDown"] = 20243 --Specifically for GCD calculation
  elseif currentSpec == 2 then
    SlamAndAwe:CreateConstant("Taste for Blood", 206333) --Fury
    SlamAndAwe:CreateConstant("Whirlwind", 190411) --Fury
    SlamAndAwe:CreateConstant("Execute", 5308) --Fury
    SlamAndAwe:CreateConstant("Ravager", 152277) --Arms
    SlamAndAwe:CreateConstant("Bladestorm", 46924) --Fury
    -- SlamAndAwe.constants["SpellCoolDown"] = 5308 --Specifically for GCD calculation
  elseif currentSpec == 1 then
    SlamAndAwe:CreateConstant("Focused Rage", 207982) --Arms (The talnet)
    SlamAndAwe:CreateConstant("Taste for Blood", 159714) --Arms
    SlamAndAwe:CreateConstant("Whirlwind", 1680) --Arms
    SlamAndAwe:CreateConstant("Execute", 163201) --Arms
    SlamAndAwe:CreateConstant("Ravager", 152277) --Arms
    SlamAndAwe:CreateConstant("Bladestorm", 227847) --Arms
    -- SlamAndAwe.constants["SpellCoolDown"] = 163201 --Specifically for GCD calculation
  end
  SlamAndAwe.constants["SpellCoolDown"] = 61304 --Specifically for GCD calculation

  --All Specs Abilities (matching ID)
  SlamAndAwe:CreateConstant("Berserker Rage", 18499)
  SlamAndAwe:CreateConstant("Battle Cry", 1719)
  SlamAndAwe:CreateConstant("Heroic Throw", 57755)
  SlamAndAwe:CreateConstant("Heroic Leap", 6544)

  --Multi Spec Abilities
  SlamAndAwe:CreateConstant("Pummel", 6552)
  SlamAndAwe:CreateConstant("Shattering Throw", 64382)
  SlamAndAwe:CreateConstant("Raging Blow", 85288)
  SlamAndAwe:CreateConstant("Rampage", 184367)
  SlamAndAwe:CreateConstant("Overpower", 7384)
  SlamAndAwe:CreateConstant("Charge", 100)

  --Fury Base
  SlamAndAwe:CreateConstant("Furious Slash", 100130)
  SlamAndAwe:CreateConstant("Enraged Regeneration", 184634)
  SlamAndAwe:CreateConstant("Bloodthirst", 23881)
  SlamAndAwe:CreateConstant("Furious Slash", 100130)
  SlamAndAwe:CreateConstant("Rampage", 184367)

  --Arms Base
  SlamAndAwe:CreateConstant("Colossus Smash", 167105)
  SlamAndAwe:CreateConstant("Colossus Smash Debuff", 208086) --The debuff is different so use this with GetDebuffInfo
  SlamAndAwe:CreateConstant("Hamstring", 1715)
  SlamAndAwe:CreateConstant("Cleave", 845)
  SlamAndAwe:CreateConstant("Die by the Sword", 118038)
  SlamAndAwe:CreateConstant("Mortal Strike", 12294)
  SlamAndAwe:CreateConstant("Slam", 1464)

  --Prot Base
  SlamAndAwe:CreateConstant("Shield Block", 2565)
  SlamAndAwe:CreateConstant("Shield Wall", 871)
  SlamAndAwe:CreateConstant("Revenge", 6572)
  SlamAndAwe:CreateConstant("Shield Slam", 23922)
  SlamAndAwe:CreateConstant("Devastate", 20243)
  SlamAndAwe:CreateConstant("Thunder Clap", 6343)
  SlamAndAwe:CreateConstant("Spell Reflection", 23920)
  SlamAndAwe:CreateConstant("Last Stand", 12975)
  SlamAndAwe:CreateConstant("Demoralizing Shout", 1160)
  SlamAndAwe:CreateConstant("Intercept", 198304)
  SlamAndAwe:CreateConstant("Ignore Pain", 190456)
  SlamAndAwe:CreateConstant("Meltharion's Fury", 203524) --Artifact
  SlamAndAwe:CreateConstant("Vengeance: Ignore Pain", 202574)
  SlamAndAwe:CreateConstant("Vengeance: Focused Rage", 202573)

  --Arms & Prot
  SlamAndAwe:CreateConstant("Victory Rush", 34428)

  --Arms & Fury
  SlamAndAwe:CreateConstant("Commanding Shout", 97462)

  --Buffs & Debuffs (non-talent)
  SlamAndAwe:CreateConstant("Enrage", 184362) --Fury
  SlamAndAwe:CreateConstant("Meat Cleaver", 85739) --Fury

  --Talents
  SlamAndAwe:CreateConstant("Impending Victory", 202168)
  SlamAndAwe:CreateConstant("Bloodbath", 12292)
  SlamAndAwe:CreateConstant("Avatar", 107574)
  SlamAndAwe:CreateConstant("Storm Bolt", 107570)
  SlamAndAwe:CreateConstant("Shockwave", 46968)
  SlamAndAwe:CreateConstant("Dragon Roar", 118000)
  SlamAndAwe:CreateConstant("Wrecking Ball", 215570) --Fury buff
  SlamAndAwe:CreateConstant("Sweeping Strikes", 35429) --Arms
  SlamAndAwe:CreateConstant("Rend", 772) --Arms
  SlamAndAwe:CreateConstant("Massacre", 206315) --Fury
  SlamAndAwe:CreateConstant("Ultimatum", 122510) --Prot buff
  SlamAndAwe:CreateConstant("Frenzy", 202539) --Fury

  -- Artifact Weapons
  SlamAndAwe:CreateConstant("Shattered Defenses", 209706) --Arms maybe 209574
  SlamAndAwe:CreateConstant("Odyn's Fury", 205545) --Fury
  SlamAndAwe:CreateConstant("Warbreaker", 209577) --Arms
  SlamAndAwe:CreateConstant("Precise Strikes", 209492) --Arms maybe 209493
  SlamAndAwe:CreateConstant("Juggernaut", 200875) --Fury

  --Legendaries
  SlamAndAwe:CreateConstant("Stone Heart", 225947) --Stone Heart

end

function SlamAndAwe:OnDisable()
  -- Called when the addon is disabled
  self:UnregisterEvent("PLAYER_ENTERING_WORLD")
  self:UnregisterEvent("PLAYER_LOGIN")
  self:UnregisterEvent("PLAYER_ALIVE")
  self:UnregisterEvent("UNIT_POWER")
  self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
  self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:UnregisterEvent("CHARACTER_POINTS_CHANGED")
  self:UnregisterEvent("PLAYER_REGEN_DISABLED")
  self:UnregisterEvent("PLAYER_REGEN_ENABLED")
  self:UnregisterEvent("SPELL_UPDATE_COOLDOWN")
  self:UnregisterEvent("UPDATE_BINDINGS")
  self:UnregisterEvent("UI_ERROR_MESSAGE")
  self:UnregisterEvent("GLYPH_UPDATED")
  self:UnregisterEvent("UNIT_EXITED_VEHICLE")
  self:UnregisterEvent("UNIT_ENTERED_VEHICLE")
end

function SlamAndAwe:OnEnable()
  self:LibSharedMedia_Registered()
  self:RegisterEvent("PLAYER_ENTERING_WORLD")
  self:RegisterEvent("PLAYER_LOGIN")
  self:RegisterEvent("PLAYER_ALIVE")
  self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
  self:RegisterEvent("CHARACTER_POINTS_CHANGED")
  self:RegisterEvent("PLAYER_REGEN_DISABLED")
  self:RegisterEvent("PLAYER_REGEN_ENABLED")
  self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
  self:RegisterEvent("UPDATE_BINDINGS")
  self:RegisterEvent("UI_ERROR_MESSAGE")
  self:RegisterEvent("UNIT_POWER")
  self:RegisterEvent("UNIT_AURA")
  self:RegisterEvent("PLAYER_TALENT_UPDATE")
  self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
  self:RegisterEvent("UNIT_ENTERED_VEHICLE")
  self:RegisterEvent("UNIT_EXITED_VEHICLE")
  self:RegisterEvent("GLYPH_UPDATED")
end

function SlamAndAwe:LibSharedMedia_Registered()
  media:Register("sound", "SAA Maelstrom 1", "Sound\\Spells\\ShootWandLaunchLightning.wav")
  media:Register("sound", "SAA Maelstrom 2", "Sound\\Spells\\DynamiteExplode.wav")
  media:Register("sound", "SAA Maelstrom 3", "Sound\\Spells\\ArmorKitBuffSound.wav")
  media:Register("sound", "SAA Maelstrom 4", "Sound\\Spells\\Fizzle\\FizzleShadowA.wav")
  media:Register("sound", "SAA Maelstrom 5", "Sound\\Spells\\LevelUp.wav")
  media:Register("sound", "SAA Maelstrom 6", "Sound\\Spells\\Tradeskills\\FishBite.wav")
  media:Register("sound", "SAA Maelstrom 7", "Sound\\Spells\\Tradeskills\\MiningHitA.wav")
  media:Register("sound", "SAA Maelstrom 8", "Sound\\Spells\\AspectofTheSnake.wav")
  media:Register("sound", "SAA Maelstrom 9", "Sound\\Spells\\bind2_Impact_Base.wav")
  media:Register("sound", "SAA Shield 1", "Sound\\Doodad\\BellowIn.wav")
  media:Register("sound", "SAA Shield 2", "Sound\\Doodad\\BellowOut.wav")
  media:Register("sound", "SAA Shield 3", "Sound\\Doodad\\PVP_Lordaeron_Door_Open.wav")
  media:Register("sound", "SAA Shield 4", "Sound\\Spells\\ShaysBell.wav")

  for k, v in pairs(media:List("statusbar")) do
    self.textures[v] = v
  end
  for k, v in pairs(media:List("border")) do
    self.borders[v] = v
  end
  for k, v in pairs(media:List("font")) do
    self.fonts[v] = v
  end
  for k, v in pairs(media:List("sound")) do
    self.sounds[v] = v
  end
end

----------------------
-- Event Routines
----------------------

function SlamAndAwe:UNIT_ENTERED_VEHICLE()
  if UnitInVehicle("player") then
    self:TidyUpAfterCombat() -- on entering vehicle treat as if out of combat ie: disable incombat displays
  end
end

function SlamAndAwe:UNIT_EXITED_VEHICLE()
  if not UnitInVehicle("player") and InCombatLockdown() then
    self:EnteredCombat() -- if in combat when exit vehichle enable SlamAndAwe combat effects
  end
end

function SlamAndAwe:PLAYER_ENTERING_WORLD()
  self:SetSpecialization()
  self:SetConstants()
  self:SetBorderTexture(nil, SlamAndAwe.db.char.border)
  self:SetBarBorderTexture(nil, SlamAndAwe.db.char.barborder)
  self:SetRageBarBorderTexture(nil, SlamAndAwe.db.char.ragebar.barborder)
  self:SetPriorityBorderTexture(nil, SlamAndAwe.db.char.priority.barborder)
  self:SetTalentEffects()
  self:UpdateBindings()
  SlamAndAwe.db.char.priority.prOption = SlamAndAwe.db.char.priority.prOptions[SlamAndAwe.db.char.priority.groupnumber]
  if not SlamAndAwe.db.char.disabled then
    self:RedrawFrames()
    self:RageBar()
  end
  if SlamAndAwe.db.char.debug then
    self:Print("PLAYER_ENTERING_WORLD Fired")
  end
end

function SlamAndAwe:PLAYER_LOGIN()
  self:SetBorderTexture(nil, SlamAndAwe.db.char.border)
  self:SetBarBorderTexture(nil, SlamAndAwe.db.char.barborder)
  self:SetRageBarBorderTexture(nil, SlamAndAwe.db.char.ragebar.barborder)
  self:SetPriorityBorderTexture(nil, SlamAndAwe.db.char.priority.barborder)
  queryDisable = false -- when player first logs in set test for talents to false
  if SlamAndAwe.db.char.debug then
    self:Print("PLAYER_LOGIN Fired")
  end
end

function SlamAndAwe:PLAYER_ALIVE()
  self:SetTalentEffects()
  if not SlamAndAwe.db.char.disabled then
    self:RedrawFrames()
    self:RageBar()
    self:UpdateBindings()
    if not queryDisable then
      self:QuerySpecChanged()
      queryDisable = true
    end
  end
  if SlamAndAwe.db.char.debug then
    self:Print("PLAYER_ALIVE Fired")
  end
end

function SlamAndAwe:UI_ERROR_MESSAGE(arg1, arg2, arg3, ...)
  if SlamAndAwe.db.char.warning.range then
    --local arg1 = select(1,...) or ""
    --local arg3 = select(3,...)
    --if strfind(arg1, L["Out of range"]) or strfind(arg1, L["too far away"]) then
    if (arg2 == 359 or arg2 == 253) then
      self:PrintMsg(arg3, SlamAndAwe.db.char.warning.color, 0.5)
    end
  end
end

function SlamAndAwe:UNIT_POWER()
  if not SlamAndAwe.db.char.disabled then
    self:RageBar()
    if SlamAndAwe.db.char.ipshow then
      if SlamAndAwe.db.char.currentspec == "Protection" then
        if SlamAndAwe.db.char.debug then
          -- self:Print("Estimated IgnorePain: "..SlamAndAwe:EstimateIgnorePain())
        end
        SlamAndAwe:UpdateEstimatedIgnorePainText(SlamAndAwe:EstimateIgnorePain())
      end
    end
  end
end

function SlamAndAwe:UNIT_AURA(_, ...)
  if not SlamAndAwe.db.char.disabled then
    local arg1 = select(1,...) or ""
    if (arg1 == "player") then
      if SlamAndAwe.db.char.currentspec == "Fury" then
        updateActiveTasteForBlood = true
        SlamAndAwe.db.char.tfbstacks = self:GetTasteForBloodInfo()
        if SlamAndAwe.db.char.barstext and SlamAndAwe.db.char.tfbshow then
          self.frames["TasteForBlood"].text:SetText(SlamAndAwe.db.char.tfbstacks.." stacks")
        else
          self.frames["TasteForBlood"].text:SetText("")
        end
        self:TasteForBloodBar()
      else
        updateActiveFocusedRage = true
        SlamAndAwe.db.char.frstacks = self:GetFocusedRageInfo()
        if SlamAndAwe.db.char.barstext and SlamAndAwe.db.char.frshow then
          self.frames["FocusedRage"].text:SetText(SlamAndAwe.db.char.frstacks.." stacks")
        else
          self.frames["FocusedRage"].text:SetText("")
        end
        self:FocusedRageBar()
      end
      local ipavailable = GetSpellInfo(GetSpellInfo(SlamAndAwe.constants["Ignore Pain ID"]))
      if SlamAndAwe.db.char.ipshow and ipavailable then
        _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, IP_Current = UnitBuff("Player",GetSpellInfo(GetSpellInfo(SlamAndAwe.constants["Ignore Pain ID"])))
        if IP_Current then
          if IPActive then
            if IPLast < IP_Current then -- If Ignore Pain is already up and you were able to recast it (only with a larger ignore pain)
              self:IgnorePainBar()
            else --Ignore Pain is already up, just need to update text so the timer isnt refreshed
              self:UpdateIgnorePainText(true)
            end
          else
            if SlamAndAwe.db.char.debug then
              -- self:Print("Actual Ignore Pain Was: "..IP_Current)
            end
            self:IgnorePainBar()
          end
        else
          self:UpdateIgnorePainText(false)
        end
      end
    end
  end
end

function SlamAndAwe:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, _, _, _, _, interruptedSpellID, ...)
  if not SlamAndAwe.db.char.disabled then
    if sourceGUID == UnitGUID("player") then
      local spellID = select(1,...) or 0
      if event == "SPELL_INTERRUPT" then
        local spellName = select(1,...) -- was 5, then 7, now 1
        if spellName then
          if SlamAndAwe.db.char.warning.interrupt then
            self:PrintMsg(L["Interrupted: "] .. spellName, SlamAndAwe.db.char.warning.color, SlamAndAwe.db.char.warning.duration)
          end
          if SlamAndAwe.db.char.announce_interrupt then
            self:Announce( SlamAndAwe.db.char.announce_interrupt_where , L["Interrupted: "] ..destName.. "'s " ..GetSpellLink(interruptedSpellID)..".")
          end
        end
      end
    end
  end
end

function SlamAndAwe:SPELL_UPDATE_COOLDOWN()
  if not SlamAndAwe.db.char.disabled then
    if SlamAndAwe.db.char.gcdshow then
      self:GCDBar()
    end
  end
end

function SlamAndAwe:UNIT_SPELLCAST_SUCCEEDED(_, ...)
  if not SlamAndAwe.db.char.disabled then
    local arg1 = select(1,...) or ""
    local arg5 = select(5,...) or ""
    if arg1 == "player" then -- skip if someone else casting
      SlamAndAwe:DebugPrint(arg5)
      if SlamAndAwe.db.char.csshow then
        if arg5 == SlamAndAwe.constants["Colossus Smash ID"] then
          self:ColossusSmashBar()
        end
      end
      if SlamAndAwe.db.char.bbshow then
        if arg5 == SlamAndAwe.constants["Bloodbath ID"] then
          self:BloodbathBar()
        end
      end
      if SlamAndAwe.db.char.bcshow then
        if arg5 == SlamAndAwe.constants["Battle Cry ID"] then
          self:BattleCryBar()
        end
      end
      if SlamAndAwe.db.char.avashow then
        if arg5 == SlamAndAwe.constants["Avatar ID"] then
          self:AvatarBar()
        end
      end
      if SlamAndAwe.db.char.drshow then
        if arg5 == SlamAndAwe.constants["Dragon Roar ID"] then
          self:DragonRoarBar()
        end
      end
      if SlamAndAwe.db.char.sblshow then
        if arg5 == SlamAndAwe.constants["Shield Block ID"] then
          self:ShieldBlockBar()
        end
      end
      if SlamAndAwe.db.char.swshow then
        if arg5 == SlamAndAwe.constants["Shield Wall ID"] then
          self:ShieldWallBar()

          if SlamAndAwe.db.char.announce_shieldwall then
            self:Announce( SlamAndAwe.db.char.announce_shieldwall_where , L["Shield Wall Active!"])
          end
        end
        if arg5 == SlamAndAwe.constants["Shield Slam ID"] then
          if SBlTime > GetTime() then -- sheild block is already up, need to append the current duration with new duration
            SBlTime = SBlTime + 1.5
            SBlMax = SBlTime - GetTime()
            SBlMin = 0
            self.frames["ShieldBlock"].statusbar:SetMinMaxValues(0,SBlMax)
          end
        end
      end
      if SlamAndAwe.db.char.demoshoutshow then
        if arg5 == SlamAndAwe.constants["Demoralizing Shout ID"] then
          self:DemoShoutBar()
        end
      end
      if SlamAndAwe.db.char.laststandshow then
        if arg5 == SlamAndAwe.constants["Last Stand ID"] then
          self:LastStandBar()

          if SlamAndAwe.db.char.announce_laststand then
            self:Announce( SlamAndAwe.db.char.announce_laststand_where , L["Last Stand Active!"])
          end

        end
      end
      if SlamAndAwe.db.char.commandingshoutshow then
        if arg5 == SlamAndAwe.constants["Commanding Shout ID"] then
          self:CommandingShoutBar()
        end
      end
    end
  end
end

function SlamAndAwe:CHARACTER_POINTS_CHANGED()
  self:SetTalentEffects()
  self:CreateBaseFrame()
  self:CreateRageFrame()
  if SlamAndAwe.db.char.debug then
    self:Print("CHARACTER_POINTS_CHANGED Fired")
  end
end

function SlamAndAwe:PLAYER_REGEN_DISABLED() -- Entering Combat
  self:EnteredCombat()
end

function SlamAndAwe:PLAYER_REGEN_ENABLED() -- Leaving Combat
  self:TidyUpAfterCombat()
end

function SlamAndAwe:UPDATE_BINDINGS()
  if not InCombatLockdown() then
    self:UpdateBindings()
  end
end

function SlamAndAwe:PLAYER_TALENT_UPDATE()
  self:SetTalentEffects()
  self:SetConstants()
  if not SlamAndAwe.db.char.disabled then
    self:RedrawFrames()
    self:RageBar()
  end
  if SlamAndAwe.db.char.debug then
    self:Print("PLAYER_TALENT_UPDATE Fired")
  end
end

function SlamAndAwe:GLYPH_UPDATED()
  self:SetTalentEffects()
  if not SlamAndAwe.db.char.disabled then
    self:RedrawFrames()
    self:RageBar()
  end
  if SlamAndAwe.db.char.debug then
    self:Print("GLYPH_UPDATED Fired")
  end
end

function SlamAndAwe:ACTIVE_TALENT_GROUP_CHANGED()
  self:SetTalentEffects()
  if not SlamAndAwe.db.char.disabled then
    self:RedrawFrames()
    self:RageBar()
  end
  if SlamAndAwe.db.char.debug then
    self:Print("ACTIVE_TALENT_GROUP_CHANGED Fired")
  end
end

----------------------------
-- Combat start and stop
----------------------------

function SlamAndAwe:EnteredCombat()
  if UnitInVehicle("player") then -- don't enable priorities & bars if we enter combat in a vehicle
    return
  end
  if SlamAndAwe.db.char.disablebars then
    self.BaseFrame:Show()
  end
  if SlamAndAwe.db.char.tfbshow and not SlamAndAwe.db.char.disabled then
    if SlamAndAwe.db.char.currentspec == "Fury" then
      self:SetTasteForBloodAlpha(SlamAndAwe.db.char.colors.tfbalpha) -- set maelstrom frame to in combat alpha
    end
  end
  if SlamAndAwe.db.char.uptime.show and not SlamAndAwe.db.char.disabled then
    if not self.uptime.incombat then
      self.uptime.incombat = true
      -- reset last fight data on entering combat
      self:InitialiseUptimeBuffs(self.uptime.lastfight)
      self.uptime.currentTime = GetTime()
      self:UpdateUptime()
      self:UpdateUptimeFrames(true)
      self.uptime.TimerEvent = self:ScheduleRepeatingTimer("UpdateUptime", 0.1, nil);
    end
  end
  if SlamAndAwe.db.char.priority.show and not SlamAndAwe.db.char.disabled then
    SlamAndAwe.db.char.priority.next = "none"
    self:SetPriorityIcon(SlamAndAwe.db.char.priority.next)
    self.updatePriority = true
    self.PriorityFrame:Show()
  end
  if SlamAndAwe.db.char.ipshow and not SlamAndAwe.db.char.disabled then
    if SlamAndAwe.db.char.currentspec == "Protection" then
      SlamAndAwe:IgnorePainBar()
    end
  end
end

function SlamAndAwe:TidyUpAfterCombat()
  self.PriorityFrame:SetBackdropBorderColor(1,1,1,1) --Remove red from priority frame if was enraged while going OOC

  self.frames["TasteForBlood"]:Hide()
  self.frames["TasteForBlood"].icon:Hide()
  self.frames["FocusedRage"]:Hide()
  self.frames["FocusedRage"].icon:Hide()
  self.frames["Avatar"]:Hide()
  self.frames["Avatar"].icon:Hide()
  self.frames["DragonRoar"]:Hide()
  self.frames["DragonRoar"].icon:Hide()
  self.frames["DemoShout"]:Hide()
  self.frames["DemoShout"].icon:Hide()
  self.frames["ColossusSmash"].icon:Hide()
  self.frames["ColossusSmash"]:Hide()
  self.frames["Bloodbath"].icon:Hide()
  self.frames["Bloodbath"]:Hide()
  self.frames["BattleCry"].icon:Hide()
  self.frames["BattleCry"]:Hide()
  self.frames["LastStand"]:Hide()
  self.frames["LastStand"].icon:Hide()
  self.frames["ShieldBlock"].icon:Hide()
  self.frames["ShieldBlock"]:Hide()
  self.frames["IgnorePain"].icon:Hide()
  self.frames["IgnorePain"]:Hide()
  self.frames["ShieldWall"].icon:Hide()
  self.frames["ShieldWall"]:Hide()
  self.frames["CommandingShout"].icon:Hide()
  self.frames["CommandingShout"]:Hide()
  if SlamAndAwe.db.char.hideRageBarOOC then
    self.frames["Rage"]:Hide()
  end

  self:SetPriorityIcon("none")
  self.updatePriority = false
  self.PriorityFrame:Hide()
  if SlamAndAwe.db.char.uptime.show and not SlamAndAwe.db.char.disabled then
    if self.uptime.incombat then
      self:UpdateUptime()
      self.uptime.incombat = false
      self:UpdateUptimeFrames(true)
      self:CancelTimer(self.uptime.TimerEvent , false)
    end
  end
  if SlamAndAwe.db.char.disablebars then
    self.BaseFrame:Hide()
  end
  if not SlamAndAwe.db.char.binding.macroset then
    -- call update Bindings to set macro keys if we were in combat when addon initialised
    self:UpdateBindings()
  end
end

----------------------------
-- Question box handler
----------------------------

function SlamAndAwe:QueryDisableAddon()
  -- if SlamAndAwe.db.char.maelstromTalents == 0 then -- check MW talents again to counter Player_Entering_World bug
  -- self:SetTalentEffects()
  -- end
  -- if UnitLevel("player") >= 60 then -- don't bother asking to disable addon if player under level 60.
  -- if SlamAndAwe.db.char.maelstromTalents == 0 and not SlamAndAwe.db.char.disabled then
  -- -- addon is enabled but we have changed to a non Enhance Spec ask if we should disable addon
  -- self:DisplayQuestionFrame(false, false)
  -- elseif SlamAndAwe.db.char.maelstromTalents > 0 and SlamAndAwe.db.char.disabled then
  -- -- addon is disabled and we have changed to an Enhance Spec ask if we should enable addon
  -- self:DisplayQuestionFrame(true, false)
  -- end
  -- end
end

StaticPopupDialogs["SAA_QUESTION_FRAME"] = {
  text = L["You have changed to a new talent spec do you want to enable SlamAndAwe?"],
  button1 = "Yes",
  button2 = "No",
  OnAccept = function()
    SlamAndAwe:EnableDisable()
  end,
  timeout = 0,
  hideOnEscape = 1,
}

function SlamAndAwe:DisplayQuestionFrame(enable, spec)
  if spec then
    if enable then
      StaticPopupDialogs["SAA_QUESTION_FRAME"].text = L["You have changed to a supported spec, do you want to enable SlamAndAwe?"]
    else
      StaticPopupDialogs["SAA_QUESTION_FRAME"].text = L["You have changed to a non supported spec, do you want to disable SlamAndAwe?"]
    end
  else
    if enable then
      StaticPopupDialogs["SAA_QUESTION_FRAME"].text = L["You are in a supported spec, do you want to enable SlamAndAwe?"]
    else
      StaticPopupDialogs["SAA_QUESTION_FRAME"].text = L["You are NOT in a supported spec, do you want to disable SlamAndAwe?"]
    end
  end
  self:DebugPrint("entered DisplayQuestionFrame, text is :"..StaticPopupDialogs["SAA_QUESTION_FRAME"].text)
  StaticPopup_Show("SAA_QUESTION_FRAME")
end

---------------------------
-- Buff Info functions
---------------------------

function SlamAndAwe:GetTasteForBloodInfo()
  local index = 1
  while UnitBuff("PLAYER", index) do
    local name, _, _, count, _, _, tfbTime = UnitBuff("PLAYER", index)
    local tfbName = GetSpellInfo(206333)
    if name == tfbName then
      return count, tfbTime
    end
    index = index + 1
  end
  return 0, 0
end

function SlamAndAwe:GetFocusedRageInfo()
  local index = 1
  while UnitBuff("PLAYER", index) do
    local name, _, _, count, _, _, frTime = UnitBuff("PLAYER", index)
    local frName = GetSpellInfo(SlamAndAwe.constants["Focused Rage ID"])
    if name == frName then
      return count, frTime
    end
    index = index + 1
  end
  return 0, 0
end

---------------------------
-- General Helper functions
---------------------------

function SlamAndAwe:Announce(where,what)
  messagetype = SlamAndAwe:MessageType(where)
  if messagetype == "RAID" and not IsInRaid() then
    return
  elseif messagetype == "PARTY" and not IsInGroup() then
    return
  else
    SendChatMessage(what , messagetype , nil, nil)
  end
end

function SlamAndAwe:TrackBanner(msg,where,length)
  last_banner_msg = msg
  last_banner_where = where
  BannerTime = GetTime() + length
  updateActiveBanner = true
end

---------------------------
-- functions
---------------------------

function SlamAndAwe:RedrawFrames()
  self:CreateBaseFrame()
  self:CreateRageFrame()
  self:CreateUptimeFrame() --replaced with resetuptime for dynamic uptime frame
  self:CreatePriorityFrame()
end

function SlamAndAwe:SetSpecialization()
  local currentSpec = GetSpecialization()
  local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None"
  if currentSpec == 2 then
    SlamAndAwe.db.char.currentspec = "Fury"
  elseif currentSpec == 3 then
    SlamAndAwe.db.char.currentspec = "Protection"
  elseif currentSpec == 1 then
    SlamAndAwe.db.char.currentspec = "Arms"
  else
    SlamAndAwe.db.char.currentspec = "None"
  end
end

function SlamAndAwe:QuerySpecChanged()

  if SlamAndAwe.db.char.currentspec == "Fury" then
    if SlamAndAwe.db.char.enableFurySpec then
      if SlamAndAwe.db.char.disabled then
        SlamAndAwe:Enable()
      end
      if SlamAndAwe.db.char.priority.groupnumber ~= 1 then
        if SlamAndAwe.db.char.priority.groupnumber < 4 then
          SlamAndAwe:SelectPrioritySet(1)
        end
      end
    else
      if not SlamAndAwe.db.char.disabled then
        SlamAndAwe:Disable()
      end
    end
  elseif SlamAndAwe.db.char.currentspec == "Protection" then
    if SlamAndAwe.db.char.enableProtSpec then
      if SlamAndAwe.db.char.disabled then
        SlamAndAwe:Enable()
      end
      if SlamAndAwe.db.char.priority.groupnumber ~= 2 then
        if SlamAndAwe.db.char.priority.groupnumber < 4 then
          SlamAndAwe:SelectPrioritySet(2)
        end
      end
    else
      if not SlamAndAwe.db.char.disabled then
        SlamAndAwe:Disable()
      end
    end
  elseif SlamAndAwe.db.char.currentspec == "Arms" then
    if SlamAndAwe.db.char.enableProtSpec then
      if SlamAndAwe.db.char.disabled then
        SlamAndAwe:Enable()
      end
      if SlamAndAwe.db.char.priority.groupnumber ~= 3 then
        if SlamAndAwe.db.char.priority.groupnumber < 4 then
          SlamAndAwe:SelectPrioritySet(3)
        end
      end
    else
      if not SlamAndAwe.db.char.disabled then
        SlamAndAwe:Disable()
      end
    end
  end
end

function SlamAndAwe:SetTalentEffects()
  SlamAndAwe:SetSpecialization() -- Set spec first
  for k,v in pairs(SlamAndAwe.barTable) do SlamAndAwe.barTable[k]=nil end
  SlamAndAwe.db.char.IPLen = 15
  SlamAndAwe.db.char.IPPercent = 1
  SlamAndAwe.db.char.SBlLen = 6
  SlamAndAwe.db.char.SBlPercent = 1
  SlamAndAwe.db.char.CSLen = 8
  SlamAndAwe.db.char.CSPercent = 1
  SlamAndAwe.db.char.BBLen = 6
  SlamAndAwe.db.char.BBPercent = 1
  SlamAndAwe.db.char.BCLen = 5
  SlamAndAwe.db.char.BCPercent = 1
  SlamAndAwe.db.char.SWPercent = 1
  SlamAndAwe.db.char.ragecap = UnitPowerMax("player" , "rage")
  SlamAndAwe.db.char.AVALen = 20
  SlamAndAwe.db.char.AVAPercent = 1
  SlamAndAwe.db.char.DRLen = 6
  SlamAndAwe.db.char.DRPercent = 1
  SlamAndAwe.db.char.TFBLen = 8
  SlamAndAwe.db.char.TFBPercent = 1
  SlamAndAwe.db.char.FRPercent = 1
  SlamAndAwe.db.char.DSPercent = 1
  SlamAndAwe.db.char.LSPercent = 1
  SlamAndAwe.db.char.CSHPercent = 1
  SlamAndAwe.db.char.RAGEPercent = 1

  --Arms Talent Checks
  local titanicMightId, _, _, titanicMight, _ = GetTalentInfo(6,3, 1, false)
  if titanicMight and titanicMightId == 22399 then
    SlamAndAwe.db.char.CSLen = 24
  else
    SlamAndAwe.db.char.CSLen = 8
  end

  --Fury Talent Checks
  local bloodbathId, _, _, bloodbath, _ = GetTalentInfo(6,1, 1, false)
  if outburst and outburstId == 22395 then
    SlamAndAwe.db.char.talBloodbath = true
  else
    SlamAndAwe.db.char.talBloodbath = false
  end

  local outburstId, _, _, outburst, _ = GetTalentInfo(3,2, 1, false)
  if outburst and outburstId == 22381 then --not sure why its 22381
    SlamAndAwe.db.char.talOutburst = true
  else
    SlamAndAwe.db.char.talOutburst = false
  end

  local dragonroarId, _, _, dragonroar, _ = GetTalentInfo(7,3, 1, false)
  if dragonroar and dragonroarId == 16037 then --not sure why its 22381
    SlamAndAwe.db.char.talDragonRoar = true
  else
    SlamAndAwe.db.char.talDragonRoar = false
  end

  local avatarId, _, _, avatar, _ = GetTalentInfo(3,3, 1, false)
  if avatar and avatarId == 22360 then
    SlamAndAwe.db.char.talAvatar = true
  else
    SlamAndAwe.db.char.talAvatar = false
  end

  local dauntlessId, _, _, dauntless, _ = GetTalentInfo(1,1, 1, false)
  if dauntless and dauntlessId == 22624 then
    SlamAndAwe.db.char.talDauntless = true
  else
    SlamAndAwe.db.char.talDauntless = false
  end

  local cracklingthunderId, _, _, cracklingthunder, _ = GetTalentInfo(4,3, 1, false)
  if cracklingthunder and cracklingthunderId == 22488 then
    SlamAndAwe.db.char.talCracklingThunder = true
  else
    SlamAndAwe.db.char.talCracklingThunder = false
  end

  local vengeanceId, _, _, vengeance, _ = GetTalentInfo(6,3, 1, false)
  if vengeance and vengeanceId == 22401 then
    SlamAndAwe.db.char.talVengeance = true
  else
    SlamAndAwe.db.char.talVengeance = false
  end

  local overpowerId, _, _, overpower, _ = GetTalentInfo(1,2, 1, false)
  if overpower and overpowerId == 19138 then
    SlamAndAwe.db.char.talOverpower = true
  else
    SlamAndAwe.db.char.talOverpower = false
  end

  local fobId, _, _, fob, _ = GetTalentInfo(3,1, 1, false)
  if fob and fobId == 22380 then
    SlamAndAwe.db.char.talFervorOfBattle = true
  else
    SlamAndAwe.db.char.talFervorOfBattle = false
  end

  local deadlycalmId, _, _, deadlycalm, _ = GetTalentInfo(6,1, 1, false)
  if deadlycalm and deadlycalmId == 22394 then
    SlamAndAwe.db.char.talDeadlyCalm = true
  else
    SlamAndAwe.db.char.talDeadlyCalm = false
  end

  local focusedrageId, _, _, focusedrage, _ = GetTalentInfo(5,3, 1, false)
  if focusedrage and focusedrageId == 22800 then
    SlamAndAwe.db.char.talFocusedRage = true
  else
    SlamAndAwe.db.char.talFocusedRage = false
  end

  local massacreId, _, _, massacre, _ = GetTalentInfo(5,1, 1, false)
  if massacre and massacreId == 22384 then
    SlamAndAwe.db.char.talMassacre = true
  else
    SlamAndAwe.db.char.talMassacre = false
  end

  local frenzyId, _, _, frenzy, _ = GetTalentInfo(6,2, 1, false)
  if frenzy and frenzyId == 22544 then
    SlamAndAwe.db.char.talFrenzy = true
  else
    SlamAndAwe.db.char.talFrenzy = false
  end

  local innerrageId, _, _, innerrage, _ = GetTalentInfo(6,3, 1, false)
  if innerrage and innerrageId == 22400 then
    SlamAndAwe.db.char.talInnerRage = true
  else
    SlamAndAwe.db.char.talInnerRage = false
  end

  local inforthekillId, _, _, inforthekill, _ = GetTalentInfo(5,1, 1, false)
  if inforthekill and inforthekillId == 215550 then
    SlamAndAwe.db.char.talInForTheKill = true
  else
    SlamAndAwe.db.char.talInForTheKill = false
  end

  function SlamAndAwe:TalentInfo()
    print ("TitanicMight: ", titanicmightId, titanicmight)
    print ("Frenzy: ", frenzyId, frenzy)
    print ("IR: ", innerrageId, innerrage)
    print ("Massacre: ", massacreId, massacre)
    print ("Avatar: ", avatarId, avatar)
    print ("DragonRoar: ", dragonroarId, dragonroar)
    print ("Outburst: ", outburstId, outburst)
    print ("Bloodbath: ", bloodbathId, bloodbath)
  end

  --Protection Talent Checks
  local neverSurrenderId, _, _, neverSurrender, _ = GetTalentInfo(5, 2, 1, false)
  local indomitableId, _, _, indomitable, _ = GetTalentInfo(5, 3, 1, false)
  if neverSurrender and neverSurrenderId == 22393 then
    SlamAndAwe.db.char.ipMultiplier = 2
    --print("Multiplier set to ", SlamAndAwe.db.char.ipMultiplier)
  elseif indomitable and indomitableId == 22362 then
    SlamAndAwe.db.char.ipMultiplier = 1.25
    --print("Multiplier set to ", SlamAndAwe.db.char.ipMultiplier)
  else
    SlamAndAwe.db.char.ipMultiplier = 1
  end

  local heavyrepercussionsId, _, _, heavyrepercussions, _ = GetTalentInfo(7,2, 1, false)
  if heavyrepercussions and heavyrepercussionsId == 22406 then
    SlamAndAwe.db.char.talHeavyRepercussions = true
  else
    SlamAndAwe.db.char.talHeavyRepercussions = false
  end

  --Misc
  local hasreckglyph
  local hasrageglyph

  if SlamAndAwe.db.char.gcdfullwidth then
    GCDPercent = 1
  else
    GCDPercent = 1.5 / 10
  end

  SlamAndAwe:QuerySpecChanged() -- Update priority group if needed
end

function SlamAndAwe:DisplayVersion()
  self:Print(self.version)
end

function SlamAndAwe:CreateBaseFrame()
  local colors

  self:SetSpecialization()
  self:SetTalentEffects()
  self.BaseFrame:SetScale(SlamAndAwe.db.char.scale)

  self.BaseFrame:SetWidth(SlamAndAwe.db.char.fWidth + SlamAndAwe.db.char.fHeight / 7)
  self.BaseFrame:SetHeight(SlamAndAwe.db.char.fHeight)
  self.BaseFrame:SetBackdrop(self.frameBackdrop)
  self.BaseFrame:SetBackdropColor(1, 1, 1, 0)
  self.BaseFrame:SetMovable(true)
  self.BaseFrame:EnableMouse(false)
  self.BaseFrame:RegisterForDrag("LeftButton")
  self.BaseFrame:SetPoint(SlamAndAwe.db.char.point, SlamAndAwe.db.char.relativeTo, SlamAndAwe.db.char.relativePoint, SlamAndAwe.db.char.xOffset, SlamAndAwe.db.char.yOffset)
  self.BaseFrame:SetScript("OnDragStart",
    function()
      self.BaseFrame:StartMoving();
    end );
  self.BaseFrame:SetScript("OnDragStop",
    function()
      self.BaseFrame:StopMovingOrSizing();
      self.BaseFrame:SetScript("OnUpdate", nil);
      self:FinishedMoving(SlamAndAwe.db.char, self.BaseFrame);
    end );
  self.BaseFrame:Show()

  local barHeight = SlamAndAwe.db.char.fHeight / 7
  local baseOffset = (-1 * barHeight) + 3
  local barCount = 0

  SlamAndAwe:SetBarFrame(self.frames["GCD"],
    SlamAndAwe.db.char.fWidth * GCDPercent, barHeight,
    barCount * baseOffset, 1,
    0, 1.5,
    6, 1,
    .6, .6, .6, .6,
    false)
  self.GCDWidth = self.frames["GCD"].statusbar:GetWidth() -- to account for spark width
  if SlamAndAwe.db.char.gcdshow then
    barCount = barCount + 1 -- we will use gcd frame
  end

  --DPS Bars
  if (SlamAndAwe.db.char.currentspec == "Fury") then

    --Taste For Blood Bar
    colors = SlamAndAwe.db.char.colors.tfb
    SlamAndAwe:SetBarFrame(self.frames["TasteForBlood"],
      SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.TFBPercent, barHeight,
      barCount * baseOffset, 1,
      0, SlamAndAwe.db.char.TFBLen,
      10, 1,
      colors.r, colors.g, colors.b, SlamAndAwe.db.char.colors.tfbalpha,
      true)
    if SlamAndAwe.db.char.tfbshow then
      barCount = barCount + 1 -- we will use tfb frame
    end
    self:SetBarIcon(self.frames["TasteForBlood"].icon, 206333)

    --Dragon Roar Bar
    colors = SlamAndAwe.db.char.colors.dragonroar
    SlamAndAwe:SetBarFrame(self.frames["DragonRoar"],
      SlamAndAwe.db.char.fWidth, barHeight,
      barCount * baseOffset, 1,
      0, SlamAndAwe.db.char.DRLen,
      10, 1,
      colors.r, colors.g, colors.b, colors.a,
      true)
    if SlamAndAwe.db.char.drshow then
      if SlamAndAwe.db.char.talDragonRoar then
        barCount = barCount + 1 -- we will use dragonroar frame
      end
    end
    self:SetBarIcon(self.frames["DragonRoar"].icon, 118000)

    --Arms Bars
  elseif SlamAndAwe.db.char.currentspec == "Arms" then

    --Colossus Smash Bar
    colors = SlamAndAwe.db.char.colors.colossussmash
    SlamAndAwe:SetBarFrame(self.frames["ColossusSmash"],
      SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.CSPercent, barHeight,
      barCount * baseOffset, 1,
      0, SlamAndAwe.db.char.CSLen,
      10, 1,
      colors.r, colors.g, colors.b, colors.a,
      true)
    if SlamAndAwe.db.char.csshow then
      barCount = barCount + 1 -- we will use ColossusSmash frame
    end
    self:SetBarIcon(self.frames["ColossusSmash"].icon, 167105)

    --Protection Bars ----------------------------------------
  elseif SlamAndAwe.db.char.currentspec == "Protection" then
    ----------------------------------------------------------

    --Ignore Pain Bar
    colors = SlamAndAwe.db.char.colors.ignorepain
    SlamAndAwe:SetBarFrame(self.frames["IgnorePain"],
      SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.IPPercent, barHeight,
      barCount * baseOffset, 1,
      0, SlamAndAwe.db.char.IPLen,
      10, 1,
      colors.r, colors.g, colors.b, colors.a,
      true)
    if SlamAndAwe.db.char.ipshow then
      barCount = barCount + 1 -- we will use Ignore Pain frame
    end
    self:SetBarIcon(self.frames["IgnorePain"].icon, 190456)

    --Shield Block Bar
    colors = SlamAndAwe.db.char.colors.shieldblock
    SlamAndAwe:SetBarFrame(self.frames["ShieldBlock"],
      SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.SBlPercent, barHeight,
      barCount * baseOffset, 1,
      0, SBlMax,
      10, 1,
      colors.r, colors.g, colors.b, colors.a,
      true)
    if SlamAndAwe.db.char.sblshow then
      SBlPos = barCount
      barCount = barCount + 1 -- we will use ShieldBlock frame
    end
    self:SetBarIcon(self.frames["ShieldBlock"].icon, 2565)

    --Demo Shout Bar
    colors = SlamAndAwe.db.char.colors.demoshout
    SlamAndAwe:SetBarFrame(self.frames["DemoShout"],
      SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.DSPercent, barHeight,
      barCount * baseOffset, 1,
      0, SlamAndAwe.db.char.DSLen,
      10, 1,
      colors.r, colors.g, colors.b, colors.a,
      true)
    if SlamAndAwe.db.char.demoshoutshow then
      barCount = barCount + 1 -- we will use DemoShout frame
    end
    self:SetBarIcon(self.frames["DemoShout"].icon,1160)

    --Last Stand Bar
    colors = SlamAndAwe.db.char.colors.laststand
    SlamAndAwe:SetBarFrame(self.frames["LastStand"],
      SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.LSPercent, barHeight,
      barCount * baseOffset, 1,
      0, SlamAndAwe.db.char.LSLen,
      10, 1,
      colors.r, colors.g, colors.b, colors.a,
      true)
    if SlamAndAwe.db.char.laststandshow then
      barCount = barCount + 1 -- we will use LastStand frame
    end
    self:SetBarIcon(self.frames["LastStand"].icon,12975)

    --Shield Wall Bar
    colors = SlamAndAwe.db.char.colors.shieldwall
    SlamAndAwe:SetBarFrame(self.frames["ShieldWall"],
      SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.SBlPercent, barHeight,
      barCount * baseOffset, 1,
      0, SlamAndAwe.db.char.SWLen,
      10, 1,
      colors.r, colors.g, colors.b, colors.a,
      true)
    if SlamAndAwe.db.char.swshow then
      barCount = barCount + 1 -- we will use ShieldWall frame
    end
    self:SetBarIcon(self.frames["ShieldWall"].icon, 871)

    --No specialization selected
  else
    self:Print("No specialization selected!")
  end

  -- All spec bars

  --Battle Cry Bar
  colors = SlamAndAwe.db.char.colors.battlecry
  SlamAndAwe:SetBarFrame(self.frames["BattleCry"],
    SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.BCPercent, barHeight,
    barCount * baseOffset, 1,
    0, SlamAndAwe.db.char.BCLen,
    10, 1,
    colors.r, colors.g, colors.b, colors.a,
    true)
  if SlamAndAwe.db.char.bcshow then
    barCount = barCount + 1 -- we will use BattleCry frame
  end
  self:SetBarIcon(self.frames["BattleCry"].icon, 1719)

  --Blodbath Bar
  colors = SlamAndAwe.db.char.colors.bloodbath
  SlamAndAwe:SetBarFrame(self.frames["Bloodbath"],
    SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.BBPercent, barHeight,
    barCount * baseOffset, 1,
    0, SlamAndAwe.db.char.BBLen,
    10, 1,
    colors.r, colors.g, colors.b, colors.a,
    true)
  if SlamAndAwe.db.char.bbshow then
    if SlamAndAwe.db.char.talBloodbath then
      barCount = barCount + 1 -- we will use Bloodbath frame
    end
  end
  self:SetBarIcon(self.frames["Bloodbath"].icon, 12292)

  --Avatar Bar
  colors = SlamAndAwe.db.char.colors.avatar
  SlamAndAwe:SetBarFrame(self.frames["Avatar"],
    SlamAndAwe.db.char.fWidth, barHeight,
    barCount * baseOffset, 1,
    0, SlamAndAwe.db.char.AVALen,
    10, 1,
    colors.r, colors.g, colors.b, colors.a,
    true)
  if SlamAndAwe.db.char.avashow then
    if SlamAndAwe.db.char.talAvatar then
      barCount = barCount + 1 -- we will use avatar frame
    end
  end
  self:SetBarIcon(self.frames["Avatar"].icon, 107574)

  --Commanding Shout Bar
  colors = SlamAndAwe.db.char.colors.commandingshout
  SlamAndAwe:SetBarFrame(self.frames["CommandingShout"],
    SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.CSHPercent, barHeight,
    barCount * baseOffset, 1,
    0, SlamAndAwe.db.char.CSHLen,
    10, 1,
    colors.r, colors.g, colors.b, colors.a,
    true)
  if SlamAndAwe.db.char.commandingshoutshow then
    if not SlamAndAwe.db.char.currentspec == "Protection" then
      barCount = barCount + 1 -- we will use CommandingShout frame
    end
  end
  self:SetBarIcon(self.frames["CommandingShout"].icon, 97462)

  --Focused Rage Bar
  colors = SlamAndAwe.db.char.colors.fr
  SlamAndAwe:SetBarFrame(self.frames["FocusedRage"],
    SlamAndAwe.db.char.fWidth * SlamAndAwe.db.char.FRPercent, barHeight,
    barCount * baseOffset, 1,
    0, SlamAndAwe.db.char.FRLen,
    10, 1,
    colors.r, colors.g, colors.b, SlamAndAwe.db.char.colors.fralpha,
    true)
  if SlamAndAwe.db.char.frshow then
    barCount = barCount + 1 -- we will use fr frame
  end
  self:SetBarIcon(self.frames["FocusedRage"].icon, 204488)

  --End CreateBaseFrame()
end

function SlamAndAwe:SetBarFrame(frameName, barWidth, barHeight, frameOffset, frameLevel, minValue, maxValue, frameValue, frameSpark, frameR, frameG, frameB, frameAlpha, icon)
  frameName:SetFrameStrata(SlamAndAwe.db.char.framestratalevel)
  frameName:SetWidth(barWidth)
  frameName:SetHeight(barHeight)
  frameName:ClearAllPoints()
  frameName:SetPoint("TOPLEFT", self.BaseFrame, "TOPLEFT", barHeight, frameOffset)
  frameName:SetBackdrop(self.barBackdrop);
  frameName:SetBackdropColor(0, 0, 0, .2);
  frameName:SetBackdropBorderColor( 1, 1, 1, 1);
  frameName:EnableMouse(false)
  if not frameName.statusbar then
    frameName.statusbar = CreateFrame("StatusBar", nil, frameName)
  end
  frameName.statusbar:SetFrameLevel(frameLevel)
  frameName.statusbar:ClearAllPoints()
  frameName.statusbar:SetHeight(barHeight - 6)
  frameName.statusbar:SetWidth(barWidth - 6)
  frameName.statusbar:SetPoint("TOPLEFT", frameName, "TOPLEFT", 3, -3)
  frameName.statusbar:SetStatusBarTexture(media:Fetch("statusbar", SlamAndAwe.db.char.texture))
  frameName.statusbar:GetStatusBarTexture():SetHorizTile(false) -- fix for textures stretching rather than revealing (was originally set true but caused bar bgs to tile in 5.0)
  frameName.statusbar:SetStatusBarColor(frameR, frameG, frameB, frameAlpha)
  frameName.statusbar:SetMinMaxValues(minValue,maxValue)
  frameName.statusbar:SetValue(frameValue)

  if not frameName.spark then
    frameName.spark = frameName.statusbar:CreateTexture(nil, "OVERLAY")
  end
  frameName.spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
  frameName.spark:SetWidth(16)
  frameName.spark:SetHeight(barHeight + 16)
  frameName.spark:SetBlendMode("ADD")
  frameName.spark:SetPoint("CENTER",frameName.statusbar,"BOTTOMLEFT",(barWidth - 6)* frameSpark, -1)
  frameName.spark:Show()

  if not frameName.text then
    frameName.text = frameName:CreateFontString(nil,"OVERLAY")
  end
  local barfont = media:Fetch("font", SlamAndAwe.db.char.barfont)
  frameName.text:SetFont(barfont, SlamAndAwe.db.char.barfontsize, SlamAndAwe.db.char.barfonteffect)
  frameName.text:ClearAllPoints()
  frameName.text:SetTextColor(1, 1, 1, 1)
  frameName.text:SetPoint("CENTER", frameName, "LEFT");
  frameName.text:SetText("")

  if not frameName.text2 then
    frameName.text2 = frameName:CreateFontString(nil,"OVERLAY")
  end
  local barfont = media:Fetch("font", SlamAndAwe.db.char.barfont)
  frameName.text2:SetFont(barfont, SlamAndAwe.db.char.barfontsize, SlamAndAwe.db.char.barfonteffect)
  frameName.text2:ClearAllPoints()
  --frameName.text2:SetTextColor(1, 1, 1, 1)
  frameName.text2:SetPoint("CENTER", frameName, "RIGHT", 40, -1);
  frameName.text2:SetText("")

  frameName:SetScript("OnUpdate",
    function()
      SlamAndAwe:OnBarUpdate();
    end );
  if icon then
    frameName.icon:SetWidth(barHeight - 3) -- same as height to get square box
    frameName.icon:SetHeight(barHeight - 3)
    frameName.icon:SetPoint("TOPRIGHT", frameName, "TOPLEFT", 0 , -2)
    frameName.icon:Hide()
  end
  frameName:Hide()
end

function SlamAndAwe:SetBarIcon(iconFrame, spellID)
  local icon = GetSpellTextureFileName(spellID)
  iconFrame:SetBackdrop({
      bgFile = icon,
      --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 0, right = 0, top = 0, bottom = 0 } })
end

function SlamAndAwe:ResetBars()
  self.BaseFrame:ClearAllPoints()
  SlamAndAwe.db.char.point = self.defaults.char.point
  SlamAndAwe.db.char.relativeTo = self.defaults.char.relativeTo
  SlamAndAwe.db.char.relativePoint = self.defaults.char.relativePoint
  SlamAndAwe.db.char.xOffset = self.defaults.char.xOffset
  SlamAndAwe.db.char.yOffset = self.defaults.char.yOffset
  SlamAndAwe.db.char.fWidth = self.defaults.char.fWidth
  SlamAndAwe.db.char.fHeight = self.defaults.char.fHeight
  SlamAndAwe.db.char.scale = self.defaults.char.scale
  SlamAndAwe.db.char.barfont = self.defaults.char.barfont
  SlamAndAwe.db.char.barfontsize = self.defaults.char.barfontsize
  SlamAndAwe.db.char.bartexture = self.defaults.char.bartexture
  SlamAndAwe.db.char.texture = self.defaults.char.texture
  self.BaseFrame:SetPoint(SlamAndAwe.db.char.point, SlamAndAwe.db.char.relativeTo, SlamAndAwe.db.char.relativePoint, SlamAndAwe.db.char.xOffset, SlamAndAwe.db.char.yOffset)
  SlamAndAwe:SetTalentEffects()
  self:RedrawFrames()
  SlamAndAwe.db.char.movingframes = true -- so that call to ShowHideBars resets to false
  self:ShowHideBars()
  self:Print(L["config_reset"])
end

function SlamAndAwe:CreateRageFrame()
  self.RageFrame:SetScale(SlamAndAwe.db.char.ragebar.scale)

  self.RageFrame:SetWidth(SlamAndAwe.db.char.ragebar.fWidth + SlamAndAwe.db.char.ragebar.fHeight)
  self.RageFrame:SetHeight(SlamAndAwe.db.char.ragebar.fHeight)
  self.RageFrame:SetBackdrop(self.rageframeBackdrop)
  self.RageFrame:SetBackdropColor(1, 1, 1, 0)
  self.RageFrame:SetMovable(true)
  self.RageFrame:EnableMouse(false)
  self.RageFrame:RegisterForDrag("LeftButton")
  self.RageFrame:SetPoint(SlamAndAwe.db.char.ragebar.point, SlamAndAwe.db.char.ragebar.relativeTo, SlamAndAwe.db.char.ragebar.relativePoint, SlamAndAwe.db.char.ragebar.xOffset, SlamAndAwe.db.char.ragebar.yOffset)
  self.RageFrame:SetScript("OnDragStart",
    function()
      self.RageFrame:StartMoving();
    end );
  self.RageFrame:SetScript("OnDragStop",
    function()
      self.RageFrame:StopMovingOrSizing();
      self.RageFrame:SetScript("OnUpdate", nil);
      self:FinishedMoving(SlamAndAwe.db.char.ragebar, self.RageFrame);
    end );
  self.RageFrame:Show()

  local barHeight = SlamAndAwe.db.char.ragebar.fHeight
  local baseOffset = 0
  local barCount = 0

  colors = SlamAndAwe.db.char.colors.rage
  SlamAndAwe:SetRageFrame(self.frames["Rage"],
    SlamAndAwe.db.char.ragebar.fWidth * SlamAndAwe.db.char.RAGEPercent, barHeight,
    barCount * baseOffset, 1,
    0, SlamAndAwe.db.char.ragecap,
    6, 1,
    colors.r, colors.g, colors.b, colors.a,
    false)
  if SlamAndAwe.db.char.rageshow then
    barCount = barCount + 1 -- we will use Rage frame
  end

end

function SlamAndAwe:SetRageFrame(frameName, barWidth, barHeight, frameOffset, frameLevel, minValue, maxValue, frameValue, frameSpark, frameR, frameG, frameB, frameAlpha, icon)
  frameName:SetFrameStrata(SlamAndAwe.db.char.framestratalevel)
  frameName:SetWidth(barWidth)
  frameName:SetHeight(barHeight)
  frameName:ClearAllPoints()
  frameName:SetPoint("TOPLEFT", self.RageFrame, "TOPLEFT", barHeight, 0)
  frameName:SetBackdrop(self.ragebarBackdrop);
  frameName:SetBackdropColor(0, 0, 0, .2);
  frameName:SetBackdropBorderColor( 1, 1, 1, 1);
  frameName:EnableMouse(false)
  if not frameName.statusbar then
    frameName.statusbar = CreateFrame("StatusBar", nil, frameName)
  end
  frameName.statusbar:SetFrameLevel(frameLevel)
  frameName.statusbar:ClearAllPoints()
  frameName.statusbar:SetHeight(barHeight - 6)
  frameName.statusbar:SetWidth(barWidth - 6)
  frameName.statusbar:SetPoint("TOPLEFT", frameName, "TOPLEFT", 3, -3)
  frameName.statusbar:SetStatusBarTexture(media:Fetch("statusbar", SlamAndAwe.db.char.ragebar.texture))
  frameName.statusbar:GetStatusBarTexture():SetHorizTile(false) -- fix for textures stretching rather than revealing (was originally set true but caused bar bgs to tile in 5.0)
  frameName.statusbar:SetStatusBarColor(frameR, frameG, frameB, frameAlpha)
  frameName.statusbar:SetMinMaxValues(minValue,maxValue)
  frameName.statusbar:SetValue(frameValue)

  if not frameName.spark then
    frameName.spark = frameName.statusbar:CreateTexture(nil, "OVERLAY")
  end
  frameName.spark:SetTexture("Interface\\CastingBar\\UI-CastingBar-Spark")
  frameName.spark:SetWidth(16)
  frameName.spark:SetHeight(barHeight + 16)
  frameName.spark:SetBlendMode("ADD")
  frameName.spark:SetPoint("CENTER",frameName.statusbar,"BOTTOMLEFT",(barWidth - 6)* frameSpark, -1)
  frameName.spark:Show()

  if not frameName.text then
    frameName.text = frameName:CreateFontString(nil,"OVERLAY")
  end
  local barfont = media:Fetch("font", SlamAndAwe.db.char.ragebar.barfont)
  frameName.text:SetFont(barfont, SlamAndAwe.db.char.ragebar.barfontsize, SlamAndAwe.db.char.ragebar.barfonteffect)
  frameName.text:ClearAllPoints()
  frameName.text:SetTextColor(1, 1, 1, 1)
  frameName.text:SetPoint("CENTER", frameName, "LEFT");
  frameName.text:SetText("")

  if not frameName.text2 then
    frameName.text2 = frameName:CreateFontString(nil,"OVERLAY")
  end
  local barfont = media:Fetch("font", SlamAndAwe.db.char.ragebar.barfont)
  frameName.text2:SetFont(barfont, SlamAndAwe.db.char.ragebar.barfontsize, SlamAndAwe.db.char.ragebar.barfonteffect)
  frameName.text2:ClearAllPoints()
  --frameName.text2:SetTextColor(1, 1, 1, 1)
  frameName.text2:SetPoint("CENTER", frameName, "RIGHT", 40, -1);
  frameName.text2:SetText("")

  frameName:SetScript("OnUpdate",
    function()
      SlamAndAwe:OnRageBarUpdate();
    end );
  frameName:Hide()
end

function SlamAndAwe:ResetRageBar()
  self.RageFrame:ClearAllPoints()
  SlamAndAwe.db.char.ragebar.point = self.defaults.char.ragebar.point
  SlamAndAwe.db.char.ragebar.relativeTo = self.defaults.char.ragebar.relativeTo
  SlamAndAwe.db.char.ragebar.relativePoint = self.defaults.char.ragebar.relativePoint
  SlamAndAwe.db.char.ragebar.xOffset = self.defaults.char.ragebar.xOffset
  SlamAndAwe.db.char.ragebar.yOffset = self.defaults.char.ragebar.yOffset
  SlamAndAwe.db.char.ragebar.fWidth = self.defaults.char.ragebar.fWidth
  SlamAndAwe.db.char.ragebar.fHeight = self.defaults.char.ragebar.fHeight
  SlamAndAwe.db.char.ragebar.scale = self.defaults.char.ragebar.scale
  SlamAndAwe.db.char.ragebar.barfont = self.defaults.char.ragebar.barfont
  SlamAndAwe.db.char.ragebar.barfontsize = self.defaults.char.ragebar.barfontsize
  SlamAndAwe.db.char.ragebar.texture = self.defaults.char.ragebar.texture

  self.RageFrame:SetPoint(SlamAndAwe.db.char.ragebar.point, SlamAndAwe.db.char.ragebar.relativeTo, SlamAndAwe.db.char.ragebar.relativePoint, SlamAndAwe.db.char.ragebar.xOffset, SlamAndAwe.db.char.ragebar.yOffset)
  SlamAndAwe:SetTalentEffects()
  self:RedrawFrames()
  SlamAndAwe.db.char.movingframes = true -- so that call to ShowHideBars resets to false
  self:ShowHideBars()
  self:Print(L["config_reset"])
end

function SlamAndAwe:DebugTalents()
  local currentSpec = GetSpecialization()
  local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None"
  print("Your current spec:", currentSpecName)
  print("Your cooldown spell: ", SlamAndAwe.constants["SpellCoolDown"])
end

function SlamAndAwe:DebugStats()
  local _, STR, _, _ = UnitStat("player", 1)
  -- local _, STA, _, _ = UnitStat("player", 3)
  local APbase, APposBuff, APnegBuff = UnitAttackPower("player")
  local APfinal = APbase + APposBuff + APnegBuff
  local ipMaxRage = 60
  print ("STR "..tostring(STR))
  print ("APbase "..tostring(APbase))
  print ("APposbuff "..tostring(APposBuff))
  print ("APnegBuff "..tostring(APnegBuff))
  print ("APnegBuff "..tostring(APnegBuff))
  print ("Versatility ", versatility)
  print ("Vdmg ", versatilityDamageBonus)
end

function SlamAndAwe:DebugFrameValues()
  self:Print("CSLen : "..SlamAndAwe.db.char.CSLen)
  self:Print("CSPercent : "..SlamAndAwe.db.char.CSPercent)
  self:Print("BCLen : "..SlamAndAwe.db.char.BCLen)
  self:Print("BCPercent : "..SlamAndAwe.db.char.BCPercent)
end

function SlamAndAwe:GCDBar()
  local startTime, duration, enabled = GetSpellCooldown(SlamAndAwe.constants["SpellCoolDown"]) -- Battle Shout because fury has it and demo is gone
  duration = duration or 0 -- force nil to 0 if for some bizzare reason no LS available.
  if duration > 0 then
    self.frames["GCD"]:Show()
    updateActiveGCD = true
    GCDTime = startTime + duration
    self.GCDMax = duration
  end
end

function SlamAndAwe:RageBar()
  if not SlamAndAwe.db.char.disabled then
    if SlamAndAwe.db.char.rageshow then
      RageMin, RageMax = self.frames["Rage"].statusbar:GetMinMaxValues()
      if SlamAndAwe.db.char.hideRageBarOOC then
        if UnitAffectingCombat("player") then
          self.frames["Rage"]:Show()
          updateActiveRage = true
        else
          self.frames["Rage"]:Hide()
        end
      else
        -- if UnitPower("player", "rage") > 0 then -- not sure why we were hiding rage bar with 0 rage, when you use ignore pain the bar would hide??
        self.frames["Rage"]:Show()
        updateActiveRage = true
        -- else
        -- self.frames["Rage"]:Hide()
        -- end
      end
    end
  end
end

function SlamAndAwe:TasteForBloodBar()

  if SlamAndAwe.db.char.tfbshow and not SlamAndAwe.db.char.disabled then
    local colors = SlamAndAwe.db.char.colors.tfb
    self.frames["TasteForBlood"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, SlamAndAwe.db.char.colors.tfbalpha)
    self.frames["TasteForBlood"]:SetBackdropBorderColor( 1, 1, 1, SlamAndAwe.db.char.colors.tfbalpha); --was msalpha
    self.frames["TasteForBlood"].spark:Show()
    self.frames["TasteForBlood"]:Show()
    self.frames["TasteForBlood"].text:SetPoint("CENTER",self.frames["TasteForBlood"].statusbar,"LEFT",34,-1)
    if SlamAndAwe.db.char.showicons then
      self.frames["TasteForBlood"].icon:Show()
    else
      self.frames["TasteForBlood"].icon:Hide()
    end
  end
  --updateActiveMaelstrom = true --triggered by Unia_Aura not here
  tfbMin, tfbMax = self.frames["TasteForBlood"].statusbar:GetMinMaxValues() -- MaelstromMin MaelstromMax
end

function SlamAndAwe:FocusedRageBar()

  if SlamAndAwe.db.char.frshow and not SlamAndAwe.db.char.disabled then
    local colors = SlamAndAwe.db.char.colors.fr
    self.frames["FocusedRage"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, SlamAndAwe.db.char.colors.fralpha)
    self.frames["FocusedRage"]:SetBackdropBorderColor( 1, 1, 1, SlamAndAwe.db.char.colors.fralpha)
    self.frames["FocusedRage"].spark:Show()
    self.frames["FocusedRage"]:Show()
    self.frames["FocusedRage"].text:SetPoint("CENTER",self.frames["FocusedRage"].statusbar,"LEFT",34,-1)
    if SlamAndAwe.db.char.showicons then
      self.frames["FocusedRage"].icon:Show()
    else
      self.frames["FocusedRage"].icon:Hide()
    end
  end
  --updateActiveFocusedRage = true --triggered by Unia_Aura not here
  frMin, frMax = self.frames["FocusedRage"].statusbar:GetMinMaxValues()
end

function SlamAndAwe:ColossusSmashBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["ColossusSmash"])
  local colors = SlamAndAwe.db.char.colors.colossussmash
  self.frames["ColossusSmash"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["ColossusSmash"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["ColossusSmash"]:Show()
  updateActiveColossusSmash = true
  CSTime = GetTime() + SlamAndAwe.db.char.CSLen
  CSMin, CSMax = self.frames["ColossusSmash"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["ColossusSmash"].icon:Show()
  else
    self.frames["ColossusSmash"].icon:Hide()
  end
end

function SlamAndAwe:BloodbathBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["Bloodbath"])
  local colors = SlamAndAwe.db.char.colors.bloodbath
  self.frames["Bloodbath"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["Bloodbath"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["Bloodbath"]:Show()
  updateActiveBloodbath = true
  BBTime = GetTime() + SlamAndAwe.db.char.BBLen
  BBMin, BBMax = self.frames["Bloodbath"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["Bloodbath"].icon:Show()
  else
    self.frames["Bloodbath"].icon:Hide()
  end
end

function SlamAndAwe:BattleCryBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["BattleCry"])
  local colors = SlamAndAwe.db.char.colors.battlecry
  self.frames["BattleCry"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["BattleCry"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["BattleCry"]:Show()
  updateActiveBattleCry = true
  BCTime = GetTime() + SlamAndAwe.db.char.BCLen
  BCMin, BCMax = self.frames["BattleCry"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["BattleCry"].icon:Show()
  else
    self.frames["BattleCry"].icon:Hide()
  end
end

function SlamAndAwe:AvatarBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["Avatar"])
  local colors = SlamAndAwe.db.char.colors.avatar
  self.frames["Avatar"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["Avatar"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["Avatar"]:Show()
  updateActiveAvatar = true
  AVATime = GetTime() + SlamAndAwe.db.char.AVALen
  AVAMin, AVAMax = self.frames["Avatar"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["Avatar"].icon:Show()
  else
    self.frames["Avatar"].icon:Hide()
  end
end

function SlamAndAwe:DragonRoarBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["DragonRoar"])
  local colors = SlamAndAwe.db.char.colors.dragonroar
  self.frames["DragonRoar"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["DragonRoar"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["DragonRoar"]:Show()
  updateActiveDragonRoar = true
  DRTime = GetTime() + SlamAndAwe.db.char.DRLen
  DRMin, DRMax = self.frames["DragonRoar"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["DragonRoar"].icon:Show()
  else
    self.frames["DragonRoar"].icon:Hide()
  end
end
--------------------------------------------------------------------
--Protection Bars
--------------------------------------------------------------------

function SlamAndAwe:IgnorePainBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["IgnorePain"])
  local colors = SlamAndAwe.db.char.colors.ignorepain
  self.frames["IgnorePain"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  self.frames["IgnorePain"].text2:SetTextColor(1, 1, 1, 1)
  self.frames["IgnorePain"]:Show()
  updateActiveIgnorePain = true
  IPTime = GetTime() + SlamAndAwe.db.char.IPLen
  IPMin, IPMax = self.frames["IgnorePain"].statusbar:GetMinMaxValues()

  if SlamAndAwe.db.char.showicons then
    self.frames["IgnorePain"].icon:Show()
  else
    self.frames["IgnorePain"].icon:Hide()
  end
end

function SlamAndAwe:UpdateIgnorePainText(Active)
  if SlamAndAwe.db.char.currentspec == "Protection" then
    if Active then
      self.frames["IgnorePain"].text:SetText(IP_Current)
      self.frames["IgnorePain"].text:SetPoint("LEFT",self.frames["IgnorePain"].statusbar,"LEFT",20,-1)
      IPLast = IP_Current
    else
      self.frames["IgnorePain"].text:SetText("0")
      self.frames["IgnorePain"].text:SetPoint("LEFT",self.frames["IgnorePain"].statusbar,"LEFT",20,-1)
      self.frames["IgnorePain"].statusbar:SetValue("0")
      self.frames["IgnorePain"].spark:SetPoint("CENTER",self.frames["IgnorePain"].statusbar,"LEFT", 0 ,-1)
    end
  end
end

function SlamAndAwe:UpdateEstimatedIgnorePainText(Value)
  -- if not IP_Current or IP_Current <= Value then
  -- self.frames["IgnorePain"].text2:SetTextColor(0, 1, 0, 1)
  --else
  --self.frames["IgnorePain"].text2:SetTextColor(1, 1, 1, 1)
  --end
  --self.frames["IgnorePain"].text2:SetText(Value)
  --self.frames["IgnorePain"].text2:SetPoint("CENTER",self.frames["IgnorePain"].statusbar,"RIGHT",-40,-1)

end

function SlamAndAwe:ShieldBlockBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["ShieldBlock"])
  local colors = SlamAndAwe.db.char.colors.shieldblock
  self.frames["ShieldBlock"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["ShieldBlock"].text2:SetTextColor(1, 1, 1, 1)
  end

  if SBlTime > GetTime() then -- sheild block is already up, need to append the current duration with new duration
    SBlTime = SBlTime + 6
    SBlMax = SBlTime - GetTime()
    SBlMin = 0
    self.frames["ShieldBlock"].statusbar:SetMinMaxValues(0,SBlMax)
  else
    self.frames["ShieldBlock"].statusbar:SetMinMaxValues(0,SlamAndAwe.db.char.SBlLen)
    SBlTime = GetTime() + SlamAndAwe.db.char.SBlLen
    SBlMin, SBlMax = self.frames["ShieldBlock"].statusbar:GetMinMaxValues()
  end
  self.frames["ShieldBlock"]:Show()
  updateActiveShieldBlock = true
  if SlamAndAwe.db.char.showicons then
    self.frames["ShieldBlock"].icon:Show()
  else
    self.frames["ShieldBlock"].icon:Hide()
  end
end

function SlamAndAwe:ShieldWallBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["ShieldWall"])
  local colors = SlamAndAwe.db.char.colors.shieldwall
  self.frames["ShieldWall"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["ShieldWall"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["ShieldWall"]:Show()
  updateActiveShieldWall = true
  SWTime = GetTime() + SlamAndAwe.db.char.SWLen
  SWMin, SWMax = self.frames["ShieldWall"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["ShieldWall"].icon:Show()
  else
    self.frames["ShieldWall"].icon:Hide()
  end
end

function SlamAndAwe:DemoShoutBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["DemoShout"])
  local colors = SlamAndAwe.db.char.colors.demoshout
  self.frames["DemoShout"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["DemoShout"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["DemoShout"]:Show()
  updateActiveDemoShout = true
  DemoShoutTime = GetTime() + SlamAndAwe.db.char.DSLen
  DemoShoutMin, DemoShoutMax = self.frames["DemoShout"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["DemoShout"].icon:Show()
  else
    self.frames["DemoShout"].icon:Hide()
  end
end

function SlamAndAwe:LastStandBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["LastStand"])
  local colors = SlamAndAwe.db.char.colors.laststand
  self.frames["LastStand"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["LastStand"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["LastStand"]:Show()
  updateActiveLastStand = true
  LastStandTime = GetTime() + SlamAndAwe.db.char.LSLen
  LastStandMin, LastStandMax = self.frames["LastStand"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["LastStand"].icon:Show()
  else
    self.frames["LastStand"].icon:Hide()
  end
end

function SlamAndAwe:CommandingShoutBar()
  SlamAndAwe:barInsert(SlamAndAwe.frames["CommandingShout"])
  local colors = SlamAndAwe.db.char.colors.commandingshout
  self.frames["CommandingShout"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
  if SlamAndAwe.db.char.enableTimeRemaining then
    self.frames["CommandingShout"].text2:SetTextColor(1, 1, 1, 1)
  end
  self.frames["CommandingShout"]:Show()
  updateActiveCommandingShout = true
  CommandingShoutTime = GetTime() + SlamAndAwe.db.char.CSHLen
  CommandingShoutMin, CommandingShoutMax = self.frames["CommandingShout"].statusbar:GetMinMaxValues()
  if SlamAndAwe.db.char.showicons then
    self.frames["CommandingShout"].icon:Show()
  else
    self.frames["CommandingShout"].icon:Hide()
  end
end
--------------------------------------------------------------------
--------------------------------------------------------------------

function SlamAndAwe:DebugDebuffInfo()
  local index = 1
  while UnitDebuff("target", index) do
    local name, _, _, count, _, _, debuffExpires, unitCaster = UnitDebuff("target", index)
    local isMine = unitCaster == "player"
    local expires = debuffExpires-GetTime()
    if isMine then
      self:DebugPrint("Debuff :"..name.." expires:"..expires)
    end
    index = index + 1
  end
end

function SlamAndAwe:DebugBuffInfo()
  local index = 1
  while UnitBuff("player", index) do
    local name, _, _, count, _, _, buffExpires = UnitBuff("player", index)
    local duration = buffExpires - GetTime()
    self:DebugPrint("Buff :"..name.." expires:"..buffExpires.." duration:"..duration.." count:"..count)
    index = index + 1
  end
end

function SlamAndAwe:DurationString(duration)
  local string = (("%1.1f"):format(duration % 60)) .. "s";
  if (duration >= 60) then
    duration = floor(duration - (duration % 60)) / 60; -- minutes
    string = (duration % 60) .."m " .. string;
    if (duration >= 60) then
      duration = (duration - (duration % 60)) / 60; -- hours
      string = duration .. "h " .. string;
    end
  end
  return string
end

function SlamAndAwe:CheckPurgeableBuff()
  -- if SlamAndAwe.db.char.hsshow then
  -- local avail = SlamAndAwe:SpellAvailable(SlamAndAwe.constants["Heroic Strike"])
  -- local usable, nomana = IsUsableSpell(SlamAndAwe.constants["Heroic Strike"])
  -- local buff1 = SlamAndAwe:GetBuffInfo(SlamAndAwe.constants["Battle Trance"])
  -- local buff2 = SlamAndAwe:GetBuffInfo(SlamAndAwe.constants["Incite"])
  --local rage = UnitPower("player", "rage")
  -- local hsrage = SlamAndAwe.db.char.rageThreshold
  --
  -- if buff1 or buff2 then
  -- if usable and avail then
  -- return true
  -- end
  -- elseif rage >= hsrage then
  -- if usable and avail then
  -- return true
  -- end
  -- end
  -- end
  -- return false
end

local OBU = {}

function SlamAndAwe:OnRageBarUpdate()

  if updateActiveRage then
    if SlamAndAwe.db.char.disabled then
      return
    end

    OBU.ragewidth = SlamAndAwe.db.char.ragebar.fWidth - 6
    local crage = UnitPower("player", "rage")
    if SlamAndAwe.db.char.currentspec == "Protection" then
      local colors = SlamAndAwe.db.char.colors.rage
      local sixtycolors = SlamAndAwe.db.char.colors.sixtyrage
      --(colors.r, colors.g, colors.b, colors.a)
      if crage >= 60 then
        self.frames["Rage"].statusbar:SetStatusBarColor(sixtycolors.r, sixtycolors.g, sixtycolors.b, sixtycolors.a)
      else
        self.frames["Rage"].statusbar:SetStatusBarColor(colors.r, colors.g, colors.b, colors.a)
      end
    end
    self.frames["Rage"].statusbar:SetValue(crage)
    self.frames["Rage"].spark:SetPoint("CENTER",self.frames["Rage"].statusbar,"LEFT", crage / SlamAndAwe.db.char.ragecap * OBU.ragewidth * SlamAndAwe.db.char.RAGEPercent ,-1)
    self.frames["Rage"].text:SetText(UnitPower('player'))
    self.frames["Rage"].text:SetPoint("LEFT",self.frames["Rage"].statusbar,"LEFT",20,-1) --font indent
  end
end

function SlamAndAwe:OnBarUpdate()
  if SlamAndAwe.db.char.disabled then
    return
  end

  OBU.width = SlamAndAwe.db.char.fWidth - 6
  OBU.timeLeft = 0

  if updateActiveGCD then
    OBU.timeLeft = GCDTime - GetTime()
    self.frames["GCD"].statusbar:SetValue(OBU.timeLeft)
    OBU.sparkpoint = OBU.timeLeft / 1.5 * self.GCDWidth
    if OBU.sparkpoint > self.GCDWidth then
      OBU.sparkpoint = self.GCDWidth
    end
    self.frames["GCD"].spark:SetPoint("CENTER",self.frames["GCD"].statusbar,"LEFT", OBU.sparkpoint,-1)
    if GCDTime < GetTime() then
      self.frames["GCD"]:Hide()
      updateActiveGCD = false
    end
  end

  if updateActiveTasteForBlood then
    SlamAndAwe.db.char.tfbstacks, OBU.tfbTime = self:GetTasteForBloodInfo()
    OBU.timeLeft = OBU.tfbTime - GetTime()

    if SlamAndAwe.db.char.tfbstacks ~= 5 then
      tfb4played = false
    end
    if SlamAndAwe.db.char.tfbstacks == 6 and InCombatLockdown() then
      if SlamAndAwe.db.char.tfb5soundplay then
        if SlamAndAwe.db.char.tfb5sound and lastSound < GetTime() - SlamAndAwe.db.char.tfb5repeat then
          PlaySoundFile(SlamAndAwe.db.char.tfb5sound)
          lastSound = GetTime()
        end
      end
    else
      if SlamAndAwe.db.char.tfbstacks == 5 and SlamAndAwe.db.char.tfb4soundplay and not tfb4played and InCombatLockdown() then
        PlaySoundFile(SlamAndAwe.db.char.tfb4sound)
        tfb4played = true
      end
    end
    if SlamAndAwe.db.char.tfbshow then
      if SlamAndAwe.db.char.tfbstacks == 6 and InCombatLockdown() then
        self:SetTasteForBloodAlpha(SlamAndAwe.db.char.colors.tfbalphaFull)
        if SlamAndAwe.db.char.tfb5flash then
          UIFrameFlash(self.frames["TasteForBlood"], 0.25, 0.25, 30, true, 0.25, 0.25)
          if SlamAndAwe.db.char.showicons then
            UIFrameFlash(self.frames["TasteForBlood"].icon, 0.25, 0.25, 30, true, 0.25, 0.25)
          end
          tfbflashing = true
        end
      else
        if tfbflashing then
          tfbflashing = false
        end
        UIFrameFlashStop(self.frames["TasteForBlood"])
        self:SetTasteForBloodAlpha(SlamAndAwe.db.char.colors.tfbalpha)

        if SlamAndAwe.db.char.showicons then
          UIFrameFlashStop(self.frames["TasteForBlood"].icon)
        end
      end

      self.frames["TasteForBlood"].statusbar:SetValue(OBU.timeLeft)
      self.frames["TasteForBlood"].spark:SetPoint("CENTER",self.frames["TasteForBlood"].statusbar,"LEFT", OBU.timeLeft/tfbMax * OBU.width * SlamAndAwe.db.char.TFBPercent,-1)
      if OBU.tfbTime < GetTime() or SlamAndAwe.db.char.tfbstacks == 0 then
        self.frames["TasteForBlood"]:Hide()
        self.frames["TasteForBlood"].icon:Hide()
        SlamAndAwe:barRemove(SlamAndAwe.frames["TasteForBlood"])
      else
        SlamAndAwe:barInsert(SlamAndAwe.frames["TasteForBlood"])
        self.frames["TasteForBlood"]:Show()
        if SlamAndAwe.db.char.showicons then
          self.frames["TasteForBlood"].icon:Show()
        end
      end
    else
      self.frames["TasteForBlood"]:Hide()
      self.frames["TasteForBlood"].icon:Hide()
      SlamAndAwe:barRemove(SlamAndAwe.frames["TasteForBlood"])
    end
    if OBU.tfbTime < GetTime() or not InCombatLockdown() then
      self.frames["TasteForBlood"]:Hide()
      self.frames["TasteForBlood"].icon:Hide()
      SlamAndAwe:barRemove(SlamAndAwe.frames["TasteForBlood"])
      if tfbflashing then
        UIFrameFlashStop(self.frames["TasteForBlood"])
        if SlamAndAwe.db.char.showicons then
          UIFrameFlashStop(self.frames["TasteForBlood"].icon)
        end
        self:SetTasteForBloodAlpha(SlamAndAwe.db.char.colors.tfbalpha)
        tfbflashing = false
      end
      updateActiveTasteForBlood = false
    end
  end

  if updateActiveFocusedRage then
    SlamAndAwe.db.char.frstacks, OBU.frTime = self:GetFocusedRageInfo()
    OBU.timeLeft = OBU.frTime - GetTime()

    if SlamAndAwe.db.char.frshow then
      if SlamAndAwe.db.char.frstacks == 3 and InCombatLockdown() then
        if SlamAndAwe.db.char.fr3soundplay then
          if SlamAndAwe.db.char.fr3sound and lastSound < GetTime() - SlamAndAwe.db.char.fr3repeat then
            PlaySoundFile(SlamAndAwe.db.char.fr3sound)
            lastSound = GetTime()
          end
        end

        self:SetFocusedRageAlpha(SlamAndAwe.db.char.colors.fralphaFull)
        if SlamAndAwe.db.char.fr3flash then
          UIFrameFlash(self.frames["FocusedRage"], 0.25, 0.25, 30, true, 0.25, 0.25)
          if SlamAndAwe.db.char.showicons then
            UIFrameFlash(self.frames["FocusedRage"].icon, 0.25, 0.25, 30, true, 0.25, 0.25)
          end
          frflashing = true
        end
      else
        if frflashing then
          frflashing = false
        end
        UIFrameFlashStop(self.frames["FocusedRage"])
        self:SetFocusedRageAlpha(SlamAndAwe.db.char.colors.fralpha)

        if SlamAndAwe.db.char.showicons then
          UIFrameFlashStop(self.frames["FocusedRage"].icon)
        end
      end

      self.frames["FocusedRage"].statusbar:SetValue(OBU.timeLeft)
      self.frames["FocusedRage"].spark:SetPoint("CENTER",self.frames["FocusedRage"].statusbar,"LEFT", OBU.timeLeft/frMax * OBU.width * SlamAndAwe.db.char.FRPercent,-1)
      if OBU.frTime < GetTime() or SlamAndAwe.db.char.frstacks == 0 then
        self.frames["FocusedRage"]:Hide()
        self.frames["FocusedRage"].icon:Hide()
        SlamAndAwe:barRemove(SlamAndAwe.frames["FocusedRage"])
      else
        SlamAndAwe:barInsert(SlamAndAwe.frames["FocusedRage"])
        self.frames["FocusedRage"]:Show()
        if SlamAndAwe.db.char.showicons then
          self.frames["FocusedRage"].icon:Show()
        end
      end
    else
      self.frames["FocusedRage"]:Hide()
      self.frames["FocusedRage"].icon:Hide()
      SlamAndAwe:barRemove(SlamAndAwe.frames["FocusedRage"])
    end
    if OBU.frTime < GetTime() or not InCombatLockdown() then
      self.frames["FocusedRage"]:Hide()
      self.frames["FocusedRage"].icon:Hide()
      SlamAndAwe:barRemove(SlamAndAwe.frames["FocusedRage"])
      if frflashing then
        UIFrameFlashStop(self.frames["FocusedRage"])
        if SlamAndAwe.db.char.showicons then
          UIFrameFlashStop(self.frames["FocusedRage"].icon)
        end
        self:SetFocusedRageAlpha(SlamAndAwe.db.char.colors.fralpha)
        frflashing = false
      end
      updateActiveFocusedRage = false
    end
  end

  if updateActiveColossusSmash then
    OBU.timeLeft = CSTime - GetTime()
    self.frames["ColossusSmash"].statusbar:SetValue(OBU.timeLeft)
    self.frames["ColossusSmash"].spark:SetPoint("CENTER",self.frames["ColossusSmash"].statusbar,"LEFT", OBU.timeLeft/CSMax * OBU.width * SlamAndAwe.db.char.CSPercent ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["ColossusSmash"].text:SetText(round(CSTime - GetTime(),0))
      self.frames["ColossusSmash"].text:SetPoint("LEFT",self.frames["ColossusSmash"].statusbar,"LEFT",20,-1)
    end
    if CSTime < GetTime() then
      self.frames["ColossusSmash"]:Hide()
      self.frames["ColossusSmash"].icon:Hide()
      updateActiveColossusSmash = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["ColossusSmash"])
    end
  end

  if updateActiveBloodbath then
    OBU.timeLeft = BBTime - GetTime()
    self.frames["Bloodbath"].statusbar:SetValue(OBU.timeLeft)
    self.frames["Bloodbath"].spark:SetPoint("CENTER",self.frames["Bloodbath"].statusbar,"LEFT", OBU.timeLeft/BBMax * OBU.width * SlamAndAwe.db.char.BBPercent ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["Bloodbath"].text:SetText(round(RETime - GetTime(),0))
      self.frames["Bloodbath"].text:SetPoint("LEFT",self.frames["Bloodbath"].statusbar,"LEFT",20,-1)
    end
    if BBTime < GetTime() then
      self.frames["Bloodbath"]:Hide()
      self.frames["Bloodbath"].icon:Hide()
      updateActiveBloodbath = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["Bloodbath"])
    end
  end

  if updateActiveBattleCry then
    OBU.timeLeft = BCTime - GetTime()
    self.frames["BattleCry"].statusbar:SetValue(OBU.timeLeft)
    self.frames["BattleCry"].spark:SetPoint("CENTER",self.frames["BattleCry"].statusbar,"LEFT", OBU.timeLeft/BCMax * OBU.width * SlamAndAwe.db.char.BCPercent ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["BattleCry"].text:SetText(round(BCTime - GetTime(),0))
      self.frames["BattleCry"].text:SetPoint("LEFT",self.frames["BattleCry"].statusbar,"LEFT",20,-1)
    end
    if BCTime < GetTime() then
      self.frames["BattleCry"]:Hide()
      self.frames["BattleCry"].icon:Hide()
      updateActiveBattleCry = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["BattleCry"])
    end
  end

  if updateActiveAvatar then
    OBU.timeLeft = AVATime - GetTime()
    self.frames["Avatar"].statusbar:SetValue(OBU.timeLeft)
    self.frames["Avatar"].spark:SetPoint("CENTER",self.frames["Avatar"].statusbar,"LEFT", OBU.timeLeft/AVAMax * OBU.width * SlamAndAwe.db.char.AVAPercent ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["Avatar"].text:SetText(round(AVATime - GetTime(),0))
      self.frames["Avatar"].text:SetPoint("LEFT",self.frames["Avatar"].statusbar,"LEFT",20,-1)
    end
    if AVATime < GetTime() then
      self.frames["Avatar"]:Hide()
      self.frames["Avatar"].icon:Hide()
      updateActiveAvatar = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["Avatar"])
    end
  end

  if updateActiveDragonRoar then
    OBU.timeLeft = DRTime - GetTime()
    self.frames["DragonRoar"].statusbar:SetValue(OBU.timeLeft)
    self.frames["DragonRoar"].spark:SetPoint("CENTER",self.frames["DragonRoar"].statusbar,"LEFT", OBU.timeLeft/DRMax * OBU.width * SlamAndAwe.db.char.DRPercent ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["DragonRoar"].text:SetText(round(DRTime - GetTime(),0))
      self.frames["DragonRoar"].text:SetPoint("LEFT",self.frames["DragonRoar"].statusbar,"LEFT",20,-1)
    end
    if DRTime < GetTime() then
      self.frames["DragonRoar"]:Hide()
      self.frames["DragonRoar"].icon:Hide()
      updateActiveDragonRoar = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["DragonRoar"])
    end
  end

  -----------------------------------------------------------------------------
  --Protection
  -----------------------------------------------------------------------------

  if updateActiveIgnorePain then
    if not IP_Current then
      -- self.frames["IgnorePain"]:Hide()
      -- self.frames["IgnorePain"].icon:Hide()
      updateActiveIgnorePain = false
      IPActive = false
      IPLast = 0
      self:UpdateIgnorePainText(false)
    else
      OBU.timeLeft = IPTime - GetTime()
      self.frames["IgnorePain"].statusbar:SetValue(OBU.timeLeft)
      self.frames["IgnorePain"].spark:SetPoint("CENTER",self.frames["IgnorePain"].statusbar,"LEFT", OBU.timeLeft/IPMax * OBU.width * SlamAndAwe.db.char.IPPercent ,-1)
      self.frames["IgnorePain"].text:SetText(IP_Current)
      self.frames["IgnorePain"].text:SetPoint("LEFT",self.frames["IgnorePain"].statusbar,"LEFT",20,-1)

      IPActive = true
      IPLast = IP_Current
      if IPTime < GetTime() then
        -- self.frames["IgnorePain"]:Hide()
        -- self.frames["IgnorePain"].icon:Hide()
        updateActiveIgnorePain = false --this was updateActiveShieldBlock.. typo maybe?
        SlamAndAwe:barRemove(SlamAndAwe.frames["IgnorePain"])
        IPActive = false
        IPLast = 0
        self:UpdateIgnorePainText(false)
      end
    end
  end

  if updateActiveShieldBlock then
    OBU.timeLeft = SBlTime - GetTime()
    self.frames["ShieldBlock"].statusbar:SetValue(OBU.timeLeft)
    self.frames["ShieldBlock"].spark:SetPoint("CENTER",self.frames["ShieldBlock"].statusbar,"LEFT", OBU.timeLeft/SBlMax * OBU.width * SlamAndAwe.db.char.SBlPercent ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["ShieldBlock"].text:SetText(round(SBlTime - GetTime(),0))
      self.frames["ShieldBlock"].text:SetPoint("LEFT",self.frames["ShieldBlock"].statusbar,"LEFT",20,-1)
    end
    if SBlTime < GetTime() then
      self.frames["ShieldBlock"]:Hide()
      self.frames["ShieldBlock"].icon:Hide()
      updateActiveShieldBlock = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["ShieldBlock"])
    end
  end

  if updateActiveShieldWall then
    OBU.timeLeft = SWTime - GetTime()
    self.frames["ShieldWall"].statusbar:SetValue(OBU.timeLeft)
    self.frames["ShieldWall"].spark:SetPoint("CENTER",self.frames["ShieldWall"].statusbar,"LEFT", OBU.timeLeft/SWMax * OBU.width * SlamAndAwe.db.char.SWPercent ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["ShieldWall"].text:SetText(round(SWTime - GetTime(),0))
      self.frames["ShieldWall"].text:SetPoint("LEFT",self.frames["ShieldWall"].statusbar,"LEFT",20,-1)
    end
    if SWTime < GetTime() then
      self.frames["ShieldWall"]:Hide()
      self.frames["ShieldWall"].icon:Hide()
      updateActiveShieldWall = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["ShieldWall"])
    end
  end

  if updateActiveDemoShout then
    OBU.timeLeft = DemoShoutTime - GetTime()
    self.frames["DemoShout"].statusbar:SetValue(OBU.timeLeft)
    self.frames["DemoShout"].spark:SetPoint("CENTER",self.frames["DemoShout"].statusbar,"LEFT", OBU.timeLeft/DemoShoutMax * OBU.width ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["DemoShout"].text:SetText(round(DemoShoutTime - GetTime(),0))
      self.frames["DemoShout"].text:SetPoint("LEFT",self.frames["DemoShout"].statusbar,"LEFT",20,-1)
    end
    if DemoShoutTime < GetTime() then
      self.frames["DemoShout"]:Hide()
      self.frames["DemoShout"].icon:Hide()
      updateActiveDemoShout = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["DemoShout"])
    end
  end

  if updateActiveLastStand then
    OBU.timeLeft = LastStandTime - GetTime()
    self.frames["LastStand"].statusbar:SetValue(OBU.timeLeft)
    self.frames["LastStand"].spark:SetPoint("CENTER",self.frames["LastStand"].statusbar,"LEFT", OBU.timeLeft/LastStandMax * OBU.width ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["LastStand"].text:SetText(round(LastStandTime - GetTime(),0))
      self.frames["LastStand"].text:SetPoint("LEFT",self.frames["LastStand"].statusbar,"LEFT",20,-1)
    end
    if LastStandTime < GetTime() then
      self.frames["LastStand"]:Hide()
      self.frames["LastStand"].icon:Hide()
      updateActiveLastStand = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["LastStand"])
    end
  end

  if updateActiveCommandingShout then
    OBU.timeLeft = CommandingShoutTime - GetTime()
    self.frames["CommandingShout"].statusbar:SetValue(OBU.timeLeft)
    self.frames["CommandingShout"].spark:SetPoint("CENTER",self.frames["CommandingShout"].statusbar,"LEFT", OBU.timeLeft/CommandingShoutMax * OBU.width ,-1)
    if SlamAndAwe.db.char.enableTimeRemaining then
      self.frames["CommandingShout"].text:SetText(round(CommandingShoutTime - GetTime(),0))
      self.frames["CommandingShout"].text:SetPoint("LEFT",self.frames["CommandingShout"].statusbar,"LEFT",20,-1)
    end
    if CommandingShoutTime < GetTime() then
      self.frames["CommandingShout"]:Hide()
      self.frames["CommandingShout"].icon:Hide()
      updateActiveCommandingShout = false
      SlamAndAwe:barRemove(SlamAndAwe.frames["CommandingShout"])
    end
  end

  --Announcements

  if updateActiveBanner then
    -- if BannerTime < GetTime() then
    -- SlamAndAwe:Announce( last_banner_where , last_banner_msg)
    -- updateActiveBanner = false
    -- end
  end

  -----------------------------------------------------------------------------
  --
  -----------------------------------------------------------------------------

end

function SlamAndAwe:CreateMsgFrame()
  self.msgFrame:ClearAllPoints()
  self.msgFrame:SetWidth(400)
  self.msgFrame:SetHeight(75)

  self.msgFrame:SetBackdrop({
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 2, right = 2, top = 2, bottom = 2 }
    })
  self.msgFrame:SetBackdropColor(1, 1, 1, 0)
  self.msgFrame:SetMovable(true)
  self.msgFrame:RegisterForDrag("LeftButton")
  self.msgFrame:SetScript("OnDragStart",
    function()
      self.msgFrame:StartMoving();
    end );
  self.msgFrame:SetScript("OnDragStop",
    function()
      self.msgFrame:StopMovingOrSizing();
      self.msgFrame:SetScript("OnUpdate", nil);
      self:FinishedMoving(SlamAndAwe.db.char.warning, self.msgFrame);
    end );
  self.msgFrame:SetPoint(SlamAndAwe.db.char.warning.point, SlamAndAwe.db.char.warning.relativeTo, SlamAndAwe.db.char.warning.relativePoint, SlamAndAwe.db.char.warning.xOffset, SlamAndAwe.db.char.warning.yOffset)
  self.msgFrame:SetInsertMode("TOP")
  self.msgFrame:SetFrameStrata(SlamAndAwe.db.char.framestratalevel)
  self.msgFrame:SetToplevel(true)
  local font = media:Fetch("font", SlamAndAwe.db.char.msgfont)
  self.msgFrame:SetFont(font, SlamAndAwe.db.char.msgfontsize, SlamAndAwe.db.char.msgfonteffect)

  self.msgFrame:Show()
end

function SlamAndAwe:PrintMsg(msg, col, time)
  if SlamAndAwe.db.char.warning.show and not SlamAndAwe.db.char.disabled then
    if msg == nil then
      msg = "Out Of Range"
    end
    if col == nil then
      col = { r=1, b=1, g=1, a=1 }
    end
    if time == nil then
      time = 3
    end
    if time ~= 5 then
      self.msgFrame:SetTimeVisible(time)
    end
    self.msgFrame:AddMessage(msg, col.r, col.g, col.b, 1, col.time)
  end
end

function SlamAndAwe:DebugPrint(msg)
  if SlamAndAwe.db.char.debug then
    self:Print(msg)
  end
end

function round(number, decimals)
  return (("%%.%df"):format(decimals)):format(number)
end

function SlamAndAwe:ResetToDefault()
  SlamAndAwe.db:ResetDB("SlamAndAwe.defaults")
  SlamAndAwe.db:RegisterDefaults(SlamAndAwe.defaults)

  if not SlamAndAwe.db.char.immuneTargets then
    SlamAndAwe.db.char.immuneTargets = {}
  end

  SlamAndAwe:SetSpecialization()
  SlamAndAwe:SetTalentEffects()
  SlamAndAwe:QuerySpecChanged()
  SlamAndAwe:RedrawFrames()
  SlamAndAwe:RageBar()

  if SlamAndAwe.db.char.currentspec == "Fury" then
    SlamAndAwe:SelectPrioritySet(1)
  elseif SlamAndAwe.db.char.currentspec == "Protection" then
    SlamAndAwe:SelectPrioritySet(2)
  elseif SlamAndAwe.db.char.currentspec == "Arms" then
    SlamAndAwe:SelectPrioritySet(3)
  else
    SlamAndAwe:SelectPrioritySet(1)
  end

  self:Print(string.format(L["Settings have been reset to their default values."]))
end
